"use strict";

var _set = function set(object, property, value, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent !== null) { set(parent, property, value, receiver); } } else if ("value" in desc && desc.writable) { desc.value = value; } else { var setter = desc.set; if (setter !== undefined) { setter.call(receiver, value); } } return value; };

var _AdharaListView$DEFAU;

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(range);

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @typedef {Object} ElementAttributes
 * @description attributes that can be set in a element using `addAttr` helper for Handlebar files.
 * */

var TemplateEngineHelpers = function () {
    function TemplateEngineHelpers() {
        _classCallCheck(this, TemplateEngineHelpers);
    }

    _createClass(TemplateEngineHelpers, null, [{
        key: "getHelpers",


        /**
         * @namespace
         * @description
         * Helpers written for handlebars. Can also be used by static references.
         * */
        value: function getHelpers(currentHelpers) {
            var if_helper = currentHelpers.if;
            return {
                /**
                 * @function
                 * @static
                 * @param {ElementAttributes} attributes - html element attributes.
                 * @param {String|Object} default_attributes - html element default attributes.
                 * @description
                 * attributes override default_attributes
                 * create attribute string and return which can be used to append
                 * @example
                 * let options = {
                * 	attributes : { id : 'element-id', className : 'css-class' }
                * }
                 * TemplateUtils.execute(
                 * 	'<a {{addAttr attributes "{"href":"javascript:void(0)", "route":"true"}"}}></a>',
                 * 	options
                 * )
                 * //returns <a href="javascript:void(0)" route:"true" id="element-id" class:"css-class></a>
                 * */
                'addAttr': function addAttr(attributes, default_attributes) {
                    if (attributes || default_attributes) {
                        var attrData = [];
                        default_attributes = default_attributes && typeof default_attributes === "string" ? JSON.parse(default_attributes) : {};
                        var class_names = attributes ? attributes.className || attributes["class"] || "" : "";
                        class_names += default_attributes.hasOwnProperty("class") ? " " + default_attributes['class'] : "";
                        attributes = Object.assign(default_attributes, attributes);
                        attributes['class'] = class_names;
                        loop(attributes, function (key, value) {
                            if (key && value !== undefined) {
                                if (key === "style") {
                                    var css_values = [];
                                    loop(value, function (css_prop, css_value) {
                                        css_values.push(css_prop + ":" + css_value + ";");
                                    });
                                    value = css_values.join('');
                                }
                                if (typeof value === "string") {
                                    value = '"' + value.replace(/"/g, '\\"') + '"';
                                }
                                attrData.push(key + '=' + value);
                            }
                        });
                        return new window.Handlebars.SafeString(attrData.join(' '));
                    }
                },
                'addProps': function addProps() {
                    var properties = Array.prototype.slice.call(arguments);
                    return properties.splice(0, properties.length - 1).join(' ');
                },
                'selectedClass': function selectedClass(selected, selectedClassName) {
                    if (selected === true) {
                        return selectedClassName;
                    } else {
                        return '';
                    }
                },
                /**
                 * @function
                 * @static
                 * @param {String} template_name - precompiled handlebar template name.
                 * @param {Object} context - context with which the `template_name` hbs template to be called
                 * @return {String} `template_name` handlebar template contents after execution with provided context.
                 * @description
                 * includes one hbs template in another.
                 * @example
                 * //child HBS file - child-template.hbs
                 * `<div id="child">
                 *     {{name}}
                 * </div>`
                 *
                 * // main HBS file - main-template.hbs
                 * `<div id="main">
                 *     {{name}}
                 *     {{include 'child-template' child_context}}
                 * </div>`
                 *
                 * Handlebars.templates['main-template']({name:"MAIN", child_context:{name:"CHILD"}})
                 * // returns
                 * //<div id="main">
                 * //    MAIN
                 * //    <div id="child">
                 * //    	CHILD
                 * //	 </div>
                 * //</div>
                 * */
                'include': function include(template_name, context) {
                    return new window.Handlebars.SafeString(TemplateUtils.execute(template_name, context));
                },
                /**
                 * @function
                 * @static
                 * @param {Number} param1 - left operand / lvalue
                 * @param {String} operation - can be one among "+", "-", "*", "/" and "%"
                 * @param {Number} param2 - right operand / rvalue
                 * @returns {Number} - result after operation between param1 and param2 with operation
                 * */
                'math': function math(param1, operation, param2) {
                    var lvalue = parseFloat(String(param1));
                    var rvalue = parseFloat(String(param2));
                    return {
                        "+": lvalue + rvalue,
                        "-": lvalue - rvalue,
                        "*": lvalue * rvalue,
                        "/": lvalue / rvalue,
                        "%": lvalue % rvalue
                    }[operation];
                },
                /**
                 * @function
                 * @static
                 * @param {String} i18nKey - application key that needs to be internationalized.
                 * @returns {String} internationalized application key's value
                 * @example
                 * // app.key.name = "APP Key"
                 * {{i18N 'app.key.name'}}	//returns "APP Key"
                 *
                 * // app.key.operation = "App Operation {0} by {1}"
                 * {{i18N 'app.key.operation' 'operationName' 'operatedBy'}}	//returns "App Operation operationName by operatedBy"
                 * */
                'i18n': function i18n(i18nKey) {
                    //~ (i18nKey, ...subs)
                    var subs = Array.prototype.slice.call(arguments);
                    subs = subs.splice(1, subs.length - 2);
                    return Adhara.i18n.get(i18nKey, subs);
                },
                /**
                 * @function
                 * @static
                 * @param {Object} object - object in which to lookup.
                 * @param {String} path - dot separated keys to be looked up for in depth.
                 * @description
                 * Wrapper for {@link getValueFromJSON}
                 * @returns {String|Number|Boolean|Object|Array} - Value for the key.
                 * */
                'get': function get(object, path) {
                    return getValueFromJSON(object, path);
                },
                /**
                 * @function
                 * @static
                 * @description
                 * Wrapper for {@link evaluateLogic}
                 * @returns
                 * handlebar block based on logic.
                 * */
                'if': function _if(param1, operator, param2, options) {
                    if ((typeof operator === "undefined" ? "undefined" : _typeof(operator)) === "object") {
                        return if_helper.call(this, param1, operator);
                    }
                    if (evaluateLogic(param1, operator, param2)) {
                        return options.fn(this);
                    } else {
                        return options.inverse(this);
                    }
                },
                /**
                 * @function
                 * @static
                 * @description
                 * If condition with multiple equations to evaluate.
                 * Takes numerous arguments which will be executed in pairs.
                 * @returns
                 * handlebar block based on logic.
                 * */
                'mIf': function mIf() {
                    var arr = [true, 'and', true];
                    var args_len = arguments.length - 1;
                    var options = arguments[args_len];
                    for (var i = 0; i < args_len; i++) {
                        if (i === 0) {
                            arr[0] = arguments[i];
                        } else if (i % 2 === 1) {
                            arr[1] = arguments[i];
                        } else {
                            arr[2] = arguments[i];
                            arr[0] = evaluateLogic(arr[0], arr[1], arr[2]);
                        }
                    }
                    if (arr[0]) {
                        return options.fn(this);
                    } else {
                        return options.inverse(this);
                    }
                },
                /**
                 * @function
                 * @static
                 * @description
                 * If condition with multiple equations to evaluate.
                 * Takes numerous arguments which will be executed in pairs.
                 * @returns {Boolean} result of equation created by provided params.
                 * @see evaluateLogic
                 * */
                'eIf': function eIf(param1, operator, param2) {
                    return evaluateLogic(param1, operator, param2);
                },
                /**
                 * @function
                 * @static
                 * @returns {String|Number|Boolean|Object|Array} - Value of the global letiable.
                 * */
                'global': function global(global_letiable) {
                    if (global_letiable.indexOf("Adhara.") === 0) {
                        return getValueFromJSON(Adhara, global_letiable.substring("Adhara.".length));
                    }
                    return getValueFromJSON(window, global_letiable);
                },
                'loop': function loop(looper, options) {
                    var structure = '';
                    for (var i = 0; i < looper.length; i++) {
                        structure += options.fn(looper[i]);
                    }
                    return structure;
                },
                /**
                 * @function
                 * @static
                 * @description Takes numerous {String} arguments and appends all those strings.
                 * @returns {String} arguments joined by ''.
                 * */
                'append': function append() {
                    var args = Array.prototype.slice.call(arguments);
                    args.pop();
                    return args.map(function (arg) {
                        if ((typeof arg === "undefined" ? "undefined" : _typeof(arg)) === "object") {
                            return JSON.stringify(arg);
                        }
                        return arg;
                    }).join('');
                },
                /**
                 * @function
                 * @static
                 * @description Takes a {String} and converts it to JSON object.
                 * @returns {Object}
                 * */
                'make_json': function make_json(str) {
                    return JSON.parse(str);
                },
                /**
                 * @function
                 * @static
                 * @description Takes a {String} and converts it to JSON object.
                 * @returns {Object}
                 * */
                'make_context': function make_context() {
                    var context = {};
                    for (var i = 0; i < arguments.length - 1; i += 2) {
                        context[arguments[i]] = arguments[i + 1];
                    }
                    return context;
                },
                /**
                 * @function
                 * @static
                 * @param {Function} fn
                 * @description Takes numerous and calls the fn with arguments from 2nd position since 1st argument is fn itself.
                 * @returns {String|Number|Boolean|Object|Array} content returned by fn
                 * */
                'fn_call': function fn_call(fn) {
                    return call_fn.apply(this, Array.prototype.slice.call(arguments).slice(0, -1));
                },
                /**
                 * @function
                 * @static
                 * @param {Object} looper
                 * @param {Object} options - Handlebars options that has access to blocks.
                 * @returns {String} Block string.
                 * @description blocks will be called with a context ~ {"key":k, "value":v}
                 * where `k` is key in the looper object and `v` is value corresponding to `k`.
                 * */
                'loopObject': function loopObject(looper, options) {
                    var structure = '';
                    loop(looper, function (key, value) {
                        structure += options.fn({ key: key, value: value });
                    });
                    return structure;
                },
                /**
                 * @function
                 * @static
                 * @param {Number} start
                 * @param {Number} step
                 * @param {Number} end
                 * @param {Object} options - Handlebars options that has access to blocks.
                 * @returns {String} Block string appended n times where n is the number of times step-looped.
                 * @description Block will be called with just a number {Number} as context which keeps increasing in steps, where the step height is equal to step param.
                 * */
                'iterate_range': function iterate_range(start, step, end, options) {
                    var str_buf = '';
                    for (var i = start; i <= end; i += step) {
                        str_buf += options.fn(i);
                    }
                    return str_buf;
                },
                'route': function route(url) {
                    return new Handlebars.SafeString("href=\"" + Adhara.router.transformURL(url) + "\" route");
                }
                /*
                TODO handle better!
                'generate': function(context, options){
                    let generatorInstance = context(),
                        ret = '', done = false, index = 0,
                        data = {};
                     function execIteration(field, index, last) {
                        if (data) {
                            data.key = field;
                            data.index = index;
                            data.first = index === 0;
                            data.last = !!last;
                        }
                         ret = ret + options.fn(context[field], {
                            data: data,
                            // blockParams: _utils.blockParams([context[field], field], [contextPath + field, null])
                        });
                    }
                     do{
                        let yi = generatorInstance.next();
                        done = yi.done;
                        execIteration(yi.value, ++index, done===true);
                    }while(done===false);
                    console.log(context, options);
                    return ret;
                }*/
            };
        }
    }, {
        key: "registerHelpers",
        value: function registerHelpers() {
            window.Handlebars.registerHelper(TemplateEngineHelpers.getHelpers(window.Handlebars.helpers));
        }
    }]);

    return TemplateEngineHelpers;
}();

/**------------------------------------------------------------------------------------------------------------------**/


var TAB = 9;
var ENTER = 13;
var UP_ARROW = 38;
var DOWN_ARROW = 40;
var BACKSPACE = 8;
var ESCAPE = 27;
var SHIFT = 16;
var SPACE = 32;

/**------------------------------------------------------------------------------------------------------------------**/
function handleForm(form) {
    if (form.submitting) {
        return;
    } else {
        form.submitting = true;
    }
    var hasFiles = !!form.querySelector('input[type="file"]');
    var apiData = void 0;
    if (hasFiles) {
        apiData = new FormData(form);
    } else {
        var formData = jQuery(form).serializeArray();
        apiData = {};
        jQuery.each(formData, function (i, fieldData) {
            apiData[fieldData.name] = fieldData.value;
        });
    }
    var format_fn = form.getAttribute('format-data');
    if (format_fn) {
        apiData = call_fn(format_fn, apiData);
    }
    if (apiData === false) {
        return;
    }
    RestAPI[form.getAttribute('api-method')]({
        url: form.action.split(window.location.host)[1],
        data: apiData,
        successMessage: form.getAttribute('success-message'),
        handleError: form.getAttribute('handle-error') !== "false",
        success: function success(data) {
            if (form.getAttribute('form-clear') === "true") {
                form.reset();
            }
            jQuery(form).trigger('success', data);
        },
        failure: function failure(message) {
            jQuery(form).trigger('failure', message);
        }
    });
}

function registerAdharaUtils() {
    //Register templateEngine helpers
    Adhara.templateEngine.helpersHandler.registerHelpers();
    //Form listeners
    jQuery(document).on('submit', 'form.api-form', function (event) {
        event.preventDefault();
        handleForm(this);
    });
    //Form listeners
    jQuery(document).on('success', 'form.dialog-form', function () /*e, d*/{
        this.close.click();
    });
}

/**
 * @function
 * @global
 * @param {String|Number|Boolean} param1
 * @param {String} operator - Operator can be one among these.
 * "in", "not_in", "contains", "not_contains", "has", "||", "&&", "|", "&", "==", "===", "!=", "!==", ">", "<", ">=", "<=", "equals", "and", "or".
 * @param {String|Number|Boolean} param2
 * @Returns {Boolean}
 *
 * "in" - param2 must be an {Array}. Whether param1's existence in that array will be checked for
 *
 * "not_in" - param2 must be an {Array} and param1's non-existence in that array will be checked for
 *
 * "contains" - param1 must be an {Array} and param2's existence in that array will be checked for
 *
 * "not_contains" - param1 must be an {Array} and param2's non-existence in that array will be checked for
 *
 * "has" - param1 must be an {Object}. Whether param2 is a key of param1
 *
 * All other operations will be applied as javaScript evaluates them.
 * `"equals" is equivalent to "=="`,
 * `"and" is equivalent to "&&"`
 * and `"or" is equivalent to "||"`.
 *
 * */
function evaluateLogic(param1, operator, param2) {
    if (operator === "in") {
        return param2 && param2.indexOf(param1) !== -1;
    } else if (operator === "not_in") {
        return param2 && param2.indexOf(param1) === -1;
    } else if (operator === "contains") {
        return param1 && param1.indexOf(param2) !== -1;
    } else if (operator === "not_contains") {
        return param1 && param1.indexOf(param2) === -1;
    } else if (operator === "has") {
        return param1 && param1.hasOwnProperty(param2);
    } else {
        return {
            "||": param1 || param2,
            "&&": param1 && param2,
            "|": param1 | param2,
            "&": param1 & param2,
            "==": param1 == param2,
            "===": param1 === param2,
            "!=": param1 != param2,
            "!==": param1 !== param2,
            ">": param1 > param2,
            "<": param1 < param2,
            ">=": param1 >= param2,
            "<=": param1 <= param2,
            "equals": param1 == param2,
            "and": param1 && param2,
            "or": param1 || param2
        }[operator];
    }
}

/**
 * @function
 * @global
 * @param {Object} object - object in which to lookup.
 * @param {String} path - dot separated keys to be looked up for in depth.
 * @param {String} [identifier=null] - token that helps to lookup inside arrays.
 * @returns {String|Number|Boolean|Object|Array} - Value for the key.
 * @description
 * Looks up a JSON object in depth and returns the value for the key provided.
 * @example
 * let obj = {
 *	task: {
 *		id: "12341234",
 * 		status: {
 * 			color: "#fff"
 * 			}
 *		}
 *	};
 * getValueFromJSON(obj, "task.status.color");	//returns "#fff"
 *
 * let objX = {
 *	tasks: [
 *		{
 *			id: "12341234",
 * 			status: {
 * 				color: "#fff"
 * 				}
 *			},
 *		{
 *			id: "55424",
 * 			status: {
 * 				color: "#f5f5f5"
 * 				}
 *			},
 *		{
 *			id: "90898080",
 * 			status: {
 * 				color: "#eee"
 * 				}
 *			},
 *		]
 *	};
 * getValueFromJSON(objX, "task[1].status.color");	//returns "#f5f5f5"
 * getValueFromJSON(objX, "task[$, ].status.color", "$");	//returns "#fff, #f5f5f5, #eee"
 * // Elaborately,
 * // In `[$, ]`		--split into identifier and separator
 * // '$'=identifier(from params).
 * // Remaining part inside [] is the separator i.e., `', '` will be used to join the results from the array
 * */
function getValueFromJSON(object, path, identifier) {
    try {
        if (!path) {
            return object;
        }
        var keys = path.split('.');
        for (var i = 0; i < keys.length; i++) {
            var key_in = keys[i];
            if (key_in.indexOf('[') !== -1) {
                var arr = key_in.split('[');
                var arrName = arr[0];
                var index = arr[1].split(']')[0];
                if (isNaN(index)) {
                    var rite = object[arrName];
                    var separator = index.substring(identifier.length, index.length);
                    var formattedVal = '';
                    for (var j = 0; j < rite.length; j++) {
                        if (j > 0) {
                            formattedVal += separator;
                        }
                        formattedVal += getValueFromJSON(rite[j], path.split('.').splice(i + 1).join('.'), identifier);
                    }
                    object = formattedVal;
                } else {
                    object = object[arrName][index];
                }
                break;
            } else {
                object = object[key_in];
            }
        }
        return object;
    } catch (e) {
        return undefined;
    }
}

/**
 * @function
 * @global
 * @param {Object} object - object to set value to
 * @param {String} path - dot separated path.
 * @param {String|Number|Boolean|Object|Array} value - value to be set fot the given key
 * @description
 * Sets value to provided object at specified depth in the path be using dot separators.
 * Creates objects at depths if no object already exists at specified path.
 * @example
 * let kit = {'has_bat': true}
 * setValueToJson(kit, 'has_ball', true);	//let kit = {'has_bat': true, 'has_ball': true}
 * setValueToJson(kit, 'has_bat', false);	//let kit = {'has_bat': false, 'has_ball': true}
 *
 * let aeroplane = {'name': 'B747'}
 * setValueToJson(aeroplane, 'tank.capacity', '4000');	//aeroplane = {'name': 'B747', 'tank': { 'capacity': '4000' }}
 * setValueToJson(aeroplane, 'tank.shape', 'amoeba');	//aeroplane = {'name': 'B747', 'tank': { 'capacity': '4000', 'shape': 'amoeba' }}
 * */
function setValueToJson(object, path, value) {
    var keys = path.split('.');
    loop(keys, function (i, key) {
        if (i + 1 < keys.length) {
            if (!object.hasOwnProperty(key) || !object[key] || _typeof(object[key]) !== "object") {
                object[key] = {};
            }
            object = object[key];
        } else {
            object[key] = value;
        }
    });
}

/**
 * @typedef {Object|Array|String|Boolean|Number|null|undefined} _MultiParams - numerous arguments of any kind
 * @description
 * A function if accepts multiple params, can use this as param type.
 * @example
 * //def
 * function mpFn({String} param1, {_MultiParams} m_params){}
 * //call
 * mpFn("Str_param1", "p1", "p2", 1, {'key':'val'}, ['m1', 'm2', ...], ...);
 * //def2
 * function mp2Fn({String} param1, {_MultiParams} m_params, {String} param2){}
 * //call2
 * mp2Fn("Str_param1", "p1", "p2", 1, {'key':'val'}, ['m1', 'm2', ...], ..., "StrX_param2");
 *
 * */
/**
 * @function
 * @global
 * @param {Function|String} fn - function to be called or global path to a function
 * @param {_MultiParams} params - any params that to be passed to function
 * @description
 * calls the function with params passed
 * @example
 * let gv = {}; //global_letiable
 * gv.sample_fn = function(param1, param2, param3){
 * 	//Do Something...
 * 	return "Hello from SampleFN"
 * };
 * call_fn('gv.sample_fn', param1, param2, param3);	//returns "Hello from SampleFN"
 * */
function call_fn(fn) {
    if (!fn) {
        return;
    }
    var args = Array.prototype.slice.call(arguments);
    args.splice(0, 1);
    if (typeof fn === "function") {
        return fn.apply(fn, args);
    } else {
        try {
            fn = getValueFromJSON(window, fn);
            if (fn && fn !== window) {
                return fn.apply(window[fn], args);
            }
        } catch (e) {
            if (e.name === "TypeError" && e.message.indexOf("is not a function") !== -1) {
                throw new Error("error executing function : " + fn);
            } else {
                throw e;
            }
        }
    }
}

/**
 * Can be used if required to call a function, and if it is unavailable, call a default fn
 * Usage : call_fn_or_def(fn, arg1, arg2, arg3, def_fn)
 * Result : fn(arg1, arg2, arg3) if fn is not undefined else def_fn(arg1, arg2, arg3)
 * */

/**
 * @function
 * @global
 * @param {Function|String} fn - function to be called or global path to a function
 * @param {_MultiParams} params - any params that to be passed to function
 * @param {Function|String} fn - function to be called or global path to a function
 * @description
 * calls the function with params passed
 * @example
 * let gv = {}; //global_letiable
 * gv.sample_fn = function(param1, param2, param3){
 * 	//Do Something...
 * 	return "Hello from SampleFN"
 * };
 * call_fn('gv.sample_fn', param1, param2, param3, defaultFunction);	//returns "Hello from SampleFN"
 * */
function call_fn_or_def(fn) {
    var args = Array.prototype.slice.call(arguments);
    var def_fn = args.pop();
    if (!(typeof def_fn === "function" || typeof window[def_fn] === "function")) {
        args.push(def_fn);
        def_fn = undefined;
    }
    if (fn) {
        return call_fn.apply(call_fn, args);
    } else if (def_fn) {
        args[0] = def_fn;
        return call_fn.apply(call_fn, args);
    }
}

/**
 * Loop - looper iterator function
 * @callback LoopIteratorCallback
 * @param {String|Number|RegExp} key - key will be string in case of an object and Number will be an Array while looping through an Array.
 * @param {*} value - Value of iterable for key.
 * @returns {Boolean}
 * return `false` to stop iteration.
 * */
/**
 * @function
 * @global
 * @param {Object|Array} object - Iterable.
 * @param {LoopIteratorCallback} cbk - callback for each value in iterable.
 * @param {Boolean} [reverseIterate=false] - iterate in reverse if it is an array.
 * */
function loop(object, cbk, reverseIterate) {
    var i = void 0,
        loop_size = void 0;
    if (object instanceof Array) {
        loop_size = object.length;
        if (reverseIterate) {
            for (i = loop_size - 1; i >= 0; i--) {
                if (cbk(i, object[i]) === false) {
                    break;
                }
            }
        } else {
            for (i = 0; i < loop_size; i++) {
                if (cbk(i, object[i]) === false) {
                    break;
                }
            }
        }
    } else {
        var keys = Object.keys(object);
        loop_size = keys.length;
        for (i = 0; i < loop_size; i++) {
            if (cbk(keys[i], object[keys[i]]) === false) {
                break;
            }
        }
    }
}

/**
 * @typedef {String} HandlebarTemplate
 * @description handlebar template can be an inline template or a pre compiled template that is created in a HBS file.
 * */

/**
 * @namespace
 * @description
 * TemplateUtils is a set of utilities related to handlebars
 * */
var TemplateUtils = {};
(function () {
    var preCompiledCache = {};

    /**
     * @function
     * @static
     * @param {HandlebarTemplate} template_or_template_string - Handlebar template name or template string.
     * @param {Object} context - content to be passed t provided handlebar template/string.
     * @param {Boolean} [cache=true] - whether to cache if the provided template is a Handlebar string template.
     * @returns {String} compiled adn executed handlebar template
     * @example
     * //using template
     * TemplateUtils.execute('template-file-name', {context_key1: "value1", ...});
     *
     * //using template string
     * TemplateUtils.execute('Hello {{name}}', {name: "Adhara"});	//returns "Hello Adhara"
     * */
    TemplateUtils.execute = function (template_or_template_string, context, cache) {
        //Check if it is a pre compiled hbs template
        var template = window.Handlebars.templates[template_or_template_string];
        if (!template && window.Handlebars.hasOwnProperty("compile")) {
            //If template not found in precompiled hbs list => template is a handlebar string template
            // check if cacheable
            if (cache !== false) {
                //check if the template is already cached.
                template = preCompiledCache[template_or_template_string];
                if (!template) {
                    //else compile, store it in cache and proceed to execution
                    template = preCompiledCache[template_or_template_string] = window.Handlebars.compile(template_or_template_string);
                }
            } else {
                //else compile and proceed to execution
                template = window.Handlebars.compile(template_or_template_string);
            }
        }
        //execute with the provided context and return the output content...
        return template(context);
    };
})();

var Internationalize = function () {

    /**
     * @constructor
     * @param {Object<String, String>} key_map - i18n key map
     * */
    function Internationalize(key_map) {
        _classCallCheck(this, Internationalize);

        this.key_map = key_map;
    }

    /**
     * @instance
     * @function
     * @param {String} key - key
     * @param {Array<String>} subs - substitutes
     * @param {String} default_value - will be returned if key is not availalbe in the keymap
     * */


    _createClass(Internationalize, [{
        key: "getValue",
        value: function getValue(key, subs, default_value) {
            if (!key) {
                return;
            }
            var value = this.key_map[key];
            if (value === undefined) {
                value = getValueFromJSON(this.key_map, key);
            }
            if (value === undefined) {
                return default_value;
            }
            subs = subs || [];
            var placeholders = value.match(/{[0-9]+}/g) || [];
            for (var i = 0; i < placeholders.length; i++) {
                var sub = subs[i] || "";
                try {
                    if (sub.indexOf('.') !== -1) {
                        sub = this.get(sub);
                    }
                } catch (e) {/*Do Nothing*/}
                value = value.replace(new RegExp("\\{" + i + "\\}", "g"), sub);
            }
            return value.trim();
        }

        /**
         * @instance
         * @function
         * @param {String} key - key
         * @param {Array<String>|String} [subs=[]] - substitutes
         * @param {String} [default_value=null] - substitutes
         * */

    }, {
        key: "get",
        value: function get(key, subs) {
            var default_value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

            if (typeof subs === "string") {
                default_value = subs;
            }
            return this.getValue(key, subs, default_value || key);
        }
    }]);

    return Internationalize;
}();

// Enable multi extend functionality https://stackoverflow.com/a/45332959


function MutateViews(baseClass) {
    for (var _len = arguments.length, mixins = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        mixins[_key - 1] = arguments[_key];
    }

    function copyProps(target, source) {
        // this function copies all properties and symbols, filtering out some special ones
        //TODO "Object.getOwnPropertyNames" and "Object.getOwnPropertySymbols" Doesn't work in IE even after transpilation to ES5...
        Object.getOwnPropertyNames(source).concat(Object.getOwnPropertySymbols(source)).forEach(function (prop) {
            if (!prop.match(/^(?:constructor|prototype|arguments|caller|name|bind|call|apply|toString|length|context)$/)) Object.defineProperty(target, prop, Object.getOwnPropertyDescriptor(source, prop));
        });
    }

    var base = function (_baseClass) {
        _inherits(base, _baseClass);

        function base() {
            var _ref;

            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            _classCallCheck(this, base);

            var _this = _possibleConstructorReturn(this, (_ref = base.__proto__ || Object.getPrototypeOf(base)).call.apply(_ref, [this].concat(args)));

            mixins.forEach(function (mixin) {
                copyProps(_this, new (Function.prototype.bind.apply(mixin, [null].concat(args)))());
            });
            return _this;
        }

        return base;
    }(baseClass);

    mixins.forEach(function (mixin) {
        // outside constructor() to allow aggregation(A,B,C).staticFunction() to be called etc.
        copyProps(base.prototype, mixin.prototype);
        copyProps(base, mixin);
    });
    return base;
}

function cloneObject(obj) {
    var clone = obj instanceof Array ? [] : {};
    for (var i in obj) {
        if (obj[i] != null && _typeof(obj[i]) === "object" && (obj[i].constructor.name === "Object" || obj[i].constructor.name === "Array")) {
            clone[i] = cloneObject(obj[i]);
        } else {
            clone[i] = obj[i];
        }
    }
    return clone;
}

var Time = function () {
    function Time() {
        _classCallCheck(this, Time);
    }

    _createClass(Time, null, [{
        key: "sleep",
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(millis) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                return _context.abrupt("return", new Promise(function (resolve, reject) {
                                    setTimeout(resolve, millis);
                                }));

                            case 1:
                            case "end":
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function sleep(_x2) {
                return _ref2.apply(this, arguments);
            }

            return sleep;
        }()
    }]);

    return Time;
}();
/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @class
 * @classdesc Ticker class that handles repetitive, time based queueing
 * @param {Number} [interval=2000] - polling interval
 * @param {Number} [exponential_factor=1] - factor by which polling interval should be multiplied
 * @param {Number} [min_interval=0] - minimum value configured for Poller's timer to work
 * */


var AdharaTicker = function () {
    function AdharaTicker(interval, exponential_factor, min_interval) {
        _classCallCheck(this, AdharaTicker);

        this.interval = interval === 0 ? interval : interval || 2000;
        this.exponential_factor = exponential_factor || 1;
        this.min_interval = min_interval || 0;
        this.initial_interval = interval;
        this.timeoutId = null;
    }

    _createClass(AdharaTicker, [{
        key: "scheduleNextTick",
        value: function scheduleNextTick() {
            var _this2 = this;

            this.pause();
            if (!(this.interval <= this.min_interval)) {
                this.timeoutId = window.setTimeout(function () {
                    _this2.onExecute();
                }, this.interval);
            }
        }
    }, {
        key: "next",
        value: function next() {
            this.scheduleNextTick();
        }
    }, {
        key: "onExecute",
        value: function onExecute() {
            this.interval *= this.exponential_factor;
            this.on_execute(this.next);
        }

        /**
         * @function
         * @description
         * Starts polling
         * */

    }, {
        key: "start",
        value: function start(execute) {
            this.on_execute = execute;
            this.scheduleNextTick();
        }

        /**
         * @function
         * @description
         * stops current timeout
         * doesn't call next or on-execute function
         * */

    }, {
        key: "pause",
        value: function pause() {
            window.clearTimeout(this.timeoutId);
        }
    }, {
        key: "resume",


        /**
         * @function
         * @description
         * stops current timeout
         * doesn't call next or on-execute function
         * start new timeout
         * */
        value: function resume() {
            this.scheduleNextTick();
        }
    }, {
        key: "stop",


        /**
         * @function
         * @description
         * stops current timeout
         * doesn't call next or on-execute function
         * reset's interval to initial interval
         * */
        value: function stop() {
            this.pause();
            this.interval = this.initial_interval;
        }
    }, {
        key: "restart",


        /**
         * @function
         * @description
         * stops current timeout
         * doesn't call next or on-execute function
         * reset's interval to initial interval
         * start new timeout
         * */
        value: function restart() {
            this.stop();
            this.scheduleNextTick();
        }
    }]);

    return AdharaTicker;
}();
/**------------------------------------------------------------------------------------------------------------------**/


var CoalesceTasker = function () {
    function CoalesceTasker() {
        var wait_for = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

        _classCallCheck(this, CoalesceTasker);

        this.wait_for = wait_for;
        this.timer_idx = 0;
    }

    _createClass(CoalesceTasker, [{
        key: "execute",
        value: function execute(executor, terminator) {
            var _this3 = this;

            if (this.terminator) this.terminator();
            this.executor = executor;
            this.terminator = terminator;
            clearTimeout(this.timer_idx);
            this.timer_idx = setTimeout(function () {
                _this3.executor();
            }, this.wait_for);
        }
    }]);

    return CoalesceTasker;
}();

/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @namespace
 * @description
 * Client routing logic.
 * All the client URL pattern's should be registered with the router.
 *
 * On visiting a URL, if called {@link AdharaRouter.route}, it calls the registered view function,
 * which takes care of rendering the page.
 *
 * Any HTML element can be used as a router. For this purpose,
 *
 *
 * > Add this attribute `href="/url/to/be/navigated/to"` and this property `route` to any html element to make behave as a router.
 *
 * > By default routing happening this way will execute the view function even if the current URL is same as provided href.
 *
 * > In order to disable this behaviour, provide the attribute `data-force="false"`
 *
 * > In order to use {@link AdharaRouter.goBack} functionality provide `data-force="true"`. See example below.
 *
 * @example
 * //Registering
 * AdharaRouter.register("^/adhara/{{instance_id}}([0-9]+)/{{tab}}(details|tokens|history)$", function(instance_id, tab){
 *		console.log(instance_id, tab);
 *	    AdharaRouter.getPathParam("instance_id");  //Returns same as instance_id
 *	    AdharaRouter.getPathParam("tab");  //Returns same as tab
 * });
 *
 * //Navigating
 * AdharaRouter.navigateTo("/adhara/123412341234/details");
 *
 * //Routing - In case if URL is already set in address bar and not via Router, call this function to execute the registered view funciton.
 * this.route();
 *
 * //HTML Example
 *
 * <a href="/adhara/123412341234/tokens" />
 *
 * <button href="/adhara/123412341234/tokens" data-force="false">tokens</button>
 *
 * <div href="/adhara/123412341234/details" data-back="true"></div>
 *
 * */


var AdharaRouter = null;

(function () {

    "use strict";

    /**
     * @private
     * @member {Object<String, Object>}
     * @description
     * Stores all the registered URL's along with other view parameters.
     * */

    var registeredUrlPatterns = {};

    /**
     * @private
     * @member {String}
     * @description
     * Stores base URI for regex matches
     * */
    var baseURI = "";

    var defaultTitle = document.title;

    /**
     * @private
     * @member {String}
     * @description
     * App Name to be used as first half of document title
     * */
    var appName = "";

    /**
     * @private
     * @member {Object<String, String>}
     * @description
     * Stores the current URL's search query parameters.
     * */
    var queryParams = {};

    /**
     * @private
     * @member {Object<String, String>}
     * @description
     * Stores the current URL's path variables.
     * */
    var pathParams = {};

    /**
     * @private
     * @member {Array<String>}
     * @description
     * Stores list of visited URL's
     * */
    var historyStack = [];

    /**
     * @private
     * @member {String|undefined}
     * @description
     * Stores current page URL.
     * */
    var currentUrl = undefined;

    /**
     * @private
     * @member {RouterURLConf}
     * @description
     * Stores route which matches with the current URL against registered URL patterns.
     * */
    var currentRoute = undefined;

    /**
     * @private
     * @member {Object<String, Function|undefined>}
     * @description
     * Stores listeners that will be called on routing.
     * */
    var listeners = {};

    /**
     * @typedef {Function} AdharaRouterMiddleware
     * @param {Object} params - url parameters
     * @param {String } params.view_name - name of the page that is being routed to
     * @param {String} params.path - path that is being routed to
     * @param {Object} params.query_params - url query parameters
     * @param {Object} params.path_params - url path parameters
     * @param {Function} route - Proceed with routing after making necessary checks in middleware
     * */

    /**
     * @private
     * @member {Array<AdharaRouterMiddleware>}
     * @description
     * Stores middlewares that will be called on routing.
     * */
    var middlewares = [];

    /**
     * @function
     * @private
     * @returns {String} Current window URL. IE compatibility provided by Hostory.js (protocol://domain/path?search_query).
     * */
    function getFullUrl() {
        return window.location.href;
        // return History.getState().cleanUrl;
    }

    /**
     * @function
     * @private
     * @returns {String} Full URL without search query (protocol://domain/path).
     * */
    function getBaseUrl() {
        return getFullUrl().split('?')[0];
    }

    /**
     * @function
     * @private
     * @returns {String} URL Path (path).
     * */
    function getPathName() {
        return AdharaRouter.transformURL(window.location.pathname);
    }

    /**
     * @function
     * @private
     * @returns {String} URL Path with search query (/path?search_query).
     * */
    function getFullPath() {
        return getPathName() + window.location.search + window.location.hash;
        // return "/"+getFullUrl().split('://')[1].substring(window.location.host.length+1);
    }

    /**
     * @function
     * @private
     * @returns {String} Search query (search_query).
     * */
    function getSearchString() {
        return window.location.search.substring(1);
    }

    /**
     * @function
     * @private
     * @returns {String} Hash (text after `#` from the url).
     * */
    function getHash() {
        return window.location.hash.substring(1);
    }

    /**
     * @function
     * @private
     * @param {String} new_path - URL path.
     * @returns {Boolean} Whether new_path matches with current URL path.
     * */
    function isCurrentPath(new_path) {
        function stripSlash(path) {
            if (path.indexOf('/') === 0) {
                return path.substring(1);
            }
            return path;
        }
        return stripSlash(getFullPath()) === stripSlash(new_path);
    }

    function callMiddlewares(params, proceed) {
        var i = 0;
        (function _proceed() {
            var middleware_fn = middlewares[i++];
            if (middleware_fn) {
                call_fn(middleware_fn, params, _proceed);
            } else {
                proceed();
            }
        })();
    }

    /**
     * @function
     * @private
     * @description matches the current URL and returns the configuration, path and params
     * @returns Object
     * */
    function matchUrl() {
        var path = getPathName();
        var matchFound = false;
        for (var regex in registeredUrlPatterns) {
            if (registeredUrlPatterns.hasOwnProperty(regex) && !matchFound) {
                var formed_regex = new RegExp(regex);
                if (formed_regex.test(path)) {
                    matchFound = true;
                    var opts = registeredUrlPatterns[regex];
                    var params = formed_regex.exec(path);
                    return { opts: opts, path: path, params: params, meta: opts.meta };
                }
            }
        }
    }

    /**
     * @function
     * @private
     * @description
     * Routes to the current URL.
     * Looks up in the registered URL patterns for a match to current URL.
     * If match found, view function will be called with regex path matches in the matched order and query param's as the last argument.
     * Current view name will be set to the view name configured against view URL.
     * @returns {Boolean} Whether any view function is found or not.
     * */
    function matchAndCall() {
        var _this4 = this;

        var matchOptions = matchUrl();
        if (matchOptions) {
            var opts = matchOptions.opts,
                path = matchOptions.path,
                params = matchOptions.params,
                meta = matchOptions.meta;

            params.splice(0, 1);
            if (opts && opts.fn) {
                var _pathParams = {};
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = params.entries()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var _ref3 = _step.value;

                        var _ref4 = _slicedToArray(_ref3, 2);

                        var index = _ref4[0];
                        var param = _ref4[1];

                        _pathParams[opts.path_param_keys[index]] = param;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                currentRoute = opts;
                //Setting current routing params...
                pathParams = _pathParams;
                currentUrl = getFullUrl();
                fetchQueryParams();

                callMiddlewares({
                    view_name: opts.view_name,
                    path: path,
                    query_params: getQueryParams(),
                    path_params: _pathParams
                }, function () {
                    params.push(queryParams);
                    document.title = [appName || defaultTitle, meta.title].filter(function (_) {
                        return _;
                    }).join(" | ");
                    if (opts.fn.constructor instanceof AdharaView.constructor) {
                        Adhara.onRoute(opts.fn, params);
                    } else {
                        opts.fn.apply(_this4, params);
                    }
                });
            }
        }
        return !!matchOptions;
    }

    var curr_path = void 0;
    function updateHistoryStack() {
        if (curr_path) {
            historyStack.push(curr_path);
        }
        curr_path = getFullPath();
    }

    /**
     * @private
     * @member {Boolean}
     * @description
     * This flag will be set to true when set to true, {@link Router.route} will not call the view function.
     * */
    var settingURL = false;

    /**
     * @function
     * @private
     * @description
     * Updates the {AdharaRouter~queryParams} with the current URL parameters
     * */
    function updateParams() {
        if (getFullUrl() !== currentUrl) {
            currentUrl = getFullUrl();
            fetchQueryParams();
        }
    }

    /**
     * @function
     * @private
     * @description
     * Fetches the search query from current URL and transforms it to query param's object.
     * @returns {Object<String, String>} The search query will be decoded and returned as an object.
     * */
    function getQueryParams() {
        var qp = {};
        if (getSearchString()) {
            loop(getSearchString().split('&'), function (i, paramPair) {
                paramPair = paramPair.split('=');
                qp[decodeURIComponent(paramPair[0])] = decodeURIComponent(paramPair[1]);
            });
        } else {
            qp = {};
        }
        return qp;
    }

    /**
     * @function
     * @private
     * @description
     * Fetches the search query from current URL and transforms it to query param's.
     * The search query will be decoded and stored.
     * */
    function fetchQueryParams() {
        queryParams = getQueryParams();
    }

    /**
     * @function
     * @private
     * @returns {String} URL constructed by current base URL and current Query Parameters.
     * */
    function generateCurrentUrl() {
        var url = getPathName();
        var params = [];
        loop(queryParams, function (key, value) {
            params.push(encodeURIComponent(key) + "=" + encodeURIComponent(value));
        });
        if (params.length) {
            url += "?" + params.join("&");
        }
        return url;
    }

    /**
     * @function
     * @private
     * @param {RouteType} [route_type=this.routeTypes.NAVIGATE] - How to route.
     * @param {Object} route_options - Route options.
     * @param {boolean} [route_options.force=false] - Whether to force navigate URL or not. Will call view function even if current URL is same. Applies for {@link RouteType.NAVIGATE}.
     * @see {@link RouteType}
     * */
    function _route(route_type, route_options) {
        if (!route_type || route_type === AdharaRouter.RouteTypes.SET) {
            AdharaRouter.setURL(generateCurrentUrl());
        } else if (route_type === AdharaRouter.RouteTypes.NAVIGATE) {
            AdharaRouter.navigateTo(generateCurrentUrl(), route_options && route_options.force || false);
        } else if (route_type === AdharaRouter.RouteTypes.OVERRIDE) {
            AdharaRouter.overrideURL(generateCurrentUrl());
        } else if (route_type === AdharaRouter.RouteTypes.UPDATE) {
            AdharaRouter.updateURL(generateCurrentUrl());
        }
    }

    var STATE_KEY = "__adhara_router__";

    var Router = function () {
        function Router() {
            _classCallCheck(this, Router);
        }

        _createClass(Router, null, [{
            key: "transformURL",


            /**
             * @function
             * @private
             * @param {String} url - path
             * @description
             * modified the URL and returns the new value. Default transformer just returns the passed url/path.
             * */
            value: function transformURL(url) {
                if (url.startsWith(baseURI)) {
                    return url;
                }
                return baseURI + url;
            }

            /**
             * @callback ViewFunction
             * @param {String} regexMatchedParams - matched regex params.
             * @param {String} searchQuery - search query parameters converted to object form.
             * @description
             * View callback function.
             * Parameters passed will be the regex matches and last parameter will be searchQueryParameters.
             * In case of more than 1 path regex match, ViewFunction will be called back with (match1, match2, ..., searchQuery)
             * */

            /**
             * @function
             * @static
             * @param {String} pattern - URL Pattern that is to be registered.
             * @param {String} view_name - Name of the view that is mapped to this URL.
             * @param {ViewFunction|Adhara} fn - View function that will be called when the pattern matches window URL.
             * @param {Object} meta - Route meta which can be accessible for current route. This can be used for miscellaneous operations like finding which tab to highlight on a sidebar.
             routes         * */

        }, {
            key: "register_one",
            value: function register_one(pattern, view_name, fn, meta) {
                var path_param_keys = [];
                var regex = /{{([a-zA-Z$_][a-zA-Z0-9$_]*)}}/g;
                var match = regex.exec(pattern);
                while (match != null) {
                    path_param_keys.push(match[1]);
                    match = regex.exec(pattern);
                }
                pattern = pattern.replace(new RegExp("\\{\\{[a-zA-Z$_][a-zA-Z0-9$_]*\\}\\}", "g"), '');
                //Removing all {{XYZ}} iff, XYZ matches first character as an alphabet ot $ or _

                pattern = "^" + this.transformURL(pattern.substring(1));
                pattern = pattern.replace(/[?]/g, '\\?'); //Converting ? to \? as RegExp(pattern) dosen't handle that
                meta = meta || {};
                registeredUrlPatterns[pattern] = { view_name: view_name, fn: fn, path_param_keys: path_param_keys, meta: meta };
            }

            /**
             * @function
             * @static
             * @param {RegExp} regex - URL Pattern that is to be unregistered.
             * @description
             * Once unregistered, this URL regex will be removed from registered URL patterns and on hitting that URL,
             * will be routed to a 404.
             * */

        }, {
            key: "deRegister",
            value: function deRegister(regex) {
                registeredUrlPatterns[regex] = undefined;
            }

            /**
             * Bulk url conf
             * @typedef {Object} RouterURLConf
             * @property {string} url - url regex
             * @property {String} view_name - view name
             * @property {Object} path_params - Path params
             * @property {Function|class} view - view
             * */

            /**
             * @function
             * @static
             * @param {Array<RouterURLConf>} list - list of url configurations
             * @description
             * Register's urls in the list iteratively...
             * */

        }, {
            key: "register",
            value: function register(list) {
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = list[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var conf = _step2.value;

                        this.register_one(conf.url, conf.view_name, conf.view, conf.meta);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }
            }

            /**
             * @typedef {Object} AdharaRouterConfiguration - Adhara router configuration
             * @property {Array<RouterURLConf>} routes - Route configurations
             * @property {String} base_uri - base url after which the matches will be taken care of.
             * For example, if '/ui' is given as base URL, then /ui/home will match a route regex with '/home' only
             * @property {Object<String, Function>} on_route_listeners - On Route listeners
             * @property {Array<AdharaRouterMiddleware>} middlewares - Middleware functions
             * */

            /**
             * @function
             * @static
             * @param {AdharaRouterConfiguration} router_configuration
             * */

        }, {
            key: "configure",
            value: function configure(router_configuration) {
                if (router_configuration.base_uri) {
                    baseURI = router_configuration.base_uri;
                }
                if (router_configuration.app_name) {
                    appName = router_configuration.app_name;
                }
                if (router_configuration.routes) {
                    Router.register(router_configuration.routes);
                }
                if (router_configuration.on_route_listeners) {
                    for (var listener_name in router_configuration.on_route_listeners) {
                        if (router_configuration.on_route_listeners.hasOwnProperty(listener_name)) {
                            Router.onRoute(listener_name, router_configuration.on_route_listeners[listener_name]);
                        }
                    }
                }
                if (router_configuration.middlewares) {
                    var _iteratorNormalCompletion3 = true;
                    var _didIteratorError3 = false;
                    var _iteratorError3 = undefined;

                    try {
                        for (var _iterator3 = router_configuration.middlewares[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                            var middleware_fn = _step3.value;

                            Router.registerMiddleware(middleware_fn);
                        }
                    } catch (err) {
                        _didIteratorError3 = true;
                        _iteratorError3 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion3 && _iterator3.return) {
                                _iterator3.return();
                            }
                        } finally {
                            if (_didIteratorError3) {
                                throw _iteratorError3;
                            }
                        }
                    }
                }
            }

            /**
             * @function
             * @static
             * @param {String} listener_name - A unique name for the listener that will be useful for unregistering.
             * @param {Function} listener_fn - Listener function that to be called on routing. No arguments passed.
             * @description
             * All registered listeners will be called whenever routing happens via AdharaRouter
             * */

        }, {
            key: "onRoute",
            value: function onRoute(listener_name, listener_fn) {
                listeners[listener_name] = listener_fn;
            }

            /**
             * @function
             * @static
             * @param {String} listener_name - A unique name for the listener that will be useful for unregistering.
             * @description
             * De-reigsters the listener registered with this name.
             * */

        }, {
            key: "offRouteListener",
            value: function offRouteListener(listener_name) {
                listeners[listener_name] = undefined;
            }

            /**
             * @function
             * @static
             * @param {Function} middleware_fn - middleware function to be used
             * @description Stores all middleware's and calls then in the order of registration
             * */

        }, {
            key: "registerMiddleware",
            value: function registerMiddleware(middleware_fn) {
                if (typeof middleware_fn === "function") {
                    middlewares.push(middleware_fn);
                }
            }

            /**
             * @function
             * @static
             * @description
             * Routes to the current URL.
             * Looks up in the registered URL patterns for a match to current URL.
             * If match found, view function will be called with regex path matches in the matched order and query param's as the last argument.
             * Current view name will be set to the view name configured against view URL.
             * */

        }, {
            key: "route",
            value: function route() {
                if (!settingURL) {
                    var matchFound = matchAndCall();
                    if (!matchFound) {
                        throw new Error('No route registered for this url : ' + getPathName());
                    }
                } else {
                    settingURL = false;
                }
                loop(listeners, function (listener_name, listener_fn) {
                    call_fn(listener_fn);
                });
            }

            /**
             * @function
             * @static
             * @returns {RouterURLConf} Current view name.
             * */

        }, {
            key: "getCurrentRoute",
            value: function getCurrentRoute() {
                if (!currentRoute) {
                    currentRoute = matchUrl().opts;
                }
                return currentRoute;
            }

            /**
             * @function
             * @static
             * @returns {String} Current view name.
             * */

        }, {
            key: "getCurrentPageName",
            value: function getCurrentPageName() {
                return AdharaRouter.getCurrentRoute().view_name;
            }

            /**
             * @function
             * @static
             * @returns {String} Current URL.
             * */

        }, {
            key: "getCurrentURL",
            value: function getCurrentURL() {
                return getFullPath();
            }

            /**
             * @function
             * @static
             * @returns {String} Current Path.
             * */

        }, {
            key: "getCurrentPath",
            value: function getCurrentPath() {
                return getPathName();
            }

            /**
             * @function
             * @static
             * @returns {String} Current URL's Hash.
             * */

        }, {
            key: "getCurrentHash",
            value: function getCurrentHash() {
                return getHash();
            }

            /**
             * @function
             * @private
             * @param {URL|String} url - URL to be navigated to.
             * @description
             * navigates to the provided URL.
             * */

        }, {
            key: "go",
            value: function go(url) {
                if (isCurrentPath(url)) {
                    return false;
                }
                history.pushState(_defineProperty({}, STATE_KEY, true), parent.document.title, url);
                //considering the behaviour of immediate state change
                var state = history.state;
                updateHistoryStack();
                pathParams = {};
                if (state !== undefined && state !== '') {
                    // let data = state.data;
                    if (state[STATE_KEY] === true || state.data[STATE_KEY] === true) {
                        this.route();
                    }
                }
                // History.pushState({[STATE_KEY]:true}, parent.document.title, url);
                return true;
            }

            /**
             * @function
             * @static
             * @param {String} url - URL that to be updated.
             * @description Updates current URL in the path but doesn't call the view function. Appends current URL in History.
             * */

        }, {
            key: "setURL",
            value: function setURL(url) {
                url = this.transformURL(url);
                settingURL = true;
                var gone = this.go(url);
                if (!gone) {
                    settingURL = false;
                }
            }

            /**
             * @function
             * @static
             * @param {!String} url - URL that to be updated.
             * @description Replaces current URL in the path, and calls view function. No modifications made to History.
             * */

        }, {
            key: "overrideURL",
            value: function overrideURL(url) {
                url = this.transformURL(url);
                history.replaceState(_defineProperty({}, STATE_KEY, true), parent.document.title, url);
                // History.replaceState({[STATE_KEY]:true}, parent.document.title, url);
            }

            /**
             * @function
             * @static
             * @param {!String} url - URL that to be updated.
             * @description Replaces current URL in the path but doesn't call the view function. No modifications made to History.
             * */

        }, {
            key: "updateURL",
            value: function updateURL(url) {
                settingURL = true;
                this.overrideURL(url);
            }

            /**
             * @function
             * @static
             * @param {!String} url - URL to be navigated to.
             * @param {Boolean} [force=false] - If true, will call the view function even if current URL is same as provided URL.
             * @description Navigates to the provided URL.
             * And if provided URL is same as current URL, view function will not be called unless force parameter is true.
             * */

        }, {
            key: "navigateTo",
            value: function navigateTo(url, force) {
                url = this.transformURL(url);
                if (!isCurrentPath(url)) {
                    var gone = this.go(url);
                    if (gone) {
                        fetchQueryParams();
                    }
                } else if (force) {
                    this.route();
                }
            }

            /**
             * @function
             * @static
             * @param {!String} backwardURL - backward URL to be navigated to.
             * @description Navigates to the backward URL by moving back in history.
             * In case if history is not available, Router will navigate to the backwardURL as if it is a new URL.
             * */

        }, {
            key: "goBack",
            value: function goBack(backwardURL) {
                if (!backwardURL) {
                    backwardURL = historyStack.slice(-1)[0];
                    if (!backwardURL) {
                        return false;
                    }
                }
                backwardURL = this.transformURL(backwardURL);
                var backwardIndex = historyStack.lastIndexOf(backwardURL);
                if (backwardIndex === -1) {
                    this.navigateTo(backwardURL);
                } else {
                    var stackLen = historyStack.length;
                    var negativeIndex = backwardIndex - stackLen;
                    historyStack.splice(stackLen + negativeIndex, -negativeIndex);
                    history.go(negativeIndex);
                }
            }

            /**
             * @function
             * @static
             * @returns {Array<String>} List of visited URL's that are routed by Router.
             * */

        }, {
            key: "peekStack",
            value: function peekStack() {
                return historyStack.slice();
            }

            /**
             * @function
             * @static
             * @param {String} param_name - name of the query parameter for which value is required.
             * @returns {String} Value of the search parameter from current URL.
             * */

        }, {
            key: "getQueryParam",
            value: function getQueryParam(param_name) {
                updateParams();
                return queryParams[param_name];
            }
        }, {
            key: "getPathParam",
            value: function getPathParam(param_name) {
                return pathParams[param_name];
            }

            /**
             * Route type
             * @typedef {String} RouteType
             * @see {@link Router.RouteTypes}
             * */

            /**
             * @function
             * @static
             * @param {!Object} new_params - Search Parameters to be added/updated.
             * @param {Boolean} [drop_existing=false] - Whether to completely replace existing search parameters or update with the new ones.
             * @param {RouteType} [route_type=this.routeTypes.NAVIGATE] - How to route. {@link RouteType}
             * @param {Object} route_options - Route options.
             * @param {boolean} [route_options.force=false] - Whether to force navigate URL or not. Will call view function even if current URL is same. Applies for {@link RouteType.NAVIGATE}.
             * @description
             * Updates the query parameters and navigates to the new URL based on route_type that is constructed with the new parameters.
             * */

        }, {
            key: "updateQueryParams",
            value: function updateQueryParams(new_params, drop_existing, route_type, route_options) {
                if (!route_type) {
                    route_type = this.RouteTypes.NAVIGATE;
                }
                /*if(!Object.keys(new_params).length){ return; }*/
                if (drop_existing) {
                    queryParams = new_params;
                } else {
                    Object.assign(queryParams, new_params);
                }
                _route(route_type, route_options);
            }

            /**
             * @function
             * @static
             * @param {!Array} param_keys - Search Parameters to be dropped.
             * @param {RouteType} [route_type=this.routeTypes.NAVIGATE] - How to route. {@link RouteType}
             * @param {Object} route_options - Route options.
             * @param {boolean} [route_options.force=false] - Whether to force navigate URL or not. Will call view function even if current URL is same. Applies for {@link RouteType.NAVIGATE}.
             * @description
             * Drops provided keys if exist, updates the query parameters and navigates to the new URL that is constructed with the new parameters.
             * */

        }, {
            key: "removeQueryParams",
            value: function removeQueryParams(param_keys, route_type, route_options) {
                loop(param_keys, function (idx, key) {
                    delete queryParams[key];
                });
                _route(route_type, route_options);
            }

            /**
             * @function
             * @static
             * @param {String} view_name - View name with which a URL pattern is registered.
             * @returns {RegExp} Pattern for which the provided view name is the view name.
             * */

        }, {
            key: "getURLPatternByPageName",
            value: function getURLPatternByPageName(view_name) {
                var matched_pattern = null;
                loop(registeredUrlPatterns, function (pattern, options) {
                    if (options.view_name === view_name) {
                        matched_pattern = pattern;
                        return false;
                    }
                });
                return matched_pattern;
            }
        }]);

        return Router;
    }();

    //---------------------

    AdharaRouter = Router;

    /**
     * @description
     * setting current view name to undefined on moving to some other page that is not registered with router.
     * */
    window.onpopstate = function (e) {
        // if(e.state[STATE_KEY]){
        AdharaRouter.route();
        // }else{
        //     currentRoute = null;
        // }
        /*if(currentRoute){
            let url_pattern = Router.getURLPatternByPageName(currentRoute.view_name);
            if(!(url_pattern && new RegExp(url_pattern).test(getPathName()))){
                currentRoute = undefined;
            }
        }*/
    };

    /**
     * @static
     * @readonly
     * @enum {RouteType}
     * @description Operations that can be performed on the entity
     * */
    AdharaRouter.RouteTypes = Object.freeze({
        /**
         * navigate to the url and call the view function. This will add current URL to History.
         * */
        NAVIGATE: "navigate",
        /**
         * override the current url and call the view function. This will not change History.
         * */
        OVERRIDE: "override",
        /**
         * Just update the URL. Adds current URL to History. View function will not be called.
         * */
        SET: "set",
        /**
         * Overrides the current URL. No modifications made to History. View function will not be called.
         * */
        UPDATE: "update"
    });

    AdharaRouter.enableAllAnchors = true;

    AdharaRouter.listen = function () {
        /**
         * Listening to elements with route property in DOM.
         * If it has href attribute, preventing default event and proceeding with SdpRouting
         * */

        function getRoutingElement(event) {
            return event.target.nodeName !== "A" ? event.currentTarget : event.target;
        }

        function hasAttribute(elem, attribute_name) {
            return elem.hasAttribute(attribute_name);
        }

        function routeHandler(event) {
            var re = getRoutingElement(event);
            if ((AdharaRouter.enableAllAnchors || hasAttribute(re, "route")) && hasAttribute(re, "href") && !hasAttribute(re, "skiprouting")) {
                var target = this.getAttribute("target");
                var miniURL = this.getAttribute('href').trim();
                var isHash = miniURL.indexOf("#") === 0;
                if (target && target !== "_self" || miniURL.indexOf('javascript') !== -1 || isHash) {
                    return;
                }
                var url = miniURL; //this.href;
                try {
                    var go_to_url = new URL(url);
                    if (go_to_url.host !== window.location.host) {
                        return;
                    }
                } catch (e) {/*Do nothing. Try catches the invalid url on new ULR(...)*/}
                var go_back = this.getAttribute("data-back");
                if (go_back) {
                    AdharaRouter.goBack(url);
                } else {
                    var force = this.getAttribute("data-force") !== "false";
                    AdharaRouter.navigateTo(url, force);
                }
                if (url) {
                    event.preventDefault();
                    event.stopPropagation();
                }
            }
        }

        jQuery(document).on("click", "a", routeHandler);
        jQuery(document).on("click", "[route]", routeHandler);

        /*document.addEventListener('click', function (e) {
            if(e.target.nodeName === "A" && ( AdharaRouter.enableAllAnchors || hasAttribute(e.target, "route") ) ){
                let url = e.target.getAttribute('href').trim();
                if(url.indexOf('javascript') !== -1){return;}
                if(url){
                    e.preventDefault();
                    e.stopPropagation();
                }
                let go_back = e.target.getAttribute("data-back");
                let force = e.target.getAttribute("data-force") !== "false";
                if(go_back){ return AdharaRouter.goBack(url); }
                AdharaRouter.navigateTo(url, force);
            }
         }, false);*/
    };

    //---------------------


    updateHistoryStack(); //updating history stack with the entry URL
})();
/**------------------------------------------------------------------------------------------------------------------**/
var Toast = {};
(function () {

    Toast.make = function (title, content, type) {
        //type should be "success", "error" or "info"
        if (Adhara.app) {
            return Adhara.app.toast(title, content, type);
        } else {
            if (window.ToastHandler) {
                return window.ToastHandler[type](content, title);
            } else {
                console.log("No toast handler found. Toast message: type-" + type + ", title-" + title + ", content=" + content);
            }
        }
    };

    Toast.error = function (message) {
        return Toast.make("Error!", message, "error");
    };

    Toast.success = function (message) {
        return Toast.make("Success", message, "success");
    };
})();

var AdharaDefaultToaster = {};

(function () {

    var notifyQueue = 0;

    function notify(title, content, type, id) {
        id = "notification_" + id;
        var $notificationDiv = jQuery('<div class="notification ' + type + '" id="' + id + '"/>');
        var $title = jQuery('<strong style="display:block" />').text(title);
        var $content = jQuery('<p />').html(content);
        $notificationDiv.append($title).append($content);
        jQuery('body').append($notificationDiv);

        var existing_notifications = jQuery('.notification');
        if (existing_notifications.length > 0) {
            jQuery.each(existing_notifications, function (index, value) {
                if (jQuery(this).attr('id') !== id) {
                    var new_top = parseFloat(jQuery(this).css('top')) + $notificationDiv.height() + 40;
                    jQuery(this).animate({ top: new_top + "px" }, 'fast');
                }
            });
        }

        jQuery('#' + id).animate({ right: '0px' }, 'fast', function () {
            notifyQueue--;
        });
        setTimeout(function () {
            jQuery('#' + id).animate({ opacity: '0.5' }, 'fast', function () {
                jQuery('#' + id).hide('slide', { direction: 'right' }, 'slow', function () {
                    setTimeout(function () {
                        jQuery('#' + id).remove();
                    }, 1000);
                });
            });
        }, 5000);
    }

    AdharaDefaultToaster.make = function (title, content, type) {
        var maxNotificationsHeight = window.innerHeight - 200;
        var currentNotificationsHeight = 0;
        jQuery.each(jQuery('.notification'), function () {
            currentNotificationsHeight += jQuery(this).height() + 40;
        });
        var proceed = currentNotificationsHeight < maxNotificationsHeight;
        var notifyTimeout = notifyQueue === 0 ? 0 : 2000;
        if (!content && type === "failure") {
            content = "Error occurred...";
        }
        var nid = performance.now();
        setTimeout(function () {
            if (notifyQueue === 0 && proceed) {
                notifyQueue++;
                notify(title, content, type, nid);
            } else {
                AdharaDefaultToaster.make(title, content, type);
            }
        }, notifyTimeout);
        return {
            remove: function remove() {
                jQuery("#notification_" + nid).remove();
            }
        };
    };
})();
/**------------------------------------------------------------------------------------------------------------------**/
function range(start, stop) {
    var step = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

    var i, _i;

    return regeneratorRuntime.wrap(function range$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    if (!(step >= 0)) {
                        _context2.next = 10;
                        break;
                    }

                    i = start;

                case 2:
                    if (!(i + step <= stop)) {
                        _context2.next = 8;
                        break;
                    }

                    _context2.next = 5;
                    return i;

                case 5:
                    i += step;
                    _context2.next = 2;
                    break;

                case 8:
                    _context2.next = 17;
                    break;

                case 10:
                    _i = start;

                case 11:
                    if (!(_i + step >= stop)) {
                        _context2.next = 17;
                        break;
                    }

                    _context2.next = 14;
                    return _i;

                case 14:
                    _i += step;
                    _context2.next = 11;
                    break;

                case 17:
                case "end":
                    return _context2.stop();
            }
        }
    }, _marked, this);
}
/**------------------------------------------------------------------------------------------------------------------**/
function deserialize(str, context) {
    if ((typeof context === "undefined" ? "undefined" : _typeof(context)) === 'object' && context.blob) {
        var _data = JSON.parse(str);
        return new context.blob(_data);
    }
    if (context) {
        var _data2 = JSON.parse(str);
        return new context.blob(_data2);
    }
    throw new Error("context passed is invalid: " + context);
}

function isPrimitive(ob) {
    return ob !== Object(ob);
}

var Serializable = function () {
    _createClass(Serializable, null, [{
        key: "_validateData",
        value: function _validateData(data) {
            // checks if there is information loss on serializing the data
            function equivalence(ob1, ob2) {
                if (isPrimitive(ob1) && isPrimitive(ob2)) {
                    return ob1 === ob2;
                } else if (isPrimitive(ob1) !== isPrimitive(ob2)) {
                    return false;
                }
                for (var key in ob1) {
                    if (ob1.hasOwnProperty(key)) {
                        if (!equivalence(ob1[key], ob2[key])) {
                            return false;
                        }
                    }
                }
                return true;
            }
            if (isPrimitive(data)) {
                return true;
            } else if ((typeof data === "undefined" ? "undefined" : _typeof(data)) !== 'object' || data === null || data instanceof Array) {
                // console.warn("null/array data", data);
                return true; //Todo handle array of arrays as well !
            } else {
                var eq_success = equivalence(JSON.parse(JSON.stringify(data)), data);
                if (!eq_success) {
                    console.warn("Equivalence check failed for the data. Data is not serializable.", data);
                }
                return eq_success;
            }
        }
    }]);

    function Serializable(data) {
        _classCallCheck(this, Serializable);

        if (!Serializable._validateData(data)) {
            throw new Error("blob must be initialized with serializable(tree-like, non-array) object: " + data);
        }
    }

    _createClass(Serializable, [{
        key: "serialize",
        value: function serialize() {
            throw new Error("Need to define method: serialize");
        }
    }]);

    return Serializable;
}();
/**------------------------------------------------------------------------------------------------------------------**/


var DataBlob = function (_Serializable) {
    _inherits(DataBlob, _Serializable);

    // extender blobs represent tree like objects only

    function DataBlob(data) {
        _classCallCheck(this, DataBlob);

        var _this5 = _possibleConstructorReturn(this, (DataBlob.__proto__ || Object.getPrototypeOf(DataBlob)).call(this, data));

        if (!data) {
            return _possibleConstructorReturn(_this5);
        }
        _this5._data = data;
        var data_is_fine = _this5.validate(data);
        if (data_is_fine === false) {
            throw new Error("assigned data does not clear the custom validation: " + data);
        }
        _this5.onInit();
        return _this5;
    }

    /**
     * Easy override method: to handle creating any cacheable objects/references classes
     * */


    _createClass(DataBlob, [{
        key: "onInit",
        value: function onInit() {}
    }, {
        key: "validate",
        value: function validate() {
            return true;
        }
    }, {
        key: "_formatTimeBit",
        value: function _formatTimeBit(value) {
            return (value.toString().length === 1 ? "0" : "") + value.toString();
        }

        //TODO generalize this using string format's

    }, {
        key: "_formatTime",
        value: function _formatTime(date) {
            return this._formatTimeBit(date.getHours()) + ":" + this._formatTimeBit(date.getMinutes()) + ":" + this._formatTimeBit(date.getSeconds());
        }

        //TODO generalize this using string format's

    }, {
        key: "_formatDate",
        value: function _formatDate(date) {
            return this._formatTimeBit(date.getMonth() + 1) + "/" + this._formatTimeBit(date.getDate()) + "/" + date.getFullYear();
        }
    }, {
        key: "data",


        // noinspection JSAnnotator
        get: function get() {
            return this._data;
        },
        set: function set(data) {
            if (!Serializable._validateData(data)) {
                // all blobs are validated for serializability
                throw new Error("blob must represent a non-array, tree-like object " + data);
            }
            var data_is_fine = this.validate(data); // custom validators must throw their own errors or return a false status on failure
            if (data_is_fine === false) {
                throw new Error("assigned data does not clear the custom validation: " + data);
            }
            this._data = data;
        }
    }, {
        key: "packet",
        get: function get() {
            return this.serialize();
        }
    }], [{
        key: "_context",
        get: function get() {
            return "base";
        }
    }]);

    return DataBlob;
}(Serializable);
/**------------------------------------------------------------------------------------------------------------------**/


var NetworkMethods = {
    GET: "get",
    POST: "post",
    PUT: "put",
    DELETE: "delete",
    PATCH: "patch"
};

var NetworkProvider = function () {
    function NetworkProvider() {
        _classCallCheck(this, NetworkProvider);
    }

    _createClass(NetworkProvider, [{
        key: "formatResponse",
        value: function formatResponse(data) {
            return data;
        }
    }, {
        key: "getCookie",
        value: function getCookie(cookie_name) {
            var cookieValue = null;
            if (document.cookie && document.cookie !== '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, cookie_name.length + 1) === cookie_name + '=') {
                        cookieValue = decodeURIComponent(cookie.substring(cookie_name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
    }, {
        key: "isFullURL",
        value: function isFullURL(link) {
            return link.startsWith("http://") || link.startsWith("https://") || link.startsWith("//");
        }
    }, {
        key: "formatURL",
        value: function formatURL(url) {
            if (this.isFullURL(url)) {
                return url;
            }
            var baseURL = this.baseURL;
            if (baseURL.endsWith("/")) {
                baseURL = baseURL.substr(0, baseURL.length - 1);
            }
            if (url.startsWith("/")) {
                url = url.substr(1);
            }
            return baseURL + '/' + url;
        }
    }, {
        key: "_handleSE",
        value: function _handleSE(xhr, success_fn, error_fn) {
            if (xhr.status >= 400) {
                if (xhr.readyState === 0 && xhr.status === 0 && error_fn.err === "") {
                    error_fn.err = "Unable to connect to server";
                }
                error_fn(xhr, error_fn.err || "error", xhr.responseText);
                //    return Toast.error(error_fn.err+"\n"+x.responseText);
            } else {
                success_fn(xhr.responseText, "success", xhr);
            }
        }
    }, {
        key: "ajax",
        value: function ajax(o) {
            if (o.method !== "get" && o.data instanceof Object) {
                if (!Object.keys(o.data).length) {
                    delete o.data;
                } else {
                    o.data = JSON.stringify(o.data);
                }
            }
            /*if(o.method === "get" || o.method === "patch" || o.method === "post") { if (o.method === "get") { /!*if (o.data) { o.data = {data: o.data}; }*!/ } }*/
            if (o.method !== "get" && o.method !== "delete") {
                o.headers['Content-Type'] = 'application/json';
            }
            jQuery.ajax(o);
            // let jqXHR = jQuery.ajax(o);
            // o.abort = jqXHR.abort;
        }
    }, {
        key: "multipart",
        value: function multipart(o) {
            var xhr = new XMLHttpRequest();
            xhr.open(o.method.toUpperCase(), o.url);
            delete o.headers['Content-Type'];
            loop(o.headers, function (header, value) {
                xhr.setRequestHeader(header, value);
            });
            xhr.onreadystatechange = function () {
                if (xhr.readyState === XMLHttpRequest.DONE) {
                    if (xhr.status >= 400) {
                        o.error(xhr, "error", xhr.responseText);
                    } else {
                        o.success(xhr.responseText, "success", xhr);
                    }
                }
            };
            xhr.send(o.data);
            // o.abort = xhr.abort;
        }
    }, {
        key: "send",
        value: function () {
            var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(o) {
                var _this6 = this;

                return regeneratorRuntime.wrap(function _callee2$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                return _context3.abrupt("return", new Promise(function (resolve, reject) {
                                    o.success = function (d, s, x) {
                                        _this6._handleSE(x, function () {
                                            return resolve([d, x]);
                                        }, function () {
                                            return reject([d, x]);
                                        });
                                    };
                                    o.error = function (x, s, e) {
                                        var err_fn = function err_fn() {
                                            return reject([e, x]);
                                        };
                                        err_fn.err = e;
                                        _this6._handleSE(x, null, err_fn);
                                    };
                                    if (o.data instanceof FormData) {
                                        _this6.multipart(o);
                                    } else {
                                        _this6.ajax(o);
                                    }
                                }));

                            case 1:
                            case "end":
                                return _context3.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function send(_x5) {
                return _ref5.apply(this, arguments);
            }

            return send;
        }()
    }, {
        key: "preFlightIntercept",
        value: function preFlightIntercept(method, url, data) {
            //    Override if required
        }
    }, {
        key: "_preFlightIntercept",
        value: function _preFlightIntercept(method, url, data) {
            this.preFlightIntercept(method, url, data);
        }
    }, {
        key: "postResponseIntercept",
        value: function postResponseIntercept(method, url, data, response, xhr) {
            //    Override if required
        }
    }, {
        key: "_postResponseIntercept",
        value: function _postResponseIntercept(method, url, data, response, xhr) {
            this.postResponseIntercept(method, url, data, response, xhr);
        }
    }, {
        key: "postErrorResponseIntercept",
        value: function postErrorResponseIntercept(method, url, data, response, xhr) {
            //    Override if required
        }
    }, {
        key: "_postErrorResponseIntercept",
        value: function _postErrorResponseIntercept(method, url, data, response, xhr) {
            this.postErrorResponseIntercept(method, url, data, response, xhr);
        }
    }, {
        key: "_send",
        value: function () {
            var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(method, url, data, options) {
                var _ref7, _ref8, r, x;

                return regeneratorRuntime.wrap(function _callee3$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                url = this.formatURL(url);
                                this._preFlightIntercept(method, url, null);
                                _context4.prev = 2;
                                _context4.next = 5;
                                return this.send(Object.assign({
                                    url: url,
                                    headers: this.headers,
                                    method: method,
                                    data: data
                                }, options));

                            case 5:
                                _ref7 = _context4.sent;
                                _ref8 = _slicedToArray(_ref7, 2);
                                r = _ref8[0];
                                x = _ref8[1];

                                this._postResponseIntercept(method, url, null, r, x);
                                return _context4.abrupt("return", this.formatResponse(r));

                            case 13:
                                _context4.prev = 13;
                                _context4.t0 = _context4["catch"](2);

                                console.log("API errored out::", _context4.t0);
                                this._postErrorResponseIntercept(method, url, data, _context4.t0[0], _context4.t0[1]);
                                throw _context4.t0[0];

                            case 18:
                            case "end":
                                return _context4.stop();
                        }
                    }
                }, _callee3, this, [[2, 13]]);
            }));

            function _send(_x6, _x7, _x8, _x9) {
                return _ref6.apply(this, arguments);
            }

            return _send;
        }()
    }, {
        key: "get",
        value: function () {
            var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(url, data, options) {
                return regeneratorRuntime.wrap(function _callee4$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                if (data && (typeof data === "undefined" ? "undefined" : _typeof(data)) === "object") {
                                    data = Object.entries(data).map(function (_ref10) {
                                        var _ref11 = _slicedToArray(_ref10, 2),
                                            k = _ref11[0],
                                            v = _ref11[1];

                                        return k + "=" + v;
                                    }).join("&");
                                }
                                _context5.next = 3;
                                return this._send(NetworkMethods.GET, url, data, options);

                            case 3:
                                return _context5.abrupt("return", _context5.sent);

                            case 4:
                            case "end":
                                return _context5.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function get(_x10, _x11, _x12) {
                return _ref9.apply(this, arguments);
            }

            return get;
        }()
    }, {
        key: "post",
        value: function () {
            var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(url, data, options) {
                return regeneratorRuntime.wrap(function _callee5$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _context6.next = 2;
                                return this._send(NetworkMethods.POST, url, data, options);

                            case 2:
                                return _context6.abrupt("return", _context6.sent);

                            case 3:
                            case "end":
                                return _context6.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function post(_x13, _x14, _x15) {
                return _ref12.apply(this, arguments);
            }

            return post;
        }()
    }, {
        key: "put",
        value: function () {
            var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(url, data, options) {
                return regeneratorRuntime.wrap(function _callee6$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                _context7.next = 2;
                                return this._send(NetworkMethods.PUT, url, data, options);

                            case 2:
                                return _context7.abrupt("return", _context7.sent);

                            case 3:
                            case "end":
                                return _context7.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function put(_x16, _x17, _x18) {
                return _ref13.apply(this, arguments);
            }

            return put;
        }()
    }, {
        key: "patch",
        value: function () {
            var _ref14 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(url, data, options) {
                return regeneratorRuntime.wrap(function _callee7$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                _context8.next = 2;
                                return this._send(NetworkMethods.PATCH, url, data, options);

                            case 2:
                                return _context8.abrupt("return", _context8.sent);

                            case 3:
                            case "end":
                                return _context8.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function patch(_x19, _x20, _x21) {
                return _ref14.apply(this, arguments);
            }

            return patch;
        }()
    }, {
        key: "delete",
        value: function () {
            var _ref15 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(url, data, options) {
                return regeneratorRuntime.wrap(function _callee8$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                _context9.next = 2;
                                return this._send(NetworkMethods.DELETE, url, data, options);

                            case 2:
                                return _context9.abrupt("return", _context9.sent);

                            case 3:
                            case "end":
                                return _context9.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function _delete(_x22, _x23, _x24) {
                return _ref15.apply(this, arguments);
            }

            return _delete;
        }()
    }, {
        key: "baseURL",
        get: function get() {
            return "/";
        }
    }, {
        key: "headers",
        get: function get() {
            return {
                "Content-Type": "application/json"
            };
        }
    }]);

    return NetworkProvider;
}();

/**------------------------------------------------------------------------------------------------------------------**/


var DataInterface = function DataInterface(network) {
    _classCallCheck(this, DataInterface);

    this.network = network || new NetworkProvider();
};
/**------------------------------------------------------------------------------------------------------------------**/


var Context = function () {

    /**
     * @param {String} key - Class instance key passed by instance creator.
     * @param {AdharaView} view - View instance to whom this context belongs to.
     * */
    function Context(key, view) {
        _classCallCheck(this, Context);

        this.key = key;
        this.view = view;
    }

    _createClass(Context, [{
        key: "removeFromParent",
        value: function removeFromParent() {
            this.parentContext.childContexts.splice(this.parentContext.childContexts.indexOf(this), 1);
        }

        /**
         * @function
         * @description searches context tree and returns a class instance
         * @param {class} classRef - class reference of an AdharaView class
         * @param {String} instanceKey - instance tag as string
         * */

    }, {
        key: "getViewFromRenderTree",
        value: function getViewFromRenderTree(classRef, instanceKey) {
            return this.searchViewInCurrentTreeAndUp(classRef, instanceKey) || this.searchViewInWholeTree(classRef, instanceKey);
        }
    }, {
        key: "checkKey",
        value: function checkKey(contextKey, instanceKey) {
            return !instanceKey || contextKey === instanceKey;
        }
    }, {
        key: "searchViewInCurrentTreeAndUp",
        value: function searchViewInCurrentTreeAndUp(classRef, instanceKey) {
            if (classRef === Adhara.container.constructor) {
                return Adhara.container;
            }
            if (this.view === Adhara.container) {
                return;
            }
            if (this.parentContext.view.constructor === classRef && this.checkKey(this.parentContext.key, instanceKey)) {
                return this.parentContext.view;
            }
            return this.parentContext.getViewFromRenderTree(classRef, instanceKey);
        }
    }, {
        key: "searchViewInWholeTree",
        value: function searchViewInWholeTree(classRef, instanceKey) {
            var containerView = this.searchViewInCurrentTreeAndUp(Adhara.container.constructor);
            return containerView.context.searchChildren(classRef, instanceKey);
        }
    }, {
        key: "searchChildren",
        value: function searchChildren(classRef, instanceKey) {
            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
                for (var _iterator4 = this.childContexts[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                    var context = _step4.value;

                    if (context.view.constructor === classRef && this.checkKey(context.key, instanceKey)) {
                        return context.view;
                    }
                }
            } catch (err) {
                _didIteratorError4 = true;
                _iteratorError4 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion4 && _iterator4.return) {
                        _iterator4.return();
                    }
                } finally {
                    if (_didIteratorError4) {
                        throw _iteratorError4;
                    }
                }
            }

            var _iteratorNormalCompletion5 = true;
            var _didIteratorError5 = false;
            var _iteratorError5 = undefined;

            try {
                for (var _iterator5 = this.childContexts[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                    var _context10 = _step5.value;

                    var matchedView = _context10.searchChildren(classRef, instanceKey);
                    if (matchedView) {
                        return matchedView;
                    }
                }
            } catch (err) {
                _didIteratorError5 = true;
                _iteratorError5 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion5 && _iterator5.return) {
                        _iterator5.return();
                    }
                } finally {
                    if (_didIteratorError5) {
                        throw _iteratorError5;
                    }
                }
            }
        }
    }, {
        key: "parentContext",
        set: function set(parent_context) {
            this._parentContext = parent_context;
            this._parentContext.childContext = this;
        },
        get: function get() {
            return this._parentContext || Adhara.container.context;
        }
    }, {
        key: "childContext",
        set: function set(child_context) {
            if (!this._childContexts) {
                this._childContexts = [];
            }
            this._childContexts.push(child_context);
        }
    }, {
        key: "childContexts",
        get: function get() {
            return this._childContexts || [];
        }
    }]);

    return Context;
}();
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaEventHandler = function () {
    function AdharaEventHandler() {
        _classCallCheck(this, AdharaEventHandler);

        this._event_listeners = {};
        this._registerEvents(this.events);
    }

    /**
     * @getter
     * @instance
     * @returns {Array<String>} return list of custom event names in PascalCase...
     * @description event listener registration functions will be created dynamically by prepending "on" th the event name
     * @example
     * say get events() returns this array: ["Render", "Format"]
     * listener functions these events can be then registered using `onRender(listener)` and `onFormat(listener)`
     * */


    _createClass(AdharaEventHandler, [{
        key: "_registerEvents",


        /**
         * @function
         * @protected
         * @param {Array<String>} event_names - list of events that are to be enabled on the current View instance.
         * @description registers the event names and creates event registration functions.
         * @example
         * _registerEvents(["Render", "Format"]);
         * //This will create 2 functions onRender and onFormat runtime to allow registration of events
         * */
        value: function _registerEvents(event_names) {
            var _this7 = this;

            var _loop = function _loop(event_name) {
                _this7._event_listeners[event_name] = [];
                _this7["on" + event_name] = function (handler) {
                    _this7._event_listeners[event_name].push(handler);
                };
                _this7["off" + event_name] = function (handler) {
                    _this7._event_listeners[event_name].splice(_this7._event_listeners[event_name].indexOf(handler), 1);
                };
            };

            var _iteratorNormalCompletion6 = true;
            var _didIteratorError6 = false;
            var _iteratorError6 = undefined;

            try {
                for (var _iterator6 = event_names[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                    var event_name = _step6.value;

                    _loop(event_name);
                }
            } catch (err) {
                _didIteratorError6 = true;
                _iteratorError6 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion6 && _iterator6.return) {
                        _iterator6.return();
                    }
                } finally {
                    if (_didIteratorError6) {
                        throw _iteratorError6;
                    }
                }
            }
        }

        /*
        // THIS CAN BE ENABLED IF SUPPORT FOR CUSTOM EVENTS OTHER THAN VIEW SPECIFIC EVENTS IS REQUIRED
        on(event_name, handler){
            if(!this._event_listeners[event_name]){
                this._event_listeners[event_name] = [];
            }
            this._event_listeners[event_name].push(handler);
        }
         off(event_name, handler){
            this._event_listeners[event_name] = this._event_listeners[event_name].filter(_handler => _handler!==handler);
        }*/

    }, {
        key: "trigger",
        value: function trigger(event_name) {
            for (var _len3 = arguments.length, data = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                data[_key3 - 1] = arguments[_key3];
            }

            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
                for (var _iterator7 = this._event_listeners[event_name][Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                    var event_handler = _step7.value;

                    event_handler.apply(event_handler, data);
                }
            } catch (err) {
                _didIteratorError7 = true;
                _iteratorError7 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion7 && _iterator7.return) {
                        _iterator7.return();
                    }
                } finally {
                    if (_didIteratorError7) {
                        throw _iteratorError7;
                    }
                }
            }
        }
    }, {
        key: "events",
        get: function get() {
            return [];
        }
    }]);

    return AdharaEventHandler;
}();
/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @class
 * @classdesc a base class that is to be extended by all the view classes
 * */


var AdharaView = function (_AdharaEventHandler) {
    _inherits(AdharaView, _AdharaEventHandler);

    /**
     * @constructor
     * @param {Object} [settings]
     * @param {String} [settings.key=undefined] - Instance key
     * @param {String} settings.c - CSS Selector from parent view to place content of this class
     * @param {Object} settings.options - custom options to be passed
     * @param {HandlebarTemplate} settings.t - View template
     * */
    function AdharaView() {
        var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, AdharaView);

        var _this8 = _possibleConstructorReturn(this, (AdharaView.__proto__ || Object.getPrototypeOf(AdharaView)).call(this));

        _this8.settings = settings;
        if (!_this8.settings.options) _this8.settings.options = {};
        var _this8$settings = _this8.settings,
            key = _this8$settings.key,
            c = _this8$settings.c;

        _this8.ts = "d" + performance.now().toString().replace(".", '-');
        _this8.context = new Context(key || _this8.ts, _this8);
        _this8._parentContainer = c;
        Adhara.addViewToInstances(_this8);
        _this8.is_active = false;
        _this8._registerEvents(["ViewRendered", "SubViewsRendered", "ViewFormatted", "ViewDestroyed"]);
        _this8.fetching_data = false;
        _this8.onInit();
        _this8._subViews = [];
        _this8.rednered_subviews = [];
        _this8.rendered = false;
        _this8.initialized = true;
        _this8.error = null;
        return _this8;
    }

    /**
     * @function
     * @instance
     * @description Anything that needs to be done right after initializing the view.
     * */


    _createClass(AdharaView, [{
        key: "onInit",
        value: function onInit() {}
        //Override this method to do any miscellaneous operations/assignments right after initializing the View


        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} template of the view
         * */

    }, {
        key: "getCustomTemplate",
        value: function getCustomTemplate(type) {
            var _iteratorNormalCompletion8 = true;
            var _didIteratorError8 = false;
            var _iteratorError8 = undefined;

            try {
                for (var _iterator8 = Adhara.viewHierarchy[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                    var ViewClass = _step8.value;

                    if (ViewClass.isPrototypeOf(this.constructor)) {
                        if (Adhara.app.customViewConfig[type] && Adhara.app.customViewConfig[type][ViewClass.name]) {
                            return Adhara.app.customViewConfig[type][ViewClass.name];
                        }
                    }
                }
            } catch (err) {
                _didIteratorError8 = true;
                _iteratorError8 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion8 && _iterator8.return) {
                        _iterator8.return();
                    }
                } finally {
                    if (_didIteratorError8) {
                        throw _iteratorError8;
                    }
                }
            }
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} template of the view
         * */

    }, {
        key: "getTemplate",


        /**
         * @function
         * @instance
         * @description Helper method to get required template. Error template or success template.
         * */
        value: function getTemplate() {
            return this.fetching_data ? this.fetchingDataTemplate : this.error ? this.errorTemplate || this.template : this.template;
        }
    }, {
        key: "isActive",
        value: function isActive() {
            return Adhara.isActiveView(this) && this.is_active;
        }
    }, {
        key: "create",
        value: function create(parentViewInstance) {
            var _this9 = this;

            Adhara.addToActiveViews(this);
            this.parentViewInstance = parentViewInstance;
            this.is_active = true;
            this.fetch().then(function () {
                _this9.render();
            });
            this.render();
        }
    }, {
        key: "fetch",
        value: function () {
            var _ref16 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
                return regeneratorRuntime.wrap(function _callee9$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:
                                this.fetching_data = true;
                                _context11.next = 3;
                                return this.fetchData();

                            case 3:
                                this.fetching_data = false;

                            case 4:
                            case "end":
                                return _context11.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function fetch() {
                return _ref16.apply(this, arguments);
            }

            return fetch;
        }()

        /**
         * @function
         * @instance
         * @description hook to make API calls, data change event will be triggered on successful API call.
         * By default no API call will be made and dataChange method will be called right away.
         * */

    }, {
        key: "fetchData",
        value: function () {
            var _ref17 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
                return regeneratorRuntime.wrap(function _callee10$(_context12) {
                    while (1) {
                        switch (_context12.prev = _context12.next) {
                            case 0:
                            case "end":
                                return _context12.stop();
                        }
                    }
                }, _callee10, this);
            }));

            function fetchData() {
                return _ref17.apply(this, arguments);
            }

            return fetchData;
        }()
    }, {
        key: "_getHTML",
        value: function _getHTML(template) {
            return Adhara.app.renderTemplate(template || this.getTemplate(), this);
        }

        /**
         * @param {Context} context - current view context from which this class instance is to be looked up in the tree
         * @param {String} [tag] - instance tag
         * */

    }, {
        key: "getParentContainerElement",
        value: function getParentContainerElement() {
            return document.querySelector(this.parentContainer);
        }
    }, {
        key: "querySelector",
        value: function querySelector(css_selector) {
            return this.getParentContainerElement().querySelector(css_selector);
        }
    }, {
        key: "querySelectorAll",
        value: function querySelectorAll(css_selector) {
            return this.getParentContainerElement().querySelectorAll(css_selector);
        }
    }, {
        key: "setState",
        value: function setState() {
            this.render();
        }
    }, {
        key: "render",
        value: function render() {
            var _this10 = this;

            if (this.parentViewInstance) this.context.parentContext = this.parentViewInstance.context;
            var container = this.getParentContainerElement();
            if (!container) {
                console.warn("No container defined/available for " + this.constructor.name + ", selecting with " + this.parentContainer);
                return;
            }
            container.innerHTML = this._getHTML();
            if (this.fetching_data) {
                return;
            }
            this.trigger("ViewRendered");
            this._format(container);
            setTimeout(function () {
                _this10.format(container);
                _this10.trigger("ViewFormatted");
            }, 0);
            this.renderSubViews();
            this.trigger("SubViewsRendered");
            this.rendered = true;
        }

        /**
         * @function
         * @getter
         * @returns {String} A CSS selector inside which child views are to be rendered.
         * */

    }, {
        key: "renderSubViews",
        value: function renderSubViews() {
            this.rednered_subviews.forEach(function (_) {
                _.destroy();
            });
            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;

            try {
                for (var _iterator9 = (this.subViews || [])[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                    var sub_view = _step9.value;

                    this.rednered_subviews.push(Adhara.createView(sub_view, this));
                }
            } catch (err) {
                _didIteratorError9 = true;
                _iteratorError9 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion9 && _iterator9.return) {
                        _iterator9.return();
                    }
                } finally {
                    if (_didIteratorError9) {
                        throw _iteratorError9;
                    }
                }
            }
        }
    }, {
        key: "_format",
        value: function _format(container) {
            var _this11 = this;

            var _loop2 = function _loop2(action) {
                var onActionElements = container.querySelectorAll("[data-on" + action + "]");

                var _loop3 = function _loop3(actionElement) {
                    if (actionElement.dataset["_ae_" + action + "_"] === "true") {
                        return "continue";
                    }
                    actionElement.addEventListener(action, function (event) {
                        var data = actionElement.dataset;
                        var action_key = "on" + action;
                        if (_this11[data[action_key]]) {
                            _this11[data[action_key]](event, data, _this11);
                        } else {
                            var fn = getValueFromJSON(window, data[action_key]);
                            if (fn) {
                                fn(event, data, _this11);
                            } else {
                                throw new Error("Invalid function: " + data[action_key] + " in View " + _this11.constructor.name);
                            }
                        }
                    });
                    actionElement.dataset["_ae_" + action + "_"] = "true";
                };

                var _iteratorNormalCompletion10 = true;
                var _didIteratorError10 = false;
                var _iteratorError10 = undefined;

                try {
                    for (var _iterator10 = onActionElements[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
                        var actionElement = _step10.value;

                        var _ret3 = _loop3(actionElement);

                        if (_ret3 === "continue") continue;
                    }
                } catch (err) {
                    _didIteratorError10 = true;
                    _iteratorError10 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion10 && _iterator10.return) {
                            _iterator10.return();
                        }
                    } finally {
                        if (_didIteratorError10) {
                            throw _iteratorError10;
                        }
                    }
                }
            };

            var _arr = ["click", "change", "blur", "scroll", "contextmenu", "copy", "cut", "dblclick", "drag", "dragend", "dragenter", "dragleave", "dragover", "dragstart", "drop", "focus", "focusin", "focusout", "input", "invalid", "mousedown", "mouseenter", "mouseleave", "mouseover", "mouseout", "mouseup", "paste", "show", "toggle", "wheel", "keyup", "keydown", "keypress", "load"];

            for (var _i2 = 0; _i2 < _arr.length; _i2++) {
                var action = _arr[_i2];
                _loop2(action);
            }
        }
    }, {
        key: "format",
        value: function format(container) {
            //Control the DOM elements after rendering
        }
    }, {
        key: "refresh",
        value: function refresh() {
            Adhara.createView(this);
        }
    }, {
        key: "onDestroy",
        value: function onDestroy() {
            // This method will be called just before destroying the view
        }
    }, {
        key: "destroy",
        value: function destroy() {
            // This method will destroy the view
            this.onDestroy();
            this.trigger("ViewDestroyed");
            this.is_active = false;
            this.context.removeFromParent();
            try {
                this.getParentContainerElement().innerHTML = "";
            } catch (e) {/*Do nothing*/}
        }
    }, {
        key: "template",
        get: function get() {
            if (this.settings.t) return this.settings.t;
            if (Adhara.router.getCurrentPageName()) {
                return Adhara.router.getCurrentPageName().replace(/_/g, "-");
            } else {
                var className = this.constructor.name.toLowerCase();
                if (className.endsWith("view")) {
                    return className.slice(0, className.length - 4);
                } else {
                    return className;
                }
            }
        }
    }, {
        key: "parentContainer",
        get: function get() {
            return this._parentContainer;
        },
        set: function set(_) {
            this._parentContainer = _;
        }
    }, {
        key: "errorTemplate",
        get: function get() {
            return this.getCustomTemplate("error") || null;
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} structure to be rendered when data is being fetched
         * */

    }, {
        key: "fetchingDataTemplate",
        get: function get() {
            return this.getCustomTemplate("fetching_data") || "";
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} structure to be rendered when there is no data available
         * */

    }, {
        key: "noDataTemplate",
        get: function get() {
            return this.getCustomTemplate("no_data") || "";
        }
    }, {
        key: "isImmortal",
        get: function get() {
            return false;
        }
    }, {
        key: "r",
        get: function get() {
            return {
                d: Adhara.app.d
            };
        }
    }, {
        key: "contentContainer",
        get: function get() {
            throw new Error("implement this method");
        }

        /**
         * @function
         * @instance
         * @returns Array<AdharaView>
         * */

    }, {
        key: "subViews",
        get: function get() {
            return this._subViews;
        }
    }], [{
        key: "of",
        value: function of(context, tag) {
            return context.getViewFromRenderTree(this, tag);
        }
    }]);

    return AdharaView;
}(AdharaEventHandler);

/**------------------------------------------------------------------------------------------------------------------**/


var AdharaListView = function (_AdharaView) {
    _inherits(AdharaListView, _AdharaView);

    function AdharaListView(settings) {
        _classCallCheck(this, AdharaListView);

        var _this12 = _possibleConstructorReturn(this, (AdharaListView.__proto__ || Object.getPrototypeOf(AdharaListView)).call(this, settings));

        _this12._page_number = 1;
        _this12.searchText = null;
        _this12._rows = [];
        _this12.formatColumn = _this12.formatColumn.bind(_this12);
        return _this12;
    }

    _createClass(AdharaListView, [{
        key: "changeViewType",
        value: function changeViewType(event, data) {
            this._listType = data.viewtype;
            this.setState();
            this.onViewTypeChanged(this.listType);
        }
    }, {
        key: "onViewTypeChanged",
        value: function onViewTypeChanged(new_view_type) {}
        //Override as required


        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list structure
         * */

    }, {
        key: "formatColumn",


        /**
         * @param {Object} row_data - row data
         * @param {ColumnConfig} column - column config
         * @param {Number} row_index
         * */
        value: function formatColumn(row_data, column, row_index) {
            if (column.form_field) {
                this._subViews.push(new column.form_field(row_index + "-" + column.name, {
                    readonly: true,
                    label: false,
                    attributes: { class: "" },
                    mutator: this,
                    value: row_data[column.name]
                }));
                return "";
            }
            if (column.formatter) {
                return column.formatter(row_data, column);
            }
            return row_data[column.name];
        }
    }, {
        key: "previousPage",


        /**
         * @function
         * @instance
         * @description listens to the previous page request, and triggers the Page Change Listener
         * */
        value: function previousPage() {
            this.setPage(this.pageNumber - 1);
            this.pageChange();
        }

        /**
         * @function
         * @instance
         * @description listens to the next page request, and triggers the Page Change Listener
         * */

    }, {
        key: "nextPage",
        value: function nextPage() {
            this.setPage(this.pageNumber + 1);
            this.pageChange();
        }
    }, {
        key: "firstPage",
        value: function firstPage() {
            this.setPage(1);
            this.pageChange();
        }
    }, {
        key: "setPage",
        value: function setPage(page_number) {
            this._page_number = page_number;
        }

        /**
         * @function
         * @instance
         * @description will be called on page change
         * */

    }, {
        key: "pageChange",
        value: function pageChange() {
            this.fetch();
        }
    }, {
        key: "getPayload",
        value: function getPayload() {
            if (this.isPaginationRequired) {
                return Object.assign({}, _get(AdharaListView.prototype.__proto__ || Object.getPrototypeOf(AdharaListView.prototype), "getPayload", this).call(this), AdharaListView.getPagePayload(this.pageNumber));
            }
            return _get(AdharaListView.prototype.__proto__ || Object.getPrototypeOf(AdharaListView.prototype), "getPayload", this).call(this);
        }

        /**
         * example:
         * return Object
         * { attributes: {} }
         * */

    }, {
        key: "search",
        value: function search() {}
    }, {
        key: "onSearchToggle",
        value: function onSearchToggle(event, data) {
            if (event.target === document.activeElement) {
                event.target.classList.add("active");
            } else {
                event.target.classList.remove("active");
            }
        }
    }, {
        key: "onSearchCapture",
        value: function onSearchCapture(event, data) {
            if (event.target.value !== this.searchText) {
                this.searchText = event.target.value;
                this.onSearch(event.target.value);
            }
        }
    }, {
        key: "onSearch",
        value: function onSearch(text) {
            console.error("TODO Search is enabled for this list view.\n         So, implement onSearch... search text: \"" + text + "\"");
        }
    }, {
        key: "updateResults",
        value: function updateResults() {
            this.getParentContainerElement().querySelector(".list-contents").innerHTML = Adhara.app.renderTemplate(this.listTemplate, this);
        }
    }, {
        key: "format",
        value: function format(container) {
            if (this.searchText !== null) {
                var $search = container.querySelector("input[type=\"search\"]");
                $search.focus();
                $search.setSelectionRange(this.searchText.length, this.searchText.length);
            }
            _get(AdharaListView.prototype.__proto__ || Object.getPrototypeOf(AdharaListView.prototype), "format", this).call(this, container);
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-list";
        }
    }, {
        key: "allowedListTypes",
        get: function get() {
            return [];
        }
    }, {
        key: "defaultListType",
        get: function get() {
            if (this.allowedListTypes.length) {
                return this.allowedListTypes[0];
            }
            throw new Error("override `get listType`");
        }
    }, {
        key: "listType",
        get: function get() {
            if (this._listType) {
                return this._listType;
            }
            return this.defaultListType;
        }
    }, {
        key: "nextType",
        get: function get() {
            if (this.allowedListTypes.length > 1) {
                var currentIndex = this.allowedListTypes.indexOf(this.listType);
                return this.allowedListTypes[currentIndex + 1] || this.allowedListTypes[0];
            }
            return null;
        }
    }, {
        key: "listTemplate",
        get: function get() {
            return AdharaListView.DEFAULT_TEMPLATES[this.listType].listTemplate;
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate} template of the list header
         * */

    }, {
        key: "headerTemplate",
        get: function get() {
            return AdharaListView.DEFAULT_TEMPLATES[this.listType].headerTemplate;
        }

        /**
         * @method
         * @getter
         * @returns {HandlebarTemplate} template of a list item
         * */

    }, {
        key: "itemTemplate",
        get: function get() {
            return AdharaListView.DEFAULT_TEMPLATES[this.listType].itemTemplate;
        }
    }, {
        key: "name",
        get: function get() {
            return this.title;
        }

        /**
         * @method
         * @getter
         * @returns {String} Table title that is to be rendered
         * */

    }, {
        key: "title",
        get: function get() {
            return "";
        }

        /**
         * @method
         * @getter
         * @returns {Boolean} whether to enable pagination or not
         * */

    }, {
        key: "isPaginationRequired",
        get: function get() {
            return false;
        }

        /**
         * @typedef {Object} ColumnConfig
         * @property {String} name - column key for lookup in objects
         * @property {String} display_name - column name that is to be rendered
         * @property {Function} formatter - A data formatter function that will return formatted data
         * @property {FormField} form_field - render data as a readonly Form Field
         * @property {Boolean} trust_as_html - whether to render as text content or HTML content
         * @example
         * {
         *  key: "column_key",
         *  name: "Column Name",
         *  trust_as_html: false // whether to render HTML as buttons or not
         * }
         * */

        /**
         * @method
         * @getter
         * @returns {Array<ColumnConfig>} list of columns in the format of column configuration
         * */

    }, {
        key: "columns",
        get: function get() {
            return [];
        }
    }, {
        key: "rows",
        set: function set(_) {
            this._rows = _;
        },
        get: function get() {
            return this._rows;
        }
    }, {
        key: "noDataAvailable",
        get: function get() {
            return "No Data Available";
        }

        /**
         * @function
         * @getter
         * @returns {HandlebarTemplate}
         * @description this template contents will be rendered just above the table.
         * */

    }, {
        key: "menuTemplate",
        get: function get() {
            return "adhara-list-menu";
        }
    }, {
        key: "footerTemplate",
        get: function get() {
            return "adhara-list-footer";
        }

        /**
         * @function
         * @getter
         * @returns {Array<Object>} Buttons to be added in the header
         * @example
         * return [
         *  {
         *      title: "Add new element",
         *      attributes: {
         *          "class": "btn btn-primary",
         *          "data-onclick": "openForm",
         *      }
         *  }
         * ]
         * */

    }, {
        key: "buttons",
        get: function get() {
            return [];
        }

        /**
         * @function
         * @getter
         * @returns {Number} total row count in a page
         * */

    }, {
        key: "rowCount",
        get: function get() {
            return AdharaListView.rowCount;
        }

        /**
         * @function
         * @getter
         * @returns {Number} the start index of the current page
         * */

    }, {
        key: "pageNumber",
        get: function get() {
            return this._page_number;
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} if the current page is the first page
         * */

    }, {
        key: "isFirstPage",
        get: function get() {
            return this._page_number === 1;
        }

        /**
         * @function
         * @getter
         * @returns {Boolean} if the current page is the last page
         * */

    }, {
        key: "isLastPage",
        get: function get() {
            //Assumption: this.data is the only has the data for the current page
            return this.rows.length < this.rowCount;
        }
    }]);

    return AdharaListView;
}(AdharaView);

/**
 * @member {Number} default row count of all table instances. Default's 5.
 * Override to increase globally.
 * */


AdharaListView.rowCount = 5;

/**
 * @member {Function} Global function that implements pagePayload pattern for payload on pagination.
 * Recommended to override.
 * */
AdharaListView.getPagePayload = function (page) {
    return { page: page };
};

AdharaListView.VIEW_TYPES = {
    CARD_VIEW: "card",
    GRID_VIEW: "grid",
    TEMPLATE_VIEW: "template"
};

AdharaListView.DEFAULT_TEMPLATES = (_AdharaListView$DEFAU = {}, _defineProperty(_AdharaListView$DEFAU, AdharaListView.VIEW_TYPES.CARD_VIEW, {
    listTemplate: "adhara-card",
    itemTemplate: "adhara-card-content"
}), _defineProperty(_AdharaListView$DEFAU, AdharaListView.VIEW_TYPES.GRID_VIEW, {
    listTemplate: "adhara-list-grid"
}), _defineProperty(_AdharaListView$DEFAU, AdharaListView.VIEW_TYPES.TEMPLATE_VIEW, {
    listTemplate: "adhara-list-template",
    headerTemplate: "adhara-list-template-header",
    itemTemplate: "adhara-list-template-item"
}), _AdharaListView$DEFAU);
/**------------------------------------------------------------------------------------------------------------------**/

var AdharaMutableView = function (_AdharaView2) {
    _inherits(AdharaMutableView, _AdharaView2);

    /**
     * @constructor
     * @param {Object} [settings]
     * @param {String} [settings.name] - field name
     * @param {String} [settings.key=undefined] - Instance key
     * @param {String} settings.c - CSS Selector from parent view to place content of this class
     * @param {Object} settings.options - custom options to be passed
     * @param {String} [settings.fields=[]] - CSS Selector from parent view to place content of this class
     * */
    function AdharaMutableView() {
        var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, AdharaMutableView);

        settings.key = settings.key || settings.name;

        var _this13 = _possibleConstructorReturn(this, (AdharaMutableView.__proto__ || Object.getPrototypeOf(AdharaMutableView)).call(this, settings));

        _this13.parentContainer = _this13.parentContainer || "[data-field=\"" + settings.name + "\"]";
        _this13._name = settings.name;
        _this13._fields = settings.fields;
        _this13.mutator = null;
        _this13._registerEvents(["Saved", "Cancelled"]);
        _this13.has_field_errors = false;
        return _this13;
    }

    _createClass(AdharaMutableView, [{
        key: "onInit",
        value: function onInit() {
            this._mutable_data = {};
            this.fieldMap = {};
            this.rendered_fields = [];
        }
    }, {
        key: "isFormField",
        value: function isFormField(f) {
            return f instanceof FormField || f instanceof AdharaMutableView;
        }
    }, {
        key: "getFieldValue",


        /**
         * @returns {*} Field data
         * */
        value: function getFieldValue(field_name) {
            var d = getValueFromJSON(this.mutableData, this.fieldMap[field_name].name);
            if (d === undefined) {
                d = this.fieldMap[field_name].value;
            }
            return d;
        }
    }, {
        key: "setFieldValue",


        /**
         * @returns {*} Field data
         * */
        value: function setFieldValue(field_name, value) {
            this.getField(field_name).changeData(value);
        }

        /**
         * @deprecated use getMutableData instead.
         * */

    }, {
        key: "getFormData",
        value: function getFormData() {
            var hasFiles = false;
            var _iteratorNormalCompletion11 = true;
            var _didIteratorError11 = false;
            var _iteratorError11 = undefined;

            try {
                for (var _iterator11 = this.rendered_fields[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
                    var rendered_field = _step11.value;

                    if (rendered_field instanceof InputField && rendered_field.config.input_type === InputField.FILE) {
                        hasFiles = true;
                    }
                }
            } catch (err) {
                _didIteratorError11 = true;
                _iteratorError11 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion11 && _iterator11.return) {
                        _iterator11.return();
                    }
                } finally {
                    if (_didIteratorError11) {
                        throw _iteratorError11;
                    }
                }
            }

            if (hasFiles) {
                var formData = new FormData();
                var _iteratorNormalCompletion12 = true;
                var _didIteratorError12 = false;
                var _iteratorError12 = undefined;

                try {
                    for (var _iterator12 = Object.entries(data)[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                        var _ref18 = _step12.value;

                        var _ref19 = _slicedToArray(_ref18, 2);

                        var key = _ref19[0];
                        var value = _ref19[1];

                        formData.append(key, value);
                    }
                } catch (err) {
                    _didIteratorError12 = true;
                    _iteratorError12 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion12 && _iterator12.return) {
                            _iterator12.return();
                        }
                    } finally {
                        if (_didIteratorError12) {
                            throw _iteratorError12;
                        }
                    }
                }

                return formData;
            }
        }
    }, {
        key: "getFieldsForValidation",
        value: function getFieldsForValidation() {
            return this.rendered_fields;
        }
    }, {
        key: "validate",
        value: function validate() {
            var update_state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            this.clearErrors();
            this.has_field_errors = false;
            var _iteratorNormalCompletion13 = true;
            var _didIteratorError13 = false;
            var _iteratorError13 = undefined;

            try {
                for (var _iterator13 = this.getFieldsForValidation()[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
                    var field = _step13.value;

                    field.validate();
                    this.has_field_errors = this.has_field_errors || !!field.hasFieldErrors;
                }
            } catch (err) {
                _didIteratorError13 = true;
                _iteratorError13 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion13 && _iterator13.return) {
                        _iterator13.return();
                    }
                } finally {
                    if (_didIteratorError13) {
                        throw _iteratorError13;
                    }
                }
            }

            update_state && this.setState();
        }
    }, {
        key: "clearErrors",
        value: function clearErrors() {
            var update_state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
            var _iteratorNormalCompletion14 = true;
            var _didIteratorError14 = false;
            var _iteratorError14 = undefined;

            try {
                for (var _iterator14 = this.rendered_fields[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
                    var field = _step14.value;

                    field.clearErrors();
                }
            } catch (err) {
                _didIteratorError14 = true;
                _iteratorError14 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion14 && _iterator14.return) {
                        _iterator14.return();
                    }
                } finally {
                    if (_didIteratorError14) {
                        throw _iteratorError14;
                    }
                }
            }

            update_state && this.setState();
        }
    }, {
        key: "getMutatedData",
        value: function getMutatedData() {
            this.validate();
            var hasFiles = this.hasFileFields;
            var data = hasFiles ? new FormData() : {};
            var _iteratorNormalCompletion15 = true;
            var _didIteratorError15 = false;
            var _iteratorError15 = undefined;

            try {
                for (var _iterator15 = this.rendered_fields[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
                    var field = _step15.value;

                    if (field instanceof FormField && field.isReadOnly) continue;
                    var serialized_value = field instanceof AdharaMutableView ? field.getMutatedData() : field.serialize();
                    if (!this.ignoreNulls || serialized_value !== null) {
                        if (hasFiles) {
                            if (field.config.input_type === InputField.FILE && field.fieldAttributes.multiple === "true") {
                                if (serialized_value) {
                                    var _iteratorNormalCompletion16 = true;
                                    var _didIteratorError16 = false;
                                    var _iteratorError16 = undefined;

                                    try {
                                        for (var _iterator16 = serialized_value[Symbol.iterator](), _step16; !(_iteratorNormalCompletion16 = (_step16 = _iterator16.next()).done); _iteratorNormalCompletion16 = true) {
                                            var file = _step16.value;

                                            data.append(field.name, file);
                                        }
                                    } catch (err) {
                                        _didIteratorError16 = true;
                                        _iteratorError16 = err;
                                    } finally {
                                        try {
                                            if (!_iteratorNormalCompletion16 && _iterator16.return) {
                                                _iterator16.return();
                                            }
                                        } finally {
                                            if (_didIteratorError16) {
                                                throw _iteratorError16;
                                            }
                                        }
                                    }
                                }
                            } else {
                                if (typeof serialized_value !== "string") {
                                    serialized_value = JSON.stringify(serialized_value);
                                }
                                data.append(field.name, serialized_value);
                            }
                        } else {
                            setValueToJson(data, field.name, serialized_value);
                        }
                    }
                }
            } catch (err) {
                _didIteratorError15 = true;
                _iteratorError15 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion15 && _iterator15.return) {
                        _iterator15.return();
                    }
                } finally {
                    if (_didIteratorError15) {
                        throw _iteratorError15;
                    }
                }
            }

            return data;
        }
    }, {
        key: "getField",
        value: function getField(field_name) {
            return this.fieldMap[field_name];
        }

        /**
         * @getter
         * @param {*} data to be submitted destination
         * @returns {Promise} response on submission.
         * */

    }, {
        key: "submitData",
        value: function () {
            var _ref20 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(data) {
                return regeneratorRuntime.wrap(function _callee11$(_context13) {
                    while (1) {
                        switch (_context13.prev = _context13.next) {
                            case 0:
                                throw new Error("Must override `submitData`");

                            case 1:
                            case "end":
                                return _context13.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function submitData(_x29) {
                return _ref20.apply(this, arguments);
            }

            return submitData;
        }()
    }, {
        key: "enhanceFieldForSubViewRendering",


        /**
         * @param {FormField} field
         * */
        value: function enhanceFieldForSubViewRendering(field) {
            this.fieldMap[field.name] = field;
            field.mutator = this;
            var _v = this.getFieldValue(field.name);
            if (field instanceof AdharaMutableView) {
                if (_v && _v instanceof Array && _v.length) {
                    field.mutableData = _v;
                }
            } else {
                field.value = _v;
            }
            return field;
        }

        /**
         * @returns {Array<FormField>}
         * */

    }, {
        key: "prepareFieldsForRendering",
        value: function prepareFieldsForRendering() {
            var _this14 = this;

            var fields = this.mutableFields.map(function (_) {
                return _this14.enhanceFieldForSubViewRendering(_);
            });
            var _iteratorNormalCompletion17 = true;
            var _didIteratorError17 = false;
            var _iteratorError17 = undefined;

            try {
                for (var _iterator17 = fields[Symbol.iterator](), _step17; !(_iteratorNormalCompletion17 = (_step17 = _iterator17.next()).done); _iteratorNormalCompletion17 = true) {
                    var field = _step17.value;

                    if (field instanceof FormField && field.dependsOn.length) {
                        var _iteratorNormalCompletion18 = true;
                        var _didIteratorError18 = false;
                        var _iteratorError18 = undefined;

                        try {
                            for (var _iterator18 = field.dependsOn[Symbol.iterator](), _step18; !(_iteratorNormalCompletion18 = (_step18 = _iterator18.next()).done); _iteratorNormalCompletion18 = true) {
                                var dependent_field_name = _step18.value;

                                this.getField(dependent_field_name).addToDependentFields(field);
                            }
                        } catch (err) {
                            _didIteratorError18 = true;
                            _iteratorError18 = err;
                        } finally {
                            try {
                                if (!_iteratorNormalCompletion18 && _iterator18.return) {
                                    _iterator18.return();
                                }
                            } finally {
                                if (_didIteratorError18) {
                                    throw _iteratorError18;
                                }
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError17 = true;
                _iteratorError17 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion17 && _iterator17.return) {
                        _iterator17.return();
                    }
                } finally {
                    if (_didIteratorError17) {
                        throw _iteratorError17;
                    }
                }
            }

            return fields;
        }
    }, {
        key: "onMutableDataChanged",
        value: function onMutableDataChanged() {
            //    Can override if required...
        }
    }, {
        key: "onFieldValueChanged",
        value: function onFieldValueChanged(field_name, value, old_value) {
            //    can override as required
        }
    }, {
        key: "_onFieldValueChanged",
        value: function _onFieldValueChanged(field_name, value, old_value) {
            var _ref21 = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
                event = _ref21.event,
                data = _ref21.data;

            setValueToJson(this._mutable_data, this.fieldMap[field_name].name, value);
            this.onFieldValueChanged(field_name, value, old_value);
            this.onMutableDataChanged();
        }
    }, {
        key: "name",
        get: function get() {
            return this._name || "";
        }
    }, {
        key: "fullName",
        get: function get() {
            return (this.mutator && this.mutator.name ? this.mutator.name + "." : "") + this.name;
        }
    }, {
        key: "safeName",
        get: function get() {
            return this.name.replace('.', '-');
        }
    }, {
        key: "key",
        get: function get() {
            return this.name;
        }

        /**
         * @example
         * get fields(){
         *  return [
         *      InputField("question", {}, {}),
         *      TextArea("answer", {}, {})
         *  ];
         * }
         * returns {Array<FormField>}
         * */

    }, {
        key: "fields",
        get: function get() {
            return this._fields || [];
        }
    }, {
        key: "mutableFields",
        get: function get() {
            return this.fields.filter(this.isFormField);
        }
    }, {
        key: "mutableData",
        set: function set(_) {
            this._mutable_data = _;
        },
        get: function get() {
            return this._mutable_data;
        }
    }, {
        key: "ignoreNulls",
        get: function get() {
            return false;
        }
    }, {
        key: "hasFileFields",
        get: function get() {
            var _iteratorNormalCompletion19 = true;
            var _didIteratorError19 = false;
            var _iteratorError19 = undefined;

            try {
                for (var _iterator19 = this.rendered_fields[Symbol.iterator](), _step19; !(_iteratorNormalCompletion19 = (_step19 = _iterator19.next()).done); _iteratorNormalCompletion19 = true) {
                    var rendered_field = _step19.value;

                    if (rendered_field instanceof InputField && rendered_field.config.input_type === InputField.FILE) {
                        return true;
                    }
                }
            } catch (err) {
                _didIteratorError19 = true;
                _iteratorError19 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion19 && _iterator19.return) {
                        _iterator19.return();
                    }
                } finally {
                    if (_didIteratorError19) {
                        throw _iteratorError19;
                    }
                }
            }

            return false;
        }
    }, {
        key: "hasFieldErrors",
        get: function get() {
            return this.has_field_errors;
        }
    }, {
        key: "isExclusivelyEditable",
        get: function get() {
            if (this.mutator) {
                return this.mutator.isExclusivelyEditable;
            }
            return true;
        }
    }, {
        key: "subViews",
        get: function get() {
            var fields = this.prepareFieldsForRendering();
            this.rendered_fields = fields.slice();
            return fields;
        }
    }]);

    return AdharaMutableView;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaFormView = function (_AdharaMutableView) {
    _inherits(AdharaFormView, _AdharaMutableView);

    function AdharaFormView() {
        _classCallCheck(this, AdharaFormView);

        return _possibleConstructorReturn(this, (AdharaFormView.__proto__ || Object.getPrototypeOf(AdharaFormView)).apply(this, arguments));
    }

    _createClass(AdharaFormView, [{
        key: "onSuccess",


        /**
         * @function
         * @instance
         * @param {Object} data - Response Object
         * @description This method will be called on forms's POST/PUT call success
         * */
        value: function onSuccess(data) {
            Toast.success("Success");
        }

        /**
         * @function
         * @instance
         * @param {Object} error - Error Response Object
         * @description This method will be called on forms's POST/PUT failure
         * */

    }, {
        key: "onError",
        value: function onError(error) {
            Toast.error(error);
        }

        /**
         * @function
         * @instance
         * @param {Array<String>} errors - Error thrown from validator
         * */

    }, {
        key: "onValidationError",
        value: function onValidationError() {
            Toast.error("This form has errors");
        }

        /**
         * @function
         * @instance
         * @param {Object} data - Form data
         * @returns {Object} Modified/Formatted data
         * */

    }, {
        key: "formatData",
        value: function formatData(data) {
            return data;
        }

        /**
         * @getter
         * @instance
         * @returns {HTMLFormElement} HTML node which represents the Form element
         * */

    }, {
        key: "updateFormState",
        value: function updateFormState(submitting) {
            try {
                this.formElement.submitting = submitting;
                this.handleSubmitButton();
                if (!submitting) {
                    this.reSubmitIfRequired();
                }
            } catch (e) {
                // Do nothing
            }
        }
    }, {
        key: "handleSubmitButton",
        value: function handleSubmitButton() {
            if (this.duplicateSubmissions) {
                return;
            }
            var submit_button = this.submitButton;
            if (!submit_button) {
                console.warn("Unable to discover 'Submit button'. Duplicate submission are not handled.");
                return;
            }
            if (this.formElement.submitting) {
                submit_button.dataset.tosubmit = submit_button.innerHTML;
                submit_button.innerHTML = submit_button.dataset.inprogress || Adhara.i18n.getValue("form.processing", [], "") || submit_button.dataset.tosubmit;
                submit_button.disabled = true;
            } else {
                submit_button.dataset.inprogress = submit_button.innerHTML;
                submit_button.innerHTML = submit_button.dataset.tosubmit;
                submit_button.disabled = false;
            }
        }
    }, {
        key: "executeDataSubmission",
        value: function () {
            var _ref22 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(apiData) {
                return regeneratorRuntime.wrap(function _callee12$(_context14) {
                    while (1) {
                        switch (_context14.prev = _context14.next) {
                            case 0:
                                _context14.next = 2;
                                return this.submitData(apiData);

                            case 2:
                                this.trigger("Saved", apiData);

                            case 3:
                            case "end":
                                return _context14.stop();
                        }
                    }
                }, _callee12, this);
            }));

            function executeDataSubmission(_x31) {
                return _ref22.apply(this, arguments);
            }

            return executeDataSubmission;
        }()

        /*getFormData(){
            let form = this.formElement;
            let fileElements = Array.prototype.slice.apply(form.querySelectorAll('input[type="file"]')).filter(fileElement => !fileElement.disabled);
            if(this.handleFileUploads && !!fileElements.length){ // ~ if(hasFiles){
                return new FormData(form);
            }else{
                let formData = jQuery(form).serializeArray();
                let apiData = {};
                jQuery.each(formData, function (i, fieldData) {
                    apiData[fieldData.name] = fieldData.value;
                });
                let checkboxes = form.querySelectorAll('[type=checkbox]');
                for(let i=0; i<checkboxes.length; i++){
                    apiData[checkboxes[i].name] = checkboxes[i].checked;
                }
                return apiData;
            }
        }*/

        /**
         * @getter
         * @private
         * @description handle making API call on behalf of the form
         * */

    }, {
        key: "_handleForm",
        value: function () {
            var _ref23 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
                var form, apiData;
                return regeneratorRuntime.wrap(function _callee13$(_context15) {
                    while (1) {
                        switch (_context15.prev = _context15.next) {
                            case 0:
                                form = this.formElement;

                                if (form.checkValidity()) {
                                    _context15.next = 3;
                                    break;
                                }

                                return _context15.abrupt("return", form.reportValidity());

                            case 3:
                                if (!form.submitting) {
                                    _context15.next = 5;
                                    break;
                                }

                                return _context15.abrupt("return", false);

                            case 5:
                                apiData = this.getMutatedData();

                                if (!this.has_field_errors) {
                                    _context15.next = 9;
                                    break;
                                }

                                this.onValidationError();
                                return _context15.abrupt("return");

                            case 9:
                                apiData = this.formatData(apiData);
                                this.updateFormState(true);
                                _context15.prev = 11;
                                _context15.next = 14;
                                return this.executeDataSubmission(apiData);

                            case 14:
                                _context15.next = 19;
                                break;

                            case 16:
                                _context15.prev = 16;
                                _context15.t0 = _context15["catch"](11);
                                return _context15.abrupt("return", false);

                            case 19:
                                _context15.prev = 19;

                                this.updateFormState(false);
                                return _context15.finish(19);

                            case 22:
                                return _context15.abrupt("return", true);

                            case 23:
                            case "end":
                                return _context15.stop();
                        }
                    }
                }, _callee13, this, [[11, 16, 19, 22]]);
            }));

            function _handleForm() {
                return _ref23.apply(this, arguments);
            }

            return _handleForm;
        }()
    }, {
        key: "_format",
        value: function _format(container) {
            var _this16 = this;

            _get(AdharaFormView.prototype.__proto__ || Object.getPrototypeOf(AdharaFormView.prototype), "_format", this).call(this, container);
            if (this.error) return;
            if (this.formElement.dataset['_ae_'] === "true") return;
            this.formElement.dataset['_ae_'] = "true";
            this.formElement.addEventListener("submit", function (event) {
                event.preventDefault();
                _this16.submit();
            });
            this.formElement.setAttribute('novalidate', '');
            this.cancelButton && this.cancelButton.addEventListener("click", function (event) {
                _this16.trigger("Cancelled");
            });
        }
    }, {
        key: "reSubmitIfRequired",
        value: function reSubmitIfRequired() {
            var _this17 = this;

            if (this.duplicateSubmissions && this.re_submit) {
                this._handleForm().then(function (_) {
                    return _this17.re_submit = !_;
                });
            }
        }
    }, {
        key: "submit",
        value: function submit() {
            var _this18 = this;

            this._handleForm().then(function (_) {
                return _this18.re_submit = !_;
            });
        }
    }, {
        key: "duplicateSubmissions",


        /**
         * @getter
         * @instance
         * @returns {Boolean} whether duplicate submissions are to be allowed
         * */
        get: function get() {
            return false;
        }

        /**
         * @getter
         * @instance
         * @returns {Boolean} whether to clear form on successful submission or not
         * */

    }, {
        key: "clearFormOnSuccess",
        get: function get() {
            return this.formElement.getAttribute('form-clear') === "true";
        }
    }, {
        key: "formElement",
        get: function get() {
            if (!this._formElement || !document.body.contains(this._formElement)) {
                this._formElement = this.getParentContainerElement().querySelector("form");
            }
            if (!this._formElement) {
                throw new Error("No from element discovered!");
            }
            return this._formElement;
        }

        /**
         * @getter
         * @instance
         * @description whether to handle file uploads or not!
         * */

    }, {
        key: "handleFileUploads",
        get: function get() {
            return true;
        }
    }, {
        key: "submitButton",
        get: function get() {
            return this.formElement.querySelector('[type="submit"]');
        }
    }, {
        key: "cancelButton",
        get: function get() {
            return this.formElement.querySelector('[data-cancel="true"]');
        }
    }]);

    return AdharaFormView;
}(AdharaMutableView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaDetailView = function (_AdharaMutableView2) {
    _inherits(AdharaDetailView, _AdharaMutableView2);

    function AdharaDetailView() {
        _classCallCheck(this, AdharaDetailView);

        return _possibleConstructorReturn(this, (AdharaDetailView.__proto__ || Object.getPrototypeOf(AdharaDetailView)).apply(this, arguments));
    }

    _createClass(AdharaDetailView, [{
        key: "enhanceFieldForSubViewRendering",
        value: function enhanceFieldForSubViewRendering(field) {
            field = _get(AdharaDetailView.prototype.__proto__ || Object.getPrototypeOf(AdharaDetailView.prototype), "enhanceFieldForSubViewRendering", this).call(this, field);
            field.readonly = true;
            return field;
        }
    }, {
        key: "isExclusivelyEditable",
        get: function get() {
            return false;
        }
    }]);

    return AdharaDetailView;
}(AdharaMutableView);
/**------------------------------------------------------------------------------------------------------------------**/


var FormField = function (_AdharaView3) {
    _inherits(FormField, _AdharaView3);

    /**
     * @typedef {Function} OnFieldValueChangeCallback
     * @param {*} old_value - old value
     * @param {*} new_value - new value
     * @param {Object} event_data - data for the event.
     * @param {String} event_data.initiator - sender tag who is initiating this event self and external will be set by default
     * */

    /**
     * @typedef {Function} FieldValidator
     * @param {*} value - value
     * @param {AdharaMutableView} mutator - Instance of Mutator
     * */

    /**
     * @constructor
     * @param {String} name - field name
     * @param {Object} [config={}]
     * @param {*} [config.value=undefined] - A value consumable by form field. A string for input type text and a number for input type number
     * @param {Map} [config.label_attributes={}]
     * @param {Array} [config.label_properties=[]]
     * @param {Map} [config.attributes={}]
     * @param {Array} [config.properties=[]] contentContainer
     * @param {String} [config.help_text=null]
     * @param {Boolean} [config.readonly=false]
     * @param {String} [config.input_type='']
     * @param {String} [config.display_name=<i18n of form_name.field_name.label>] - display name of the field
     * @param {boolean} [config.nullable=true] - whether the field is nullable or not
     * @param {boolean} [config.editable=true] - whether the field is editable or not. Used for display only purposes in details page, etc
     * @param {Function} [config.nullable=true] - whether the field is nullable or not
     * @param {FieldValidator} [config.validator=null] - Field validator
     * @param {Array<String>} [config.depends_on=null] - field depends on another field
     * @param {OnFieldValueChangeCallback} [config.onChange=null] - Callback function for on change
     * @param {OnFieldValueChangeCallback} [config.onDependentParentChanged=null] - Callback function for on dependent change
     * @param {Object} [settings]
     * @param {String} [settings.key=undefined] - Instance key
     * @param {String} settings.c - CSS Selector from parent view to place content of this class
     * */
    function FormField(name) {
        var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var settings = arguments[2];

        _classCallCheck(this, FormField);

        settings = settings || {};

        var _this20 = _possibleConstructorReturn(this, (FormField.__proto__ || Object.getPrototypeOf(FormField)).call(this, settings));

        _this20.name = name;
        _this20._value = config.value;
        _this20.readonly = config.readonly || false;
        _this20.config = config || {};
        _this20.field_errors = [];

        /**
         * @field {Array<FormField>} dependent form field instances
         * */
        _this20._dependent_fields = [];
        /**
         * {AdharaFormView} form
         * */
        _this20.mutator = _this20.config.mutator || null;
        return _this20;
    }

    _createClass(FormField, [{
        key: "clone",
        value: function clone(key) {
            return new this.constructor(this.name, Object.assign({}, cloneObject(this.config)), Object.assign({}, cloneObject(this.settings), { key: key }));
        }
    }, {
        key: "validate",
        value: function validate() {
            var _field_errors;

            if (this.isRequired && this.isEmpty) {
                this.field_errors.push(Adhara.i18n.get(this.mutatorName + "." + this.name + ".error", 'This field is required'));
            }
            (_field_errors = this.field_errors).push.apply(_field_errors, _toConsumableArray(this.config.validator && this.config.validator(this.value, this.mutator) || []));
            this.refreshErrors();
        }
    }, {
        key: "refreshErrors",
        value: function refreshErrors() {
            var errors = this.querySelector('.invalid-feedback');
            if (this.field_errors.length) {
                errors.classList.add("d-none");
            } else {
                errors.classList.remove("d-none");
            }
            errors.innerHTML = this.field_errors.join(", ");
        }
    }, {
        key: "clearErrors",
        value: function clearErrors() {
            this.field_errors = [];
            this.refreshErrors();
        }

        /**
         * @getter
         * @returns {HandlebarTemplate} - template for the field
         * */

    }, {
        key: "addToDependentFields",
        value: function addToDependentFields(field) {
            if (this._dependent_fields.indexOf(field) === -1) {
                this._dependent_fields.push(field);
            }
        }

        /**
         * @returns {HTMLElement} dom element of the field that is rendered by the fieldTemplate
         * */

    }, {
        key: "getField",
        value: function getField() {
            return document.querySelector(this.parentContainer + " [name='" + this.safeName + "']");
        }
    }, {
        key: "queryValue",
        value: function queryValue() {
            return this.getField().value;
        }
    }, {
        key: "queryRaw",
        value: function queryRaw() {
            return this.queryValue();
        }
    }, {
        key: "onDataChange",
        value: function onDataChange(event, event_data) {
            this.handleDataChange(this.queryValue(), this.value, event_data);
        }
    }, {
        key: "handleDataChange",
        value: function handleDataChange(value, old_value) {
            var event_data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

            event_data.initiator = event_data.initiator || "self";
            if (this.config.onChange) {
                this.config.onChange(value, old_value, event_data);
            }
            var _iteratorNormalCompletion20 = true;
            var _didIteratorError20 = false;
            var _iteratorError20 = undefined;

            try {
                for (var _iterator20 = this._dependent_fields[Symbol.iterator](), _step20; !(_iteratorNormalCompletion20 = (_step20 = _iterator20.next()).done); _iteratorNormalCompletion20 = true) {
                    var dependent_field = _step20.value;

                    var d_event_data = Object.assign({}, event_data, { initiator: "dependency" });
                    if (dependent_field.config.onDependentParentChanged) {
                        dependent_field.config.onDependentParentChanged(value, old_value, d_event_data);
                    } else if (event_data.initiator === "self") {
                        dependent_field.changeData(null, d_event_data);
                    }
                }
            } catch (err) {
                _didIteratorError20 = true;
                _iteratorError20 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion20 && _iterator20.return) {
                        _iterator20.return();
                    }
                } finally {
                    if (_didIteratorError20) {
                        throw _iteratorError20;
                    }
                }
            }

            this.value = value;
            if (this.field_errors.length) this.validate();
            this.mutator._onFieldValueChanged(this.name, this.value, old_value, event_data);
        }
    }, {
        key: "changeData",
        value: function changeData(value) {
            var event_data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            event_data.initiator = event_data.initiator || "external";
            this.handleDataChange(value, this.value, event_data);
            this.setState();
        }
    }, {
        key: "serialize",
        value: function serialize() {
            if (this.value === undefined) this.value = this.queryValue();
            return this.value;
        }
    }, {
        key: "parentContainer",
        get: function get() {
            return _get(FormField.prototype.__proto__ || Object.getPrototypeOf(FormField.prototype), "parentContainer", this) || "[data-field=\"" + this.name + "\"]";
        },
        set: function set(_) {
            _set(FormField.prototype.__proto__ || Object.getPrototypeOf(FormField.prototype), "parentContainer", _, this);
        }
    }, {
        key: "mutator",
        set: function set(_) {
            this._mutator = _;
        },
        get: function get() {
            return this._mutator;
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-form-fields/index";
        }
    }, {
        key: "inputType",
        get: function get() {
            return this.config.input_type;
        }
    }, {
        key: "labelTemplate",
        get: function get() {
            return 'adhara-form-fields/label';
        }
    }, {
        key: "prependTemplate",
        get: function get() {
            return this.config.prependTemplate;
        }
    }, {
        key: "appendTemplate",
        get: function get() {
            return this.config.appendTemplate;
        }
    }, {
        key: "fieldErrorsTemplate",
        get: function get() {
            return 'adhara-form-fields/error';
        }
    }, {
        key: "fieldTemplate",
        get: function get() {
            if (this.isEditable) return this.editableFieldTemplate;
            return this.nonEditableFieldTemplate;
        }
    }, {
        key: "editableFieldTemplate",
        get: function get() {}
    }, {
        key: "nonEditableFieldTemplate",
        get: function get() {
            return this.value || "-";
        }
    }, {
        key: "helpTemplate",
        get: function get() {
            return 'adhara-form-fields/help';
        }
    }, {
        key: "safeName",
        get: function get() {
            return this.name.replace(/\./g, '-');
        }
    }, {
        key: "showLabel",
        get: function get() {
            return this.config.label !== false;
        }
    }, {
        key: "isRequired",
        get: function get() {
            return this.config.required || this.fieldProperties.indexOf("required") !== -1;
        }
    }, {
        key: "isMultiple",
        get: function get() {
            return this.config.multiple || this.fieldProperties.indexOf("multiple") !== -1;
        }
    }, {
        key: "isReadOnly",
        get: function get() {
            return this.config.readonly || this.fieldProperties.indexOf("readonly") !== -1;
        }
    }, {
        key: "displayName",
        get: function get() {
            return this.config.display_name || Adhara.i18n.get(this.mutatorName + "." + this.name + ".label");
        }
    }, {
        key: "labelAttributes",
        get: function get() {
            var _ = Object.assign({
                for: this.safeName
            }, this.config.label_attributes);
            if (this.isRequired) {
                _.class = _.class || [];
                _.class.push("required");
            }
            return _;
        }
    }, {
        key: "labelProperties",
        get: function get() {
            return (this.config.label_properties || []).slice();
        }
    }, {
        key: "placeholder",
        set: function set(_) {
            this.config.placeholder = _;
        },
        get: function get() {
            //placeholder can be disabled by setting config.placeholder to false to by enabling label
            var _p = "";
            if (this.config.placeholder || !this.showLabel && this.config.placeholder !== false) {
                if (typeof this.config.placeholder === "string") {
                    _p = this.config.placeholder;
                } else {
                    _p = Adhara.i18n.get([this.mutatorName, this.name, 'placeholder'].filter(function (_) {
                        return _;
                    }).join('.'));
                }
            }
            return this.isRequired && _p ? _p + " *" : _p;
        }
    }, {
        key: "mutatorName",
        get: function get() {
            return this.mutator ? this.mutator.fullName : '';
        }
    }, {
        key: "hasFieldErrors",
        get: function get() {
            return this.field_errors.length;
        }
    }, {
        key: "defaultFieldAttributes",
        get: function get() {
            if (this.isEditable) return { class: "form-control" };
            return {};
        }
    }, {
        key: "fieldAttributes",
        get: function get() {
            return Object.assign({
                id: this.safeName,
                name: this.safeName,
                placeholder: this.placeholder || ""
                // title: this.value?this.value:this.placeholder
            }, this.config.attributes || this.defaultFieldAttributes);
        }
    }, {
        key: "fieldProperties",
        get: function get() {
            var _p = (this.config.properties || []).slice();
            if (_p.indexOf("required") !== -1) _p.splice(_p.indexOf("required"), 1);
            if (this.config.multiple) _p.push("multiple");
            if (this.config.readonly) _p.push("readonly");
            return _p;
        }
    }, {
        key: "helpText",
        get: function get() {
            return this.config.help_text;
        }
    }, {
        key: "isNullable",
        get: function get() {
            return this.config.nullable === true;
        }
    }, {
        key: "isEditable",
        get: function get() {
            return this.config.editable === undefined && this.mutator.isExclusivelyEditable;
        }
    }, {
        key: "dependsOn",
        get: function get() {
            return this.config.depends_on || [];
        }
    }, {
        key: "isEmpty",
        get: function get() {
            if (typeof this.value === "boolean") return false;
            if (this.value instanceof Array) return !this.value.length;
            return !this.value;
        }
    }, {
        key: "value",
        set: function set(_) {
            this._value = _;
        },
        get: function get() {
            return this._value;
        }
    }]);

    return FormField;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var InputField = function (_FormField) {
    _inherits(InputField, _FormField);

    function InputField() {
        _classCallCheck(this, InputField);

        return _possibleConstructorReturn(this, (InputField.__proto__ || Object.getPrototypeOf(InputField)).apply(this, arguments));
    }

    _createClass(InputField, [{
        key: "queryValue",
        value: function queryValue(target) {
            var _ = _get(InputField.prototype.__proto__ || Object.getPrototypeOf(InputField.prototype), "queryValue", this).call(this, target);
            if (_.trim() === "") {
                return null;
            }
            var converter = 'query_' + this.inputType;
            return this[converter] && this[converter](_, target || this.getField()) || _;
        }
    }, {
        key: "query_number",
        value: function query_number(value, field) {
            return +value;
        }
    }, {
        key: "query_checbox",
        value: function query_checbox(value, field) {
            return field.checked;
        }
    }, {
        key: "query_file",
        value: function query_file(value, field) {
            return this.fieldAttributes.multiple ? field.files : field.files[0];
        }
    }, {
        key: "editableFieldTemplate",
        get: function get() {
            return "adhara-form-fields/input";
        }
    }, {
        key: "inputType",
        get: function get() {
            return this.config.input_type || "text";
        }
    }]);

    return InputField;
}(FormField);

InputField.BUTTON = "button";
InputField.CHECKBOX = "checkbox";
InputField.COLOR = "color";
InputField.DATE = "date";

InputField.DATETIME_LOCAL = "datetime-local";
InputField.EMAIL = "email";
InputField.FILE = "file";
InputField.IMAGE = "image";
InputField.MONTH = "month";
InputField.NUMBER = "number";

InputField.PASSWORD = "password";

InputField.RADIO = "radio";
InputField.RANGE = "range";
InputField.RESET = "reset";

InputField.SEARCH = "search";
InputField.SUBMIT = "submit";

InputField.TEL = "tel";
InputField.TEXT = "text";
InputField.TIME = "time";
InputField.URL = "url";
InputField.WEEK = "week";
/**------------------------------------------------------------------------------------------------------------------**/

var TextArea = function (_FormField2) {
    _inherits(TextArea, _FormField2);

    function TextArea() {
        _classCallCheck(this, TextArea);

        return _possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).apply(this, arguments));
    }

    _createClass(TextArea, [{
        key: "editableFieldTemplate",
        get: function get() {
            return "adhara-form-fields/textarea";
        }
    }]);

    return TextArea;
}(FormField);
/**------------------------------------------------------------------------------------------------------------------**/


var SelectField = function (_FormField3) {
    _inherits(SelectField, _FormField3);

    function SelectField() {
        _classCallCheck(this, SelectField);

        return _possibleConstructorReturn(this, (SelectField.__proto__ || Object.getPrototypeOf(SelectField)).apply(this, arguments));
    }

    _createClass(SelectField, [{
        key: "onInit",
        value: function onInit() {
            this.isSelectedValue = this.isSelectedValue.bind(this);
        }
    }, {
        key: "format",
        value: function format(container) {
            if (this.isEditable) this.value = this.queryValue();
        }
    }, {
        key: "isSelectedValue",
        value: function isSelectedValue(rendering_value) {
            if (!this.value) return !rendering_value;
            if (this.isMultiple) {
                return this.value.indexOf(rendering_value && rendering_value.toString()) !== -1;
            }
            return rendering_value === this.value;
        }
    }, {
        key: "getSelectedValue",
        value: function getSelectedValue(htmlValue) {
            return htmlValue === "" ? null : htmlValue;
        }
    }, {
        key: "queryRaw",
        value: function queryRaw(target) {
            var _this24 = this;

            var $f = target || this.getField();
            if (this.isMultiple) {
                return [].concat(_toConsumableArray($f.selectedOptions)).map(function (_) {
                    return { value: _this24.getSelectedValue(_.value), display: _.innerText };
                });
            }
            return {
                value: this.getSelectedValue($f.value),
                display: $f.children[$f.selectedIndex].innerText
            };
        }
    }, {
        key: "queryValue",
        value: function queryValue(target) {
            var _this25 = this;

            if (this.isMultiple) {
                return this.queryRaw(target).map(function (_) {
                    return _this25.getSelectedValue(_.value);
                });
            }
            return this.getSelectedValue(_get(SelectField.prototype.__proto__ || Object.getPrototypeOf(SelectField.prototype), "queryValue", this).call(this, target));
        }
    }, {
        key: "editableFieldTemplate",
        get: function get() {
            return "adhara-form-fields/select";
        }
    }, {
        key: "nonEditableFieldTemplate",
        get: function get() {
            var _this26 = this;

            return this.config.options.filter(function (_) {
                return _.value === _this26._value;
            })[0] || "-";
        }
    }, {
        key: "value",
        set: function set(_) {
            _set(SelectField.prototype.__proto__ || Object.getPrototypeOf(SelectField.prototype), "value", _, this);
        },
        get: function get() {
            var _ = _get(SelectField.prototype.__proto__ || Object.getPrototypeOf(SelectField.prototype), "value", this);
            return _ === undefined ? null : _;
        }

        /**
         * @returns {Array<Object>} options
         * @example:
         * get options(){
         *      return [
         *          {"value": "H", "display: "High"},
         *          {"value": "M", "display: "Medium"},
         *          {"value": "L", "display: "Low"}
         *      ];
         * }
         * */

    }, {
        key: "options",
        get: function get() {
            var _this27 = this;

            var _o = this.options_cache;
            if (!_o && this.config.options) {
                if (this.config.options.call) {
                    var promise = this.config.options();
                    if (promise.then) {
                        promise.then(function (_options) {
                            _this27.options_cache = _options;
                            _this27.setState();
                        });
                    } else {
                        _o = promise;
                    }
                    return [];
                } else {
                    _o = this.config.options;
                }
            }
            _o = (_o || []).slice();
            if (this.isNullable) {
                _o.unshift({ value: null, display: this.placeholder || "----------" });
            }
            return _o;
        }
    }]);

    return SelectField;
}(FormField);

/**------------------------------------------------------------------------------------------------------------------**/


var RadioField = function (_FormField4) {
    _inherits(RadioField, _FormField4);

    function RadioField() {
        _classCallCheck(this, RadioField);

        return _possibleConstructorReturn(this, (RadioField.__proto__ || Object.getPrototypeOf(RadioField)).apply(this, arguments));
    }

    _createClass(RadioField, [{
        key: "editableFieldTemplate",
        get: function get() {
            return "adhara-form-fields/radio";
        }
    }]);

    return RadioField;
}(FormField);

/**------------------------------------------------------------------------------------------------------------------**/


var CheckboxField = function (_InputField) {
    _inherits(CheckboxField, _InputField);

    function CheckboxField() {
        _classCallCheck(this, CheckboxField);

        return _possibleConstructorReturn(this, (CheckboxField.__proto__ || Object.getPrototypeOf(CheckboxField)).apply(this, arguments));
    }

    _createClass(CheckboxField, [{
        key: "queryValue",
        value: function queryValue(target) {
            return (target || this.getField()).checked;
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-form-fields/checkbox";
        }
    }, {
        key: "defaultFieldAttributes",
        get: function get() {
            return {};
        }
    }]);

    return CheckboxField;
}(InputField);

/**------------------------------------------------------------------------------------------------------------------**/


var SuggestionHintsMetaField = function (_AdharaView4) {
    _inherits(SuggestionHintsMetaField, _AdharaView4);

    function SuggestionHintsMetaField() {
        _classCallCheck(this, SuggestionHintsMetaField);

        return _possibleConstructorReturn(this, (SuggestionHintsMetaField.__proto__ || Object.getPrototypeOf(SuggestionHintsMetaField)).apply(this, arguments));
    }

    _createClass(SuggestionHintsMetaField, [{
        key: "onInit",
        value: function onInit() {
            _get(SuggestionHintsMetaField.prototype.__proto__ || Object.getPrototypeOf(SuggestionHintsMetaField.prototype), "onInit", this).call(this);
            this.cursor = 0;
            this._rc = 0;
            this._hints = [];
            this.hintTempalate = this.settings.options.hint_template;
        }
    }, {
        key: "onScroll",
        value: function onScroll(event, data) {
            if (event.target.offsetHeight + event.target.scrollTop >= event.target.scrollHeight && this.scroll_position !== event.target.scrollTop) {
                this.scroll_position = event.target.scrollTop;
                this.trigger("ScrollHitBottom");
            }
        }
    }, {
        key: "show",
        value: function show() {
            this.enable = true;
            this.setState();
        }
    }, {
        key: "hide",
        value: function hide() {
            this.enable = false;
            this.setState();
            // setTimeout(()=>{
            //     this._hc && this._hc.classList.add('d-none');
            // }, 1000);

            /*this.enable = false;
            setTimeout(()=>{
                this.setState();
            }, 500);*/
        }
    }, {
        key: "format",
        value: function format(container) {
            _get(SuggestionHintsMetaField.prototype.__proto__ || Object.getPrototypeOf(SuggestionHintsMetaField.prototype), "format", this).call(this, container);
            try {
                var hintContainer = this.querySelector('.hint-container');
                if (hintContainer) hintContainer.scrollTop = this.scroll_position;
            } catch (e) {/*--Do nothing--*/}
            this.scroll_position = 0;
        }
    }, {
        key: "reset",
        value: function reset() {
            this.cursor = 0;
            this._hints = [];
            this.setState();
        }
    }, {
        key: "cursorUp",
        value: function cursorUp() {
            if (this.cursor > 0) this.cursor--;else this.cursor = this.hints.length - 1;
            this.setState();
        }
    }, {
        key: "cursorDown",
        value: function cursorDown() {
            if (this.cursor < this.hints.length - 1) this.cursor++;else this.cursor = 0;
            this.setState();
        }
    }, {
        key: "onChoice",
        value: function onChoice(event, data) {
            this.cursor = +data.index;
            this.trigger("HintSelected", this.selectedHint);
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-form-fields/field-hints";
        }
    }, {
        key: "events",
        get: function get() {
            return ["HintSelected", "ScrollHitBottom"];
        }
    }, {
        key: "_hc",
        get: function get() {
            return this.getParentContainerElement().querySelector('.hint-container');
        }
    }, {
        key: "hints",
        get: function get() {
            return this._hints;
        },
        set: function set(_) {
            this._hints = _;
            this.enable = !!this._hints.length;
            this.setState();
        }
    }, {
        key: "selectedHint",
        get: function get() {
            return this.hints[this.cursor];
        }
    }]);

    return SuggestionHintsMetaField;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var SuggestionMetaField = function (_FormField5) {
    _inherits(SuggestionMetaField, _FormField5);

    //THIS IS A META CLASS ONLY, to be used inside other select classes..!

    /**
     * @param {SuggestionDataProvider} config.dataProvider
     * */
    function SuggestionMetaField(name, config, settings) {
        _classCallCheck(this, SuggestionMetaField);

        var _this31 = _possibleConstructorReturn(this, (SuggestionMetaField.__proto__ || Object.getPrototypeOf(SuggestionMetaField)).call(this, name, config, settings));

        if (!(config.data_provider instanceof SuggestionDataProvider)) {
            //TODO throw error...
            // throw new Error(`field config error: ${this.name} | dataProvider must be an instance of SuggestionDataProvider`);
        }
        _this31.term = "";
        _this31.page = 1;
        _this31.paginated_hints = [];
        _this31.hint = new SuggestionHintsMetaField({
            c: ".hints#" + _this31.ts,
            options: {
                hint_template: config.hint_template
            }
        });
        _this31.hint.onHintSelected(function (hint) {
            _this31.handleHintUpdate(false);
        });
        _this31.hint.onScrollHitBottom(function () {
            _this31.updateHints({ page: _this31.page + 1 }).then(function (_) {
                return _;
            });
        });
        _this31.tasker = new CoalesceTasker(500);
        return _this31;
    }

    _createClass(SuggestionMetaField, [{
        key: "focus",
        value: function focus(term) {
            var i = this.getParentContainerElement().querySelector("input");
            i.focus();
            if (term !== undefined) {
                i.value = term;
                i.dispatchEvent(new Event("change"));
            }
        }
    }, {
        key: "onFocus",
        value: function onFocus(e, d) {
            this.hint.show();
            this.trigger("Focused", e, d);
        }
    }, {
        key: "onBlur",
        value: function onBlur(e, d) {
            var _this32 = this;

            this.trigger("Blurred", e, d);
            setTimeout(function () {
                if (e.target.name !== document.activeElement.name) {
                    _this32.hint.hide();
                }
            }, 1000);
        }
    }, {
        key: "handleHintUpdate",
        value: function handleHintUpdate() {
            var isDeleted = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            this.trigger(isDeleted ? "HintDeleted" : "HintSelected", this.hint.selectedHint);
            this.updateHints({ term: "", re_fetch: true }).then(function (_) {
                return _;
            });
            this.selected_hint = this.hint.selectedHint;
            // this.hint.reset();
        }
    }, {
        key: "onKeyDown",
        value: function () {
            var _ref24 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(event, data) {
                var key;
                return regeneratorRuntime.wrap(function _callee14$(_context16) {
                    while (1) {
                        switch (_context16.prev = _context16.next) {
                            case 0:
                                key = event.which;

                                if (!(key === ESCAPE)) {
                                    _context16.next = 4;
                                    break;
                                }

                                _context16.next = 30;
                                break;

                            case 4:
                                if (!( /*key===TAB || */key === ENTER)) {
                                    _context16.next = 9;
                                    break;
                                }

                                if (this.hint.selectedHint) {
                                    this.handleHintUpdate(false);
                                }
                                event.preventDefault();
                                _context16.next = 30;
                                break;

                            case 9:
                                if (!(key === UP_ARROW)) {
                                    _context16.next = 19;
                                    break;
                                }

                                if (!(!this.hint.hints || !this.hint.hints.length)) {
                                    _context16.next = 15;
                                    break;
                                }

                                _context16.next = 13;
                                return this.updateHints({ start_fetching: true });

                            case 13:
                                _context16.next = 16;
                                break;

                            case 15:
                                this.hint.cursorUp();

                            case 16:
                                event.preventDefault();
                                _context16.next = 30;
                                break;

                            case 19:
                                if (!(key === DOWN_ARROW)) {
                                    _context16.next = 29;
                                    break;
                                }

                                if (!(!this.hint.hints || !this.hint.hints.length)) {
                                    _context16.next = 25;
                                    break;
                                }

                                _context16.next = 23;
                                return this.updateHints({ start_fetching: true });

                            case 23:
                                _context16.next = 26;
                                break;

                            case 25:
                                this.hint.cursorDown();

                            case 26:
                                event.preventDefault();
                                _context16.next = 30;
                                break;

                            case 29:
                                if (key === BACKSPACE && !event.target.value) {
                                    this.handleHintUpdate(true);
                                }

                            case 30:
                            case "end":
                                return _context16.stop();
                        }
                    }
                }, _callee14, this);
            }));

            function onKeyDown(_x36, _x37) {
                return _ref24.apply(this, arguments);
            }

            return onKeyDown;
        }()
    }, {
        key: "onTermChange",
        value: function () {
            var _ref25 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(event, data) {
                return regeneratorRuntime.wrap(function _callee15$(_context17) {
                    while (1) {
                        switch (_context17.prev = _context17.next) {
                            case 0:
                                _context17.next = 2;
                                return this.updateHints({ term: event.target.value });

                            case 2:
                            case "end":
                                return _context17.stop();
                        }
                    }
                }, _callee15, this);
            }));

            function onTermChange(_x38, _x39) {
                return _ref25.apply(this, arguments);
            }

            return onTermChange;
        }()
    }, {
        key: "canFetchHints",
        value: function canFetchHints(new_term) {
            return this.isHintUpdated || this.isTermChanged || this.isPageChanged;
        }
    }, {
        key: "isNewTerm",
        value: function isNewTerm(term) {
            return term !== this.term && term !== this.querying_results_for_term;
        }
    }, {
        key: "updateHints",
        value: function () {
            var _ref26 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(options) {
                var _this33 = this;

                var start_fetching, is_new_term, is_new_page, force_re_fetch, page, term, has_next_page;
                return regeneratorRuntime.wrap(function _callee17$(_context19) {
                    while (1) {
                        switch (_context19.prev = _context19.next) {
                            case 0:
                                start_fetching = options.start_fetching === true;
                                is_new_term = start_fetching || options.term && this.isNewTerm(options.term);
                                is_new_page = start_fetching || options.page !== undefined;
                                force_re_fetch = options.re_fetch === true;
                                page = is_new_page ? options.page || 1 : 1;

                                if (is_new_term || force_re_fetch) page = 1;

                                term = options.term || this.term;
                                has_next_page = page === 1 || this.config.data_provider.hasNextPage;

                                if (has_next_page) {
                                    _context19.next = 10;
                                    break;
                                }

                                return _context19.abrupt("return");

                            case 10:
                                if (!(!is_new_term && !is_new_page && !force_re_fetch)) {
                                    _context19.next = 12;
                                    break;
                                }

                                return _context19.abrupt("return", false);

                            case 12:
                                this.querying_results_for_term = term;
                                this.querying_results_for_page = page;
                                this.tasker.execute(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
                                    var results, _paginated_hints, _results;

                                    return regeneratorRuntime.wrap(function _callee16$(_context18) {
                                        while (1) {
                                            switch (_context18.prev = _context18.next) {
                                                case 0:
                                                    if (!(page === 1)) {
                                                        _context18.next = 9;
                                                        break;
                                                    }

                                                    _context18.next = 3;
                                                    return _this33.config.data_provider.getFirstPage(term);

                                                case 3:
                                                    results = _context18.sent;

                                                    if (!(_this33.querying_results_for_term !== term)) {
                                                        _context18.next = 6;
                                                        break;
                                                    }

                                                    return _context18.abrupt("return");

                                                case 6:
                                                    _this33.paginated_hints = results;
                                                    _context18.next = 15;
                                                    break;

                                                case 9:
                                                    _context18.next = 11;
                                                    return _this33.config.data_provider.getNextPage();

                                                case 11:
                                                    _results = _context18.sent;

                                                    if (!(_this33.querying_results_for_term !== term)) {
                                                        _context18.next = 14;
                                                        break;
                                                    }

                                                    return _context18.abrupt("return");

                                                case 14:
                                                    (_paginated_hints = _this33.paginated_hints).push.apply(_paginated_hints, _toConsumableArray(_results));

                                                case 15:
                                                    _this33.hint.hints = _this33.paginated_hints;
                                                    _this33.querying_results_for_term = null;
                                                    _this33.querying_results_for_page = null;
                                                    _this33.term = term;
                                                    _this33.page = page;

                                                case 20:
                                                case "end":
                                                    return _context18.stop();
                                            }
                                        }
                                    }, _callee16, _this33);
                                })));

                            case 15:
                            case "end":
                                return _context19.stop();
                        }
                    }
                }, _callee17, this);
            }));

            function updateHints(_x40) {
                return _ref26.apply(this, arguments);
            }

            return updateHints;
        }()
    }, {
        key: "template",
        get: function get() {
            return "adhara-form-fields/suggestions";
        }
    }, {
        key: "events",
        get: function get() {
            return ["HintSelected", "HintDeleted", "Focused", "Blurred"];
        }
    }, {
        key: "defaultFieldAttributes",
        get: function get() {
            return {};
        }
    }, {
        key: "isTermChanged",
        get: function get() {
            if (this.querying_results_for_term) {
                return this.querying_results_for_term !== this.term;
            }
            return this.showing_results_for_term !== this.term;
        }
    }, {
        key: "isPageChanged",
        get: function get() {
            if (this.querying_results_for_page) {
                return this.page > this.querying_results_for_page;
            }
            if (this.showing_results_for_page) {
                return this.page > this.showing_results_for_page;
            }
            return true;
        }
    }, {
        key: "isHintUpdated",
        get: function get() {
            var oldHint = this.selected_hint && this.selected_hint.value;
            var newHint = this.hint.selectedHint && this.hint.selectedHint.value;
            return newHint !== oldHint;
        }
    }, {
        key: "subViews",
        get: function get() {
            return [this.hint];
        }
    }]);

    return SuggestionMetaField;
}(FormField);

var SuggestionDataProvider = function () {

    /**
     * @param {Array<Object>} data
     * @param {String|Number} data.value - value to be attained as selected value
     * @param {String} data.display - display string
     * @example
     * SuggestionDataProvider([
     *  {value: 1, display: "One"},
     *  {value: 2, display: "Two"},
     *  {value: 3, display: "Three"},
     * ]
     * */
    function SuggestionDataProvider() {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

        _classCallCheck(this, SuggestionDataProvider);

        this.data = data;
    }

    _createClass(SuggestionDataProvider, [{
        key: "getFirstPage",
        value: function () {
            var _ref28 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(term) {
                return regeneratorRuntime.wrap(function _callee18$(_context20) {
                    while (1) {
                        switch (_context20.prev = _context20.next) {
                            case 0:
                                return _context20.abrupt("return", this.data.filter(function (_) {
                                    return _.display.indexOf(term) !== -1;
                                }));

                            case 1:
                            case "end":
                                return _context20.stop();
                        }
                    }
                }, _callee18, this);
            }));

            function getFirstPage(_x42) {
                return _ref28.apply(this, arguments);
            }

            return getFirstPage;
        }()
    }, {
        key: "getNextPage",
        value: function () {
            var _ref29 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
                return regeneratorRuntime.wrap(function _callee19$(_context21) {
                    while (1) {
                        switch (_context21.prev = _context21.next) {
                            case 0:
                                return _context21.abrupt("return", []);

                            case 1:
                            case "end":
                                return _context21.stop();
                        }
                    }
                }, _callee19, this);
            }));

            function getNextPage() {
                return _ref29.apply(this, arguments);
            }

            return getNextPage;
        }()
    }, {
        key: "hasNextPage",
        get: function get() {
            return false;
        }
    }]);

    return SuggestionDataProvider;
}();
/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @class
 * @param {Object} [settings]
 * @param {String} [settings.name] - field name
 * @param {String} [settings.key=undefined] - Instance key
 * @param {String} settings.c - CSS Selector from parent view to place content of this class
 * @param {Function} settings.get_fields - fields list for index
 * @param {Function} settings.serializedRowFilter -  filter put serialized rows based on input values
 * @param {Boolean} settings.nullable -  whether at-least one row data must be provided or not.
 * @param {HandlebarTemplate} settings.fieldSetTemplate - CSS Selector from parent view to place content of this class
 * */


var FieldSetRepeater = function (_AdharaMutableView3) {
    _inherits(FieldSetRepeater, _AdharaMutableView3);

    function FieldSetRepeater() {
        _classCallCheck(this, FieldSetRepeater);

        return _possibleConstructorReturn(this, (FieldSetRepeater.__proto__ || Object.getPrototypeOf(FieldSetRepeater)).apply(this, arguments));
    }

    _createClass(FieldSetRepeater, [{
        key: "onInit",
        value: function onInit() {
            _get(FieldSetRepeater.prototype.__proto__ || Object.getPrototypeOf(FieldSetRepeater.prototype), "onInit", this).call(this);
            this.fieldMap = null;
            this.mutableData = this.mutableData instanceof Array && this.mutableData.length ? this.mutableData : [{}];
            this.fieldSetMap = [];
        }
    }, {
        key: "addFieldSet",
        value: function addFieldSet(event, data) {
            this.mutableData.push({});
            this.setState();
        }
    }, {
        key: "removeFieldSet",
        value: function removeFieldSet(event, data) {
            if (this.mutableData.length > 1) {
                this.mutableData.splice(data.idx, 1);
                this.setState();
            }
        }
    }, {
        key: "getFieldsForIndex",
        value: function getFieldsForIndex(idx) {
            return this.settings.get_fields && this.settings.get_fields(idx) || this.settings.fields;
        }
    }, {
        key: "filterSerializedRows",
        value: function filterSerializedRows(data) {
            if (this.settings.serializedRowFilter) {
                return this.settings.serializedRowFilter(data);
            }
            return data.filter(function (datum) {
                return !!Object.values(datum).filter(function (_) {
                    return _;
                }).length;
            });
        }
    }, {
        key: "getFieldValue",
        value: function getFieldValue(field_name) {
            throw new Error("invalid function called for a repeater field set. Use getFieldValueByIndex");
        }

        /**
         * @returns {*} Field data
         * */

    }, {
        key: "getFieldValueByIndex",
        value: function getFieldValueByIndex(field_name, row_index) {
            return getValueFromJSON(this.mutableData[row_index], this.fieldSetMap[row_index][field_name].name);
        }
    }, {
        key: "getFieldByIndex",


        /**
         * @returns {*} Field data
         * */
        value: function getFieldByIndex(field_name, index) {
            return this.rendered_fields.filter(function (_) {
                return _.name === field_name && _.config.list_index === index;
            })[0];
        }
    }, {
        key: "getMutatedData",
        value: function getMutatedData() {
            var data = [];
            var _iteratorNormalCompletion21 = true;
            var _didIteratorError21 = false;
            var _iteratorError21 = undefined;

            try {
                for (var _iterator21 = this.rendered_fields[Symbol.iterator](), _step21; !(_iteratorNormalCompletion21 = (_step21 = _iterator21.next()).done); _iteratorNormalCompletion21 = true) {
                    var field = _step21.value;

                    if (!data[field.config.list_index]) {
                        data[field.config.list_index] = {};
                    }
                    setValueToJson(data[field.config.list_index], field.name, field.serialize());
                }
            } catch (err) {
                _didIteratorError21 = true;
                _iteratorError21 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion21 && _iterator21.return) {
                        _iterator21.return();
                    }
                } finally {
                    if (_didIteratorError21) {
                        throw _iteratorError21;
                    }
                }
            }

            return this.filterSerializedRows(data);
        }
    }, {
        key: "onFieldValueChangedForIndex",
        value: function onFieldValueChangedForIndex(field_name, value, old_value, index) {
            //    can override as required
        }
    }, {
        key: "_onFieldValueChanged",
        value: function _onFieldValueChanged(field_name, value, old_value, event_data) {
            var index = event_data.repeaterindex || event_data.list_index;
            setValueToJson(this.mutableData[index], this.fieldSetMap[index][field_name].name, value);
            this.onFieldValueChangedForIndex(field_name, value, old_value, index);
            this.onMutableDataChanged();
        }
    }, {
        key: "getFieldsForValidation",
        value: function getFieldsForValidation() {
            var _to_validate = [];
            var _iteratorNormalCompletion22 = true;
            var _didIteratorError22 = false;
            var _iteratorError22 = undefined;

            try {
                for (var _iterator22 = this.fieldSetMap[Symbol.iterator](), _step22; !(_iteratorNormalCompletion22 = (_step22 = _iterator22.next()).done); _iteratorNormalCompletion22 = true) {
                    var fieldset = _step22.value;

                    if (Object.values(fieldset).filter(function (_) {
                        return !_.isEmpty;
                    }).length) {
                        _to_validate.push.apply(_to_validate, _toConsumableArray(Object.values(fieldset)));
                    }
                }
            } catch (err) {
                _didIteratorError22 = true;
                _iteratorError22 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion22 && _iterator22.return) {
                        _iterator22.return();
                    }
                } finally {
                    if (_didIteratorError22) {
                        throw _iteratorError22;
                    }
                }
            }

            if (!this.isNullable && _to_validate.length === 0) {
                return Object.values(this.fieldSetMap[0]);
            }
            return _to_validate;
        }
    }, {
        key: "template",
        get: function get() {
            return 'adhara-form-fields/repeater';
        }
    }, {
        key: "isHorizontal",
        get: function get() {
            return this.settings.style === FieldSetRepeater.style.HORIZONTAL;
        }
    }, {
        key: "addNewText",
        get: function get() {
            return this.settings.add_new_text;
        }
    }, {
        key: "repeaterFieldSetClass",
        get: function get() {
            return this.isHorizontal ? "d-inline-block" : "d-flex";
        }
    }, {
        key: "rowCount",
        get: function get() {
            return this.mutableData.length;
        }
    }, {
        key: "subViews",
        get: function get() {
            var repeated_fields = [];
            for (var i = 0; i < this.rowCount; i++) {
                var _iteratorNormalCompletion23 = true;
                var _didIteratorError23 = false;
                var _iteratorError23 = undefined;

                try {
                    for (var _iterator23 = this.getFieldsForIndex(i).filter(this.isFormField)[Symbol.iterator](), _step23; !(_iteratorNormalCompletion23 = (_step23 = _iterator23.next()).done); _iteratorNormalCompletion23 = true) {
                        var field = _step23.value;

                        var _field = field.clone("repeater-" + this.safeName + "-" + i);
                        _field.mutator = this;
                        _field.parentContainer = "#fieldset-" + i + "-" + this.safeName + " [data-field=" + _field.safeName + "]";
                        if (!this.isHorizontal) {
                            //=> vertical growing repeater
                            _field.config.label = _field.config.label !== false && i === 0;
                        }
                        _field.config.list_index = i;
                        _field.config.attributes["data-repeaterIndex"] = i;
                        if (!this.fieldSetMap[i]) this.fieldSetMap[i] = {};
                        this.fieldSetMap[i][_field.name] = _field;
                        _field.value = this.getFieldValueByIndex(_field.name, i);
                        repeated_fields.push(_field);
                    }
                } catch (err) {
                    _didIteratorError23 = true;
                    _iteratorError23 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion23 && _iterator23.return) {
                            _iterator23.return();
                        }
                    } finally {
                        if (_didIteratorError23) {
                            throw _iteratorError23;
                        }
                    }
                }
            }
            this.rendered_fields = repeated_fields.slice();
            return repeated_fields;
        }
    }, {
        key: "isNullable",
        get: function get() {
            return this.settings.nullable !== false;
        }
    }]);

    return FieldSetRepeater;
}(AdharaMutableView);

FieldSetRepeater.style = {
    HORIZONTAL: "h",
    VERTICAL: "v"
};
/**------------------------------------------------------------------------------------------------------------------**/

var AdharaGridView = function (_AdharaListView) {
    _inherits(AdharaGridView, _AdharaListView);

    function AdharaGridView() {
        _classCallCheck(this, AdharaGridView);

        return _possibleConstructorReturn(this, (AdharaGridView.__proto__ || Object.getPrototypeOf(AdharaGridView)).apply(this, arguments));
    }

    _createClass(AdharaGridView, [{
        key: "listType",
        get: function get() {
            return AdharaListView.VIEW_TYPES.GRID_VIEW;
        }

        // TODO
        // 1. need to take in different table configurations,
        // 2. need a preprocessor for data before drawing table

    }, {
        key: "tableClass",
        get: function get() {
            return "table-bordered table-hover";
        }
    }]);

    return AdharaGridView;
}(AdharaListView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaTemplateView = function (_AdharaListView2) {
    _inherits(AdharaTemplateView, _AdharaListView2);

    function AdharaTemplateView() {
        _classCallCheck(this, AdharaTemplateView);

        return _possibleConstructorReturn(this, (AdharaTemplateView.__proto__ || Object.getPrototypeOf(AdharaTemplateView)).apply(this, arguments));
    }

    _createClass(AdharaTemplateView, [{
        key: "listType",
        get: function get() {
            return AdharaListView.VIEW_TYPES.TEMPLATE_VIEW;
        }
    }, {
        key: "tableClass",
        get: function get() {
            return "table-bordered table-hover";
        }
    }, {
        key: "containerAttributes",
        get: function get() {
            return {};
        }
    }]);

    return AdharaTemplateView;
}(AdharaListView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaCardView = function (_AdharaListView3) {
    _inherits(AdharaCardView, _AdharaListView3);

    function AdharaCardView() {
        _classCallCheck(this, AdharaCardView);

        return _possibleConstructorReturn(this, (AdharaCardView.__proto__ || Object.getPrototypeOf(AdharaCardView)).apply(this, arguments));
    }

    _createClass(AdharaCardView, [{
        key: "listType",
        get: function get() {
            return AdharaListView.VIEW_TYPES.CARD_VIEW;
        }
    }, {
        key: "containerClass",
        get: function get() {
            return "";
        }
    }, {
        key: "cardSizeClass",
        get: function get() {
            return "col-md-4";
        }
    }]);

    return AdharaCardView;
}(AdharaListView);
/**------------------------------------------------------------------------------------------------------------------**/
/**
 * Created by varun on 10/2/18.
 */


var AdharaDialogView = function (_AdharaView5) {
    _inherits(AdharaDialogView, _AdharaView5);

    function AdharaDialogView() {
        _classCallCheck(this, AdharaDialogView);

        return _possibleConstructorReturn(this, (AdharaDialogView.__proto__ || Object.getPrototypeOf(AdharaDialogView)).apply(this, arguments));
    }

    _createClass(AdharaDialogView, [{
        key: "onInit",
        value: function onInit() {
            this._modalId = "adhara-dialog-id-" + Date.now();
            this.destroy = this.destroy.bind(this);
        }
    }, {
        key: "getParentContainerElement",
        value: function getParentContainerElement() {
            // return document.querySelector('.adhara-dialog')
            return document.querySelector('#' + this.wrapperId);
        }
    }, {
        key: "render",
        value: function render() {
            this.destroy();
            var dialog_elements = document.querySelectorAll('#' + this.modalId);
            if (dialog_elements && dialog_elements.length) {
                for (var i = 0; i < dialog_elements.length; i++) {
                    dialog_elements[i].remove();
                }
            }
            var wrapper = document.createElement('div');
            wrapper.id = this.wrapperId;
            wrapper.classList.add('adhara-dialog');
            document.querySelector('body').appendChild(wrapper);
            _get(AdharaDialogView.prototype.__proto__ || Object.getPrototypeOf(AdharaDialogView.prototype), "render", this).call(this);
        }
    }, {
        key: "format",
        value: function format() {
            if (this.isAutoShow) {
                this.show();
            }
        }
    }, {
        key: "show",
        value: function show() {
            var _this39 = this;

            this.modalElement.modal('show');
            if (this.destroyOnClose) {
                setTimeout(function () {
                    _this39.modalElement.on('hidden.bs.modal', _this39.destroy);
                }, 0);
            }
        }
    }, {
        key: "hide",
        value: function hide() {
            //Note: destroy's if destroyOnClose is enabled. See event listener binding in show() method.
            this.modalElement.modal('hide');
        }
    }, {
        key: "onDestroy",
        value: function onDestroy() {
            var wrapper_element = document.getElementById(this.wrapperId);
            if (wrapper_element) {
                wrapper_element.remove();
            }
        }
    }, {
        key: "template",
        get: function get() {
            return "adhara-dialog";
        }
    }, {
        key: "titleTemplate",
        get: function get() {
            return 'Adhara Dialog';
        }
    }, {
        key: "messageTemplate",
        get: function get() {
            return 'Adhara Dialog Message!';
        }
    }, {
        key: "buttons",
        get: function get() {
            return [{
                attributes: {
                    "type": "button",
                    "class": "btn btn-secondary",
                    "data-dismiss": "modal"
                },
                text: 'Close'
            }];
        }
    }, {
        key: "modalId",
        get: function get() {
            return this._modalId;
        }
    }, {
        key: "wrapperId",
        get: function get() {
            return this.modalId + "-wrapper";
        }
    }, {
        key: "modalElement",
        get: function get() {
            if (!this._modalElemnt || !document.body.contains(this._modalElemnt[0])) {
                this._modalElemnt = $('#' + this.modalId); //Using jQ as that is mostly used in this view
            }
            return this._modalElemnt;
        }
    }, {
        key: "isAutoShow",
        get: function get() {
            return true;
        }
    }, {
        key: "destroyOnClose",
        get: function get() {
            return true;
        }
    }]);

    return AdharaDialogView;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaTabView = function (_AdharaView6) {
    _inherits(AdharaTabView, _AdharaView6);

    function AdharaTabView() {
        _classCallCheck(this, AdharaTabView);

        return _possibleConstructorReturn(this, (AdharaTabView.__proto__ || Object.getPrototypeOf(AdharaTabView)).apply(this, arguments));
    }

    _createClass(AdharaTabView, [{
        key: "onInit",
        value: function onInit() {
            this.containerId = "d" + Date.now();
        }
    }, {
        key: "changeCurrentTab",
        value: function changeCurrentTab(tabId) {
            var new_tab = this.tabs.filter(function (tab) {
                return tab.id === tabId;
            })[0];
            if (!new_tab) return false;
            this._current_Tab = new_tab;
            this.setState();
            return true;
        }
    }, {
        key: "onLinklessTabClick",
        value: function onLinklessTabClick(event, data) {
            this.changeCurrentTab(data.tabid);
        }
    }, {
        key: "onTabShow",
        value: function onTabShow() {}
    }, {
        key: "onTabClick",
        value: function onTabClick() {}
    }, {
        key: "onTabChange",
        value: function onTabChange() {}

        /*onShow(){
         }*/

    }, {
        key: "format",
        value: function format() {}
    }, {
        key: "template",
        get: function get() {
            return "adhara-tab-view";
        }
    }, {
        key: "containerClass",
        get: function get() {
            return 'nav nav-pills';
        }
    }, {
        key: "tabNavClass",
        get: function get() {
            return 'custom-tabs-line tabs-line-bottom left-aligned';
        }
    }, {
        key: "tabListClass",
        get: function get() {
            return "nav";
        }

        /**
         * @typedef {Object} TabObject
         * @property {String} id
         * @property {AdharaView} instance of adhara view
         * */

        /**
         * @returns {Array<TabObject>} list of tab objects
         * */

    }, {
        key: "tabs",
        get: function get() {
            return [];
        }

        /**
         * @getter
         * @instance
         * @returns {Object} Active tab configuration
         * */

    }, {
        key: "currentTab",
        get: function get() {
            var current_tab_link_from_url = Adhara.router.getCurrentURL();
            var current_Tab = this.tabs.filter(function (tab) {
                return tab.link === current_tab_link_from_url;
            });
            return current_Tab.length ? current_Tab[0] : this._current_Tab || this.tabs[0];
        }
    }, {
        key: "tabsList",
        get: function get() {
            var current_tab_id = this.currentTab.id;
            return this.tabs.map(function (tab) {
                tab.className = tab.id === current_tab_id ? "active" : "";
                return tab;
            });
        }
    }, {
        key: "nextSelector",
        get: function get() {
            return '.btn-next';
        }
    }, {
        key: "previousSelector",
        get: function get() {
            return '.btn-previous';
        }
    }, {
        key: "contentContainer",
        get: function get() {
            return ".tab-content .tab-pane";
        }
    }, {
        key: "subViews",
        get: function get() {
            var cTab = this.currentTab.view;
            cTab.parentContainer = "#" + this.containerId + " .tab-content .tab-pane.active";
            return [cTab];
        }

        // renderSubViews(){
        //     Adhara.createView(this.currentTab.view, this);
        // }

    }]);

    return AdharaTabView;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaAppContainerView = function (_AdharaView7) {
    _inherits(AdharaAppContainerView, _AdharaView7);

    function AdharaAppContainerView() {
        _classCallCheck(this, AdharaAppContainerView);

        return _possibleConstructorReturn(this, (AdharaAppContainerView.__proto__ || Object.getPrototypeOf(AdharaAppContainerView)).apply(this, arguments));
    }

    _createClass(AdharaAppContainerView, [{
        key: "template",
        get: function get() {
            return "app-container";
        }
    }, {
        key: "isImmortal",
        get: function get() {
            return true;
        }
    }, {
        key: "contentContainer",
        get: function get() {
            return "main";
        }
    }]);

    return AdharaAppContainerView;
}(AdharaView);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaDialogFormView = function (_MutateViews) {
    _inherits(AdharaDialogFormView, _MutateViews);

    function AdharaDialogFormView() {
        _classCallCheck(this, AdharaDialogFormView);

        return _possibleConstructorReturn(this, (AdharaDialogFormView.__proto__ || Object.getPrototypeOf(AdharaDialogFormView)).apply(this, arguments));
    }

    _createClass(AdharaDialogFormView, [{
        key: "primaryAction",
        value: function primaryAction() {
            this.submit();
        }
    }, {
        key: "primaryActionTitle",
        get: function get() {
            return 'Save';
        }
    }, {
        key: "submitButton",
        get: function get() {
            return this.getParentContainerElement().querySelector('button.btn-primary');
        }
    }, {
        key: "buttons",
        get: function get() {
            if (this.primaryActionTitle) {
                return [_get(AdharaDialogFormView.prototype.__proto__ || Object.getPrototypeOf(AdharaDialogFormView.prototype), "buttons", this)[0], {
                    attributes: {
                        "type": "button",
                        "class": "btn btn-primary",
                        "data-onclick": "primaryAction"
                    },
                    text: this.primaryActionTitle
                }];
            } else {
                return _get(AdharaDialogFormView.prototype.__proto__ || Object.getPrototypeOf(AdharaDialogFormView.prototype), "buttons", this);
            }
        }
    }]);

    return AdharaDialogFormView;
}(MutateViews(AdharaFormView, AdharaDialogView));
/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @class
 * @abstract
 * @classdesc operations that can be performed on a specific dataset whose name must be passed as initializer argument
 * */


var AdharaStorage = function () {
    function AdharaStorage() {
        _classCallCheck(this, AdharaStorage);
    }

    _createClass(AdharaStorage, [{
        key: "select",


        /**
         * @function
         * @instance
         * @param {String} database_name - name of the database
         * @param {String} dataset_name - name/key_name of the dataset on which operations are to be carried out
         * */
        value: function select(database_name, dataset_name) {
            throw new Error("return a StorageOperator instance from this method. create a `class xStorageOperator extends AdharaStorageOperator{...}`");
        }
    }]);

    return AdharaStorage;
}();

/**
 * @class
 * @abstract
 * @classdesc operations that can be performed on a specific dataset whose name must be passed as initializer argument
 * */


var AdharaStorageOperator = function () {

    /**
     * @constructor
     * @param {String} dataset - name/key_name of the dataset on which operations are to be carried out
     * */
    function AdharaStorageOperator(dataset) {
        _classCallCheck(this, AdharaStorageOperator);

        this.dataset = dataset;
    }

    /**
     * @function
     * @instance
     * @abstract
     * @returns {Promise}
     * */


    _createClass(AdharaStorageOperator, [{
        key: "store",
        value: function store(key, value) {
            throw new Error("Override `store` method");
        }

        /**
         * @function
         * @instance
         * @abstract
         * @returns {Promise}
         * */

    }, {
        key: "retrieve",
        value: function retrieve(key) {
            throw new Error("Override `retrieve` method");
        }

        /**
         * @function
         * @instance
         * @abstract
         * @returns {Promise}
         * */

    }, {
        key: "remove",
        value: function remove(key) {
            throw new Error("Override `remove` method");
        }

        /**
         * @function
         * @instance
         * @returns {Promise}
         * */

    }, {
        key: "removeAll",
        value: function removeAll() {
            return this.removeMultiple(function () {
                return true;
            });
        }

        /**
         * @function
         * @instance
         * @param {Function} filter - A function whose return value is interpreted as a boolean. return true, will remove the entry, else do nothing
         * @returns {Promise}
         * */

    }, {
        key: "removeMultiple",
        value: function removeMultiple(filter) {
            var _this43 = this;

            return this.keys().then(function () {
                var _ref30 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(keys) {
                    var key_promises, _iteratorNormalCompletion24, _didIteratorError24, _iteratorError24, _iterator24, _step24, key, data, data_promises, i, datum, _key4;

                    return regeneratorRuntime.wrap(function _callee20$(_context22) {
                        while (1) {
                            switch (_context22.prev = _context22.next) {
                                case 0:
                                    key_promises = [];
                                    _iteratorNormalCompletion24 = true;
                                    _didIteratorError24 = false;
                                    _iteratorError24 = undefined;
                                    _context22.prev = 4;
                                    _iterator24 = keys[Symbol.iterator]();

                                case 6:
                                    if (_iteratorNormalCompletion24 = (_step24 = _iterator24.next()).done) {
                                        _context22.next = 16;
                                        break;
                                    }

                                    key = _step24.value;
                                    _context22.t0 = key_promises;
                                    _context22.next = 11;
                                    return _this43.retrieve(key);

                                case 11:
                                    _context22.t1 = _context22.sent;

                                    _context22.t0.push.call(_context22.t0, _context22.t1);

                                case 13:
                                    _iteratorNormalCompletion24 = true;
                                    _context22.next = 6;
                                    break;

                                case 16:
                                    _context22.next = 22;
                                    break;

                                case 18:
                                    _context22.prev = 18;
                                    _context22.t2 = _context22["catch"](4);
                                    _didIteratorError24 = true;
                                    _iteratorError24 = _context22.t2;

                                case 22:
                                    _context22.prev = 22;
                                    _context22.prev = 23;

                                    if (!_iteratorNormalCompletion24 && _iterator24.return) {
                                        _iterator24.return();
                                    }

                                case 25:
                                    _context22.prev = 25;

                                    if (!_didIteratorError24) {
                                        _context22.next = 28;
                                        break;
                                    }

                                    throw _iteratorError24;

                                case 28:
                                    return _context22.finish(25);

                                case 29:
                                    return _context22.finish(22);

                                case 30:
                                    _context22.next = 32;
                                    return Promise.all(key_promises);

                                case 32:
                                    data = _context22.sent;
                                    data_promises = [];

                                    for (i = 0; i < data.length; i++) {
                                        datum = data[i];
                                        _key4 = keys[i];

                                        if (!!filter(_key4, datum)) {
                                            data_promises.push(_this43.remove(_key4));
                                        }
                                    }
                                    _context22.next = 37;
                                    return Promise.all(data_promises);

                                case 37:
                                    return _context22.abrupt("return", _context22.sent);

                                case 38:
                                case "end":
                                    return _context22.stop();
                            }
                        }
                    }, _callee20, _this43, [[4, 18, 22, 30], [23,, 25, 29]]);
                }));

                return function (_x43) {
                    return _ref30.apply(this, arguments);
                };
            }());
        }

        /**
         * @function
         * @instance
         * @abstract
         * @returns {Promise}
         * */

    }, {
        key: "keys",
        value: function keys() {
            throw new Error("Override `keys` method");
        }
    }]);

    return AdharaStorageOperator;
}();
/**------------------------------------------------------------------------------------------------------------------**/


var StorageSelector = function () {
    function StorageSelector() {
        _classCallCheck(this, StorageSelector);
    }

    _createClass(StorageSelector, null, [{
        key: "select",
        value: function select() {
            if (window.hasOwnProperty("indexedDB")) {
                return AdharaDBStorage;
            } else {
                return AdharaCacheStorage;
            }
        }
    }]);

    return StorageSelector;
}();
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaDBStorage = function (_AdharaStorage) {
    _inherits(AdharaDBStorage, _AdharaStorage);

    function AdharaDBStorage() {
        _classCallCheck(this, AdharaDBStorage);

        // promise based Async wrapper for indexedDB

        var _this44 = _possibleConstructorReturn(this, (AdharaDBStorage.__proto__ || Object.getPrototypeOf(AdharaDBStorage)).call(this));

        function promisifyRequest(request) {
            return new Promise(function (resolve, reject) {
                request.onsuccess = function () {
                    resolve(request.result);
                };
                request.onerror = function () {
                    reject(request.error);
                };
            });
        }

        function promisifyRequestCall(obj, method, args) {
            var request = void 0;
            var p = new Promise(function (resolve, reject) {
                request = obj[method].apply(obj, args);
                promisifyRequest(request).then(resolve, reject);
            });
            p.request = request;
            return p;
        }

        function promisifyCursorRequestCall(obj, method, args) {
            var p = promisifyRequestCall(obj, method, args);
            return p.then(function (value) {
                if (!value) {
                    return;
                }
                return new Cursor(value, p.request);
            });
        }

        function proxyProperties(ProxyClass, targetProp, properties) {
            properties.forEach(function (prop) {
                Object.defineProperty(ProxyClass.prototype, prop, {
                    get: function get() {
                        return this[targetProp][prop];
                    },
                    set: function set(val) {
                        this[targetProp][prop] = val;
                    }
                });
            });
        }

        function proxyRequestMethods(ProxyClass, targetProp, Constructor, properties) {
            properties.forEach(function (prop) {
                if (!(prop in Constructor.prototype)) {
                    return;
                }
                ProxyClass.prototype[prop] = function () {
                    return promisifyRequestCall(this[targetProp], prop, arguments);
                };
            });
        }

        function proxyMethods(ProxyClass, targetProp, Constructor, properties) {
            properties.forEach(function (prop) {
                if (!(prop in Constructor.prototype)) {
                    return;
                }
                ProxyClass.prototype[prop] = function () {
                    return this[targetProp][prop].apply(this[targetProp], arguments);
                };
            });
        }

        function proxyCursorRequestMethods(ProxyClass, targetProp, Constructor, properties) {
            properties.forEach(function (prop) {
                if (!(prop in Constructor.prototype)) {
                    return;
                }
                ProxyClass.prototype[prop] = function () {
                    return promisifyCursorRequestCall(this[targetProp], prop, arguments);
                };
            });
        }

        function Index(index) {
            this._index = index;
        }

        proxyProperties(Index, '_index', ['name', 'keyPath', 'multiEntry', 'unique']);

        proxyRequestMethods(Index, '_index', IDBIndex, ['get', 'getKey', 'getAll', 'getAllKeys', 'count']);

        proxyCursorRequestMethods(Index, '_index', IDBIndex, ['openCursor', 'openKeyCursor']);

        function Cursor(cursor, request) {
            this._cursor = cursor;
            this._request = request;
        }

        proxyProperties(Cursor, '_cursor', ['direction', 'key', 'primaryKey', 'value']);

        proxyRequestMethods(Cursor, '_cursor', IDBCursor, ['update', 'delete']);

        // proxy 'next' methods
        ['advance', 'continue', 'continuePrimaryKey'].forEach(function (methodName) {
            if (!(methodName in IDBCursor.prototype)) {
                return;
            }
            Cursor.prototype[methodName] = function () {
                var cursor = this;
                var args = arguments;
                return Promise.resolve().then(function () {
                    cursor._cursor[methodName].apply(cursor._cursor, args);
                    return promisifyRequest(cursor._request).then(function (value) {
                        return value ? new Cursor(value, cursor._request) : null;
                    });
                });
            };
        });

        function ObjectStore(store) {
            this._store = store;
        }

        ObjectStore.prototype.createIndex = function () {
            return new Index(this._store.createIndex.apply(this._store, arguments));
        };

        ObjectStore.prototype.index = function () {
            return new Index(this._store.index.apply(this._store, arguments));
        };

        proxyProperties(ObjectStore, '_store', ['name', 'keyPath', 'indexNames', 'autoIncrement']);

        proxyRequestMethods(ObjectStore, '_store', IDBObjectStore, ['put', 'add', 'delete', 'clear', 'get', 'getAll', 'getKey', 'getAllKeys', 'count']);

        proxyCursorRequestMethods(ObjectStore, '_store', IDBObjectStore, ['openCursor', 'openKeyCursor']);

        proxyMethods(ObjectStore, '_store', IDBObjectStore, ['deleteIndex']);

        function Transaction(idbTransaction) {
            this._tx = idbTransaction;
            this.complete = new Promise(function (resolve, reject) {
                idbTransaction.oncomplete = function () {
                    resolve();
                };
                idbTransaction.onerror = function () {
                    reject(idbTransaction.error);
                };
                idbTransaction.onabort = function () {
                    reject(idbTransaction.error);
                };
            });
        }

        Transaction.prototype.objectStore = function () {
            return new ObjectStore(this._tx.objectStore.apply(this._tx, arguments));
        };

        proxyProperties(Transaction, '_tx', ['objectStoreNames', 'mode']);

        proxyMethods(Transaction, '_tx', IDBTransaction, ['abort']);

        function UpgradeDB(db, oldVersion, transaction) {
            this._db = db;
            this.oldVersion = oldVersion;
            this.transaction = new Transaction(transaction);
        }

        UpgradeDB.prototype.createObjectStore = function () {
            return new ObjectStore(this._db.createObjectStore.apply(this._db, arguments));
        };

        proxyProperties(UpgradeDB, '_db', ['name', 'version', 'objectStoreNames']);

        proxyMethods(UpgradeDB, '_db', IDBDatabase, ['deleteObjectStore', 'close']);

        function DB(db) {
            this._db = db;
        }

        DB.prototype.transaction = function () {
            return new Transaction(this._db.transaction.apply(this._db, arguments));
        };

        proxyProperties(DB, '_db', ['name', 'version', 'objectStoreNames']);

        proxyMethods(DB, '_db', IDBDatabase, ['close']);

        // Add cursor iterators
        ['openCursor', 'openKeyCursor'].forEach(function (funcName) {
            [ObjectStore, Index].forEach(function (Constructor) {
                Constructor.prototype[funcName.replace('open', 'iterate')] = function () {
                    var args = Array.prototype.slice.call(arguments);
                    var callback = args[args.length - 1];
                    var nativeObject = this._store || this._index;
                    var request = nativeObject[funcName].apply(nativeObject, args.slice(0, -1));
                    request.onsuccess = function () {
                        callback(request.result);
                    };
                };
            });
        });

        // polyfill getAll
        [Index, ObjectStore].forEach(function (Constructor) {
            if (Constructor.prototype.getAll) {
                return;
            }
            Constructor.prototype.getAll = function (query, count) {
                var instance = this;
                var items = [];
                return new Promise(function (resolve) {
                    instance.iterateCursor(query, function (cursor) {
                        if (!cursor) {
                            resolve(items);
                            return;
                        }
                        items.push(cursor.value);

                        if (count !== undefined && items.length === count) {
                            resolve(items);
                            return;
                        }
                        cursor["continue"]();
                    });
                });
            };
        });

        var idb = {
            open: function open(name, version, upgradeCallback) {
                var p = promisifyRequestCall(indexedDB, 'open', [name, version]);
                var request = p.request;

                request.onupgradeneeded = function (event) {
                    if (upgradeCallback) {
                        upgradeCallback(new UpgradeDB(request.result, event.oldVersion, request.transaction));
                    }
                };

                return p.then(function (db) {
                    return new DB(db);
                });
            },
            del: function del(name) {
                return promisifyRequestCall(indexedDB, 'deleteDatabase', [name]);
            }
        };

        _this44.dbs = {};

        var _loop4 = function _loop4(db_config) {
            _this44.dbs[db_config.id] = idb.open(db_config.name, db_config.version, function (upgradeDb) {
                return _this44.createObjectStores(upgradeDb, db_config);
            });
        };

        var _iteratorNormalCompletion25 = true;
        var _didIteratorError25 = false;
        var _iteratorError25 = undefined;

        try {
            for (var _iterator25 = Adhara.app.DBConfig[Symbol.iterator](), _step25; !(_iteratorNormalCompletion25 = (_step25 = _iterator25.next()).done); _iteratorNormalCompletion25 = true) {
                var db_config = _step25.value;

                _loop4(db_config);
            }
        } catch (err) {
            _didIteratorError25 = true;
            _iteratorError25 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion25 && _iterator25.return) {
                    _iterator25.return();
                }
            } finally {
                if (_didIteratorError25) {
                    throw _iteratorError25;
                }
            }
        }

        return _this44;
    }

    _createClass(AdharaDBStorage, [{
        key: "createObjectStores",
        value: function createObjectStores(upgradeDb, db_config) {
            try {
                var db_schema = db_config.schema;
                for (var table_name in db_schema) {
                    if (db_schema.hasOwnProperty(table_name)) {
                        if (!upgradeDb.objectStoreNames.contains(table_name)) {
                            //If table doesn't exist already
                            var os = upgradeDb.createObjectStore(table_name, db_schema[table_name]);
                            //indexes = [
                            // // See for more details https://developers.google.com/web/ilt/pwa/working-with-indexeddb#defining_indexes
                            //      {
                            //          name: "title-index",
                            //          property: "title",
                            //          options: {
                            //              unique: true
                            //          }
                            //      }
                            //      {
                            //          name: "gender-index",
                            //          property: "gender",
                            //          options: {
                            //              unique: false
                            //          }
                            //      }
                            // ]
                            var _iteratorNormalCompletion26 = true;
                            var _didIteratorError26 = false;
                            var _iteratorError26 = undefined;

                            try {
                                for (var _iterator26 = db_schema[table_name].indexes[Symbol.iterator](), _step26; !(_iteratorNormalCompletion26 = (_step26 = _iterator26.next()).done); _iteratorNormalCompletion26 = true) {
                                    var index = _step26.value;

                                    os.createIndex(index.name, index.property, index.options);
                                }
                            } catch (err) {
                                _didIteratorError26 = true;
                                _iteratorError26 = err;
                            } finally {
                                try {
                                    if (!_iteratorNormalCompletion26 && _iterator26.return) {
                                        _iterator26.return();
                                    }
                                } finally {
                                    if (_didIteratorError26) {
                                        throw _iteratorError26;
                                    }
                                }
                            }
                        }
                    }
                }
                return true;
            } catch (e) {
                return false;
            }
        }
    }, {
        key: "select",
        value: function select(database_name, dataset_name) {
            return new DBStorageOperator(dataset_name, this.dbs[database_name]);
        }
    }]);

    return AdharaDBStorage;
}(AdharaStorage);

var DBStorageOperator = function (_AdharaStorageOperato) {
    _inherits(DBStorageOperator, _AdharaStorageOperato);

    function DBStorageOperator(dataset, db) {
        _classCallCheck(this, DBStorageOperator);

        var _this45 = _possibleConstructorReturn(this, (DBStorageOperator.__proto__ || Object.getPrototypeOf(DBStorageOperator)).call(this, dataset));

        _this45.db = db;
        return _this45;
    }

    _createClass(DBStorageOperator, [{
        key: "retrieve",
        value: function retrieve(key) {
            var _this46 = this;

            return this.db.then(function (db) {
                return db.transaction(_this46.dataset).objectStore(_this46.dataset).get(key);
            });
        }
    }, {
        key: "store",
        value: function store(key, val) {
            var _this47 = this;

            if (!val) {
                val = key;
                key = undefined;
            }
            return this.db.then(function (db) {
                var tx = db.transaction(_this47.dataset, 'readwrite');
                tx.objectStore(_this47.dataset).put(val, key);
                return tx.complete;
            });
        }
    }, {
        key: "remove",
        value: function remove(key) {
            var _this48 = this;

            return this.db.then(function (db) {
                var tx = db.transaction(_this48.dataset, 'readwrite');
                tx.objectStore(_this48.dataset).delete(key);
                return tx.complete;
            });
        }
    }, {
        key: "removeAll",
        value: function removeAll() {
            var _this49 = this;

            return this.db.then(function (db) {
                var tx = db.transaction(_this49.dataset, 'readwrite');
                tx.objectStore(_this49.dataset).clear();
                return tx.complete;
            });
        }
    }, {
        key: "keys",
        value: function keys() {
            var _this50 = this;

            return this.db.then(function (db) {
                var tx = db.transaction(_this50.dataset);
                var keys = [];
                var store = tx.objectStore(_this50.dataset);
                // This would be store.getAllKeys(), but it isn't supported by Edge or Safari.
                // openKeyCursor isn't supported by Safari, so we fall back
                (store.iterateKeyCursor || store.iterateCursor).call(store, function (cursor) {
                    if (!cursor) return;
                    keys.push(cursor.key);
                    cursor.continue();
                });

                return tx.complete.then(function () {
                    return keys;
                });
            });
        }
    }]);

    return DBStorageOperator;
}(AdharaStorageOperator);
/**------------------------------------------------------------------------------------------------------------------**/


var AdharaCacheStorage = function (_AdharaStorage2) {
    _inherits(AdharaCacheStorage, _AdharaStorage2);

    function AdharaCacheStorage() {
        _classCallCheck(this, AdharaCacheStorage);

        var _this51 = _possibleConstructorReturn(this, (AdharaCacheStorage.__proto__ || Object.getPrototypeOf(AdharaCacheStorage)).call(this));

        _this51.dbs = AdharaCacheStorageOperator.cache;
        var _iteratorNormalCompletion27 = true;
        var _didIteratorError27 = false;
        var _iteratorError27 = undefined;

        try {
            for (var _iterator27 = Adhara.app.DBConfig[Symbol.iterator](), _step27; !(_iteratorNormalCompletion27 = (_step27 = _iterator27.next()).done); _iteratorNormalCompletion27 = true) {
                var db_config = _step27.value;

                if (!_this51.dbs[db_config.id]) {
                    _this51.dbs[db_config.id] = {};
                }
            }
        } catch (err) {
            _didIteratorError27 = true;
            _iteratorError27 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion27 && _iterator27.return) {
                    _iterator27.return();
                }
            } finally {
                if (_didIteratorError27) {
                    throw _iteratorError27;
                }
            }
        }

        return _this51;
    }

    _createClass(AdharaCacheStorage, [{
        key: "select",
        value: function select(database_name, dataset_name) {
            return new AdharaCacheStorageOperator(dataset_name, this.dbs[database_name]);
        }
    }]);

    return AdharaCacheStorage;
}(AdharaStorage);

var AdharaCacheStorageOperator = function (_AdharaStorageOperato2) {
    _inherits(AdharaCacheStorageOperator, _AdharaStorageOperato2);

    function AdharaCacheStorageOperator(dataset, db) {
        _classCallCheck(this, AdharaCacheStorageOperator);

        var _this52 = _possibleConstructorReturn(this, (AdharaCacheStorageOperator.__proto__ || Object.getPrototypeOf(AdharaCacheStorageOperator)).call(this, dataset));

        _this52.db = db;
        return _this52;
    }

    _createClass(AdharaCacheStorageOperator, [{
        key: "store",
        value: function store(key, value) {
            return new Promise(function (resolve, reject) {
                AdharaCacheStorageOperator.cache[key] = value;
                resolve();
            });
        }
    }, {
        key: "retrieve",
        value: function retrieve(key) {
            return new Promise(function (resolve, reject) {
                resolve(AdharaCacheStorageOperator.cache[key]);
            });
        }
    }, {
        key: "remove",
        value: function remove(key) {
            return new Promise(function (resolve, reject) {
                delete AdharaCacheStorageOperator.cache[key];
                resolve();
            });
        }
    }, {
        key: "removeAll",
        value: function removeAll() {
            return new Promise(function (resolve, reject) {
                AdharaCacheStorageOperator.cache = {};
                resolve();
            });
        }
    }, {
        key: "keys",
        value: function keys() {
            return new Promise(function (resolve, reject) {
                resolve(Object.keys(AdharaCacheStorageOperator.cache));
            });
        }
    }]);

    return AdharaCacheStorageOperator;
}(AdharaStorageOperator);

AdharaCacheStorageOperator.cache = {};
/**------------------------------------------------------------------------------------------------------------------**/

var AdharaApp = function () {
    function AdharaApp() {
        _classCallCheck(this, AdharaApp);
    }

    _createClass(AdharaApp, [{
        key: "toast",


        /**
         * @function
         * @instance
         * @param {String} title - toast message title
         * @param {String} content - toast message content
         * @param {String} type - toast message type. can take the values "success"|"error"|"info".
         * */
        value: function toast(title, content, type) {
            return AdharaDefaultToaster.make(title, content, type);
        }
    }, {
        key: "renderTemplate",
        value: function renderTemplate(template, context) {
            return TemplateUtils.execute(template, context);
        }
    }, {
        key: "is_debug_mode",


        /**
         * @function
         * @instance
         * @return {Boolean} Whether the app is being accessed in development mode or in production mode
         * */
        get: function get() {
            return ["localhost", "127.0.0.1", "0.0.0.0"].indexOf(window.location.hostname) !== -1 || window.location.hostname.indexOf("192.168.") !== -1;
        }
    }, {
        key: "dataInterface",
        get: function get() {
            return DataInterface();
        }
    }, {
        key: "d",
        get: function get() {
            if (!this._d) {
                this._d = this.dataInterface;
            }
            return this.dataInterface;
        }

        /**
         * @function
         * @instance
         * @return {String} App name
         * */

    }, {
        key: "name",
        get: function get() {
            return "Adhara App";
        }

        /**
         * @function
         * @instance
         * @return {Object} App name in detail. Like first and last name
         * */

    }, {
        key: "detailedName",
        get: function get() {
            return {
                first: "Adhara",
                last: "App"
            };
        }

        /**
         * @function
         * @instance
         * @return {String} Tag line
         * */

    }, {
        key: "tagLine",
        get: function get() {}

        /**
         * @function
         * @instance
         * @return {AdharaView} Container view class
         * */

    }, {
        key: "containerView",
        get: function get() {}

        /**
         * @getter
         * @instance
         * @returns {Object} Custom global view configurations
         * */

    }, {
        key: "customViewConfig",
        get: function get() {
            return {
                fetching_data: {
                    AdharaListView: "Fetching Data..."
                },
                no_data: {
                    AdharaListView: "No Data Available"
                }
            };
        }

        /**
         * @function
         * @instance
         * @return {AdharaRouterConfiguration} Adhara style routing config
         * */

    }, {
        key: "routerConfiguration",
        get: function get() {
            return {
                routes: [],
                on_route_listeners: {},
                middlewares: []
            };
        }

        /**
         * @function
         * @instance
         * @returns {Object} WebSocket config object.
         * sample...
         * {
         *  url: "sub.domain.com:9081"
         * }
         * */

    }, {
        key: "webSocketConfig",
        get: function get() {}

        /**
         * @getter
         * @instance
         * @returns {Object} DB Configuration which includes DB names and DB Schematics for Client Storage ( for all the object stores )
         * */

    }, {
        key: "DBConfig",
        get: function get() {
            return [{
                id: "default",
                name: "Adhara-app_db",
                version: 1,
                schema: {
                    http_cache: {
                        keyPath: "url"
                    }
                }
            }];
        }
    }, {
        key: "_diConfig",
        get: function get() {
            return Object.assign({
                http_cache_table: "http_cache",
                default_reuse: true,
                reuse_timeout: 5 * 60 * 1000
            }, this.DIConfig);
        }

        /**
         * @getter
         * @instance
         * @returns {Object} Data interface related configuration
         * */

    }, {
        key: "DIConfig",
        get: function get() {
            return {};
        }

        /**
         * @getter
         * @instance
         * @returns {Object<String, Object>} scopes that to be used in the app.
         * @description Map of scopes that can be accessed across the application.
         * Scopes can vary from environment to environment. Like in Node.JS vs in Browser JS.
         * */

    }, {
        key: "scopes",
        get: function get() {
            return {
                global: window // the global scope
            };
        }
    }, {
        key: "i18n_key_map",
        get: function get() {
            return {
                "list_view.navigation.previous": "Previous",
                "list_view.navigation.next": "Next",
                "form.processing": "Processing...",
                "common.yes": "Yes",
                "common.no": "No"
            };
        }
    }]);

    return AdharaApp;
}();

/**------------------------------------------------------------------------------------------------------------------**/
/**
 * @class
 * @classdesc a class that handles everything related to the website
 * */


var Adhara = null;

(function () {
    var AdharaBase = function () {
        function AdharaBase() {
            _classCallCheck(this, AdharaBase);

            this.container = null;
            this.always_active_views = [];
            this.active_views = [];
            this.router = AdharaRouter;
            this.toast = Toast;
        }

        _createClass(AdharaBase, [{
            key: "init",
            value: function init(app) {
                callOnInitListeners();
                if (app) {
                    this.app = new app();
                    this.i18n = new Internationalize(Adhara.app.i18n_key_map);
                    this.createShortcuts();
                    this.performSystemChecks();
                    this.createContainer();
                    if (this.app.webSocketConfig) {
                        WebSocket.listen(this.app.webSocketConfig);
                    }
                } else {
                    this.router.route();
                }
            }
        }, {
            key: "createShortcuts",
            value: function createShortcuts() {
                //  handle create shortcuts
            }
        }, {
            key: "performSystemChecks",
            value: function performSystemChecks() {
                /*// verify the controller for if it has support for all the API methods (for ease of Dev)
                for(let i = 0; i < Adhara.app.allowedHttpMethods.length; i++){
                    if(typeof Controller[Adhara.app.allowedHttpMethods[i] + "Data"] !== 'function'){
                        throw new Error(Adhara.app.allowedHttpMethods[i] + " api method is not registered with the controller!");
                    }
                }*/
            }
        }, {
            key: "createContainer",
            value: function createContainer() {
                var _this53 = this;

                this.router.configure(this.app.routerConfiguration);
                this.router.listen();
                var containerView = this.app.containerView;
                if (containerView) {
                    this.container = containerView;
                    this.container.onViewRendered(this.router.route);
                    this._clearActiveViews();
                    //TODO Adhara.getView is not valid function anymore...
                    this.always_active_views = this.container.subViews.map(function (subView) {
                        return Adhara.getView(subView, _this53.container);
                    });
                    this.container.create();
                    this.always_active_views.push(this.container);
                } else {
                    this._clearActiveViews();
                    this.router.route();
                }
            }
        }, {
            key: "addToActiveViews",
            value: function addToActiveViews(viewInstance) {
                if (!this.isActiveView(viewInstance)) {
                    if (viewInstance.isImmortal) {
                        this.always_active_views.push(viewInstance);
                    } else {
                        this.active_views.push(viewInstance);
                    }
                }
            }
        }, {
            key: "getActiveView",
            value: function getActiveView(classReference) {
                var active_view = this.active_views.filter(function (view_instance) {
                    return view_instance.constructor === classReference;
                })[0];
                if (!active_view) {
                    active_view = this.always_active_views.filter(function (view_instance) {
                        return view_instance.constructor === classReference;
                    })[0];
                }
                return active_view;
            }
        }, {
            key: "isActiveView",
            value: function isActiveView(viewInstance) {
                return this.active_views.indexOf(viewInstance) !== -1 || this.always_active_views.indexOf(viewInstance) !== -1;
            }
        }, {
            key: "_clearActiveViews",
            value: function _clearActiveViews() {
                this.active_views = [];
            }
        }, {
            key: "closeActiveViews",
            value: function closeActiveViews() {
                var _iteratorNormalCompletion28 = true;
                var _didIteratorError28 = false;
                var _iteratorError28 = undefined;

                try {
                    for (var _iterator28 = this.active_views[Symbol.iterator](), _step28; !(_iteratorNormalCompletion28 = (_step28 = _iterator28.next()).done); _iteratorNormalCompletion28 = true) {
                        var active_view = _step28.value;

                        active_view.destroy();
                    }
                } catch (err) {
                    _didIteratorError28 = true;
                    _iteratorError28 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion28 && _iterator28.return) {
                            _iterator28.return();
                        }
                    } finally {
                        if (_didIteratorError28) {
                            throw _iteratorError28;
                        }
                    }
                }

                this._clearActiveViews();
            }
        }, {
            key: "templateEngine",
            get: function get() {
                return {
                    name: "Handlebars",
                    helpersHandler: TemplateEngineHelpers
                };
            }
        }, {
            key: "viewHierarchy",
            get: function get() {
                return [AdharaAppContainerView, AdharaDialogView, AdharaTemplateView, AdharaCardView, AdharaGridView, AdharaListView, AdharaFormView, AdharaView];
            }
        }]);

        return AdharaBase;
    }();

    Adhara = new AdharaBase();

    //View class handling
    var view_instances = {};

    //Single ton views
    Adhara.addViewToInstances = function (instance) {
        view_instances[instance.constructor.name] = instance;
    };

    // //Query singleton views
    Adhara.getView = function (viewClass, parentViewInstance) {
        if (!viewClass) {
            throw new Error("invalid view class");
        }
        var active_view = Adhara.getActiveView(viewClass instanceof Function ? viewClass : viewClass.constructor);
        if (active_view) {
            return active_view;
        } else if (parentViewInstance) {
            return viewClass;
            // return new viewClass(parentViewInstance);
        } else {
            throw new Error("parent view is required to construct a view. Failed to create view: " + viewClass.constructor.name);
        }
    };

    //Create a view instance
    Adhara.createView = function (adhara_view_instance, parentViewInstance) {
        adhara_view_instance.create(parentViewInstance);
        return adhara_view_instance;
    };

    //On route listener
    Adhara.onRoute = function (view) {
        Adhara.closeActiveViews();
        if (!Adhara.container.isActive()) {
            return Adhara.container.create();
        }
        view.parentContainer = Adhara.container.contentContainer;
        Adhara.createView(view, Adhara.container);
    };

    var on_init_listeners = [registerAdharaUtils];

    Adhara.onInit = function (fn) {
        on_init_listeners.push(fn);
    };

    Adhara.lightReload = function () {
        Adhara.container ? Adhara.container.refresh() : Adhara.router.route();
    };

    function callOnInitListeners() {
        var _iteratorNormalCompletion29 = true;
        var _didIteratorError29 = false;
        var _iteratorError29 = undefined;

        try {
            for (var _iterator29 = on_init_listeners[Symbol.iterator](), _step29; !(_iteratorNormalCompletion29 = (_step29 = _iterator29.next()).done); _iteratorNormalCompletion29 = true) {
                var on_init_listener = _step29.value;

                on_init_listener();
            }
        } catch (err) {
            _didIteratorError29 = true;
            _iteratorError29 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion29 && _iterator29.return) {
                    _iterator29.return();
                }
            } finally {
                if (_didIteratorError29) {
                    throw _iteratorError29;
                }
            }
        }
    }
})();
//# sourceMappingURL=adhara.combined.es5.js.map
